<?php

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  Script: Maian Uploader v4.0
  Written by: David Ian Bennett
  E-Mail: support@maianscriptworld.co.uk
  Website: http://www.maianscriptworld.co.uk

  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  
  This File: class_csvdump.inc.php
  Description: Creates CSV Files

  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

class csvDump extends genericOptions {

                                      var $prefix;
                                      var $fields = array();
                                      var $sql;
                                      
                                      //=========================================================
                                      // FUNCTION: define_newline()
                                      // Desc: Define EOL character according to target OS
                                      // Parameters: 0
                                      //=========================================================
                                      
                                      function define_newline()
                                      {
                                        $unewline = "\r\n";

                                        if (strstr(strtolower($_SERVER["HTTP_USER_AGENT"]), 'win')) {
                                          $unewline = "\r\n";
                                        }
                                        else if (strstr(strtolower($_SERVER["HTTP_USER_AGENT"]), 'mac')) {
                                          $unewline = "\r";
                                        } else {
                                          $unewline = "\n";
                                        }

                                        return $unewline;
                                      }
                                      
                                      //=============================================================
                                      // FUNCTION: check_csv()
                                      // Desc: Data found with comma needs to be enclosed in quotes
                                      // Parameters: 1
                                      //=============================================================
                                      
                                      function check_csv($data)
                                      {
                                        return (strstr($data, ",") ? '"'.$data.'"' : $data);
                                      }

                                      //=========================================================
                                      // FUNCTION: generate_csv()
                                      // Desc: Generates a CSV File from an SQL String
                                      // (and outputs it to the browser)
                                      // Parameters: 0
                                      //=========================================================

                                      function generate_csv()
                                      {
                                        $query = mysql_query("SELECT * FROM ".$this->prefix."members
                                                              $this->sql
                                                              ") or die(mysql_error());

                                        //Build field names array
                                           
                                        $field_array = array();
                                        
                                        if (in_array('id', $this->fields)) {
                                          $field_array[] = 'id';
                                        }
                                        if (in_array('sign_date', $this->fields)) {
                                          $field_array[] = 'sign_date';
                                        }
                                        if (in_array('username', $this->fields)) {
                                          $field_array[] = 'username';
                                        }
                                        if (in_array('email', $this->fields)) {
                                          $field_array[] = 'email';
                                        }
                                        if (in_array('ip', $this->fields)) {
                                          $field_array[] = 'ip';
                                        }
                                        if (in_array('field_name', $this->fields)) {
                                          $field_array[] = 'field_name';
                                        }
                                        if (in_array('field_company', $this->fields)) {
                                          $field_array[] = 'field_company';
                                        }
                                        if (in_array('field_address', $this->fields)) {
                                          $field_array[] = 'field_address';
                                        }
                                        if (in_array('field_tel', $this->fields)) {
                                          $field_array[] = 'field_tel';
                                        }
                                        if (in_array('field_fax', $this->fields)) {
                                          $field_array[] = 'field_fax';
                                        }
                                        if (in_array('field_mobile', $this->fields)) {
                                          $field_array[] = 'field_mobile';
                                        }
                                        if (in_array('field_location', $this->fields)) {
                                          $field_array[] = 'field_location';
                                        }
                                           
                                        $DATA_ONE = implode(",", $field_array);
                                           
                                        $csv_field = $DATA_ONE.$this->define_newline();
                                           
                                        //Now build data string
                                        $data_string = '';

                                        while ($row = mysql_fetch_array($query))
                                        {
                                          if (in_array('id', $this->fields)) {
                                            $data_string .= $row['id'].',';
                                          }
                                          if (in_array('sign_date', $this->fields)) {
                                            $data_string .= $this->check_csv($row['sign_date']).',';
                                          }
                                          if (in_array('username', $this->fields)) {
                                            $data_string .= $this->check_csv($this->char_back($this->strip_slashes($row['username']))).',';
                                          }
                                          if (in_array('email', $this->fields)) {
                                            $data_string .= $row['email'].',';
                                          }
                                          if (in_array('ip', $this->fields) && $row['ip']) {
                                            $data_string .= $row['ip'].',';
                                          }
                                          if (in_array('field_name', $this->fields)) {
                                            $data_string .= $this->check_csv($this->char_back($this->strip_slashes($row['field_name']))).',';
                                          }
                                          if (in_array('field_company', $this->fields)) {
                                            $data_string .= $this->check_csv($this->char_back($this->strip_slashes($row['field_company']))).',';
                                          }
                                          if (in_array('field_address', $this->fields)) {
                                            $data_string .= $this->check_csv($this->char_back($this->strip_slashes($row['field_address']))).',';
                                          }
                                          if (in_array('field_tel', $this->fields)) {
                                            $data_string .= $row['field_tel'].',';
                                          }
                                          if (in_array('field_fax', $this->fields)) {
                                            $data_string .= $row['field_fax'].',';
                                          }
                                          if (in_array('field_mobile', $this->fields)) {
                                            $data_string .= $row['field_mobile'].',';
                                          }
                                          if (in_array('field_location', $this->fields)) {
                                            $data_string .= $this->check_csv($this->char_back($this->strip_slashes($row['field_location']))).',';
                                          }
                                                
                                          $data_string = substr($data_string,0,-1);

                                          $data_string .= $this->define_newline();
                                        }

                                        return trim($csv_field.$data_string);
                                      }

                                      //=========================================================
                                      // FUNCTION: dump()
                                      // Desc: Generate the CSV File and send it to browser 
                                      //  or download it as a file
                                      // Parameters: 0
                                      //=========================================================

                                      function dump()
                                      {
                                        $CSV       = $this->generate_csv();
                                        $filename  = 'backup/csv_dump.csv';
                                           
                                        if (is_writeable('backup/'))
                                        {
                                          $fp = fopen($filename, 'ab');

                                          if ($fp) {
                                            fwrite($fp,$CSV);
                                            fclose($fp);
                                          }
                                        }
                                           
                                        unset($CSV);

                                        if(ini_get('zlib.output_compression')) {
                                          ini_set('zlib.output_compression', 'Off');
                                        }
                                           
                                        header('Last-Modified: '.gmdate('D, d M Y H:i:s').' GMT');
                                        header('Pragma: public');
		                                    header('Expires: 0');
		                                    header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
		                                    header('Cache-Control: private',false);
		                                    header('Content-Type: '.$this->get_mime_type());
		                                    header('Content-Disposition: attachment; filename='.$filename.';');
		                                    header('Content-Transfer-Encoding: binary');
		                                    header('Content-Length: '.filesize($filename));
		                           
                                        readfile($filename);

                                        if (file_exists($filename)) {
                                          unlink($filename);
                                          unset($filename);
                                        }
                                      }
}

?>
