<?php

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  Script: Maian Uploader v4.0
  Written by: David Ian Bennett
  E-Mail: support@maianscriptworld.co.uk
  Website: http://www.maianscriptworld.co.uk

  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  
  This File: index.php
  Description: Main Parsing File (Admin)

  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

session_start();

error_reporting(E_ALL ^ E_NOTICE);
set_magic_quotes_runtime(0);
define('FOLDER_PATH',dirname(__FILE__).'/');
define('PARENT',1);
define('RELATIVE_PATH','../');

// Database connection..
include(RELATIVE_PATH.'inc/db_connection.inc.php');
 
// Load settings..
$SETTINGS = mysql_fetch_object(mysql_query("SELECT *,UNIX_TIMESTAMP(dateStamp) AS prog_date 
                                            FROM ".$database['prefix']."settings 
                                            LIMIT 1")) or die(mysql_error());                                            
 
// Load include files..
include(RELATIVE_PATH.'lang/'.$SETTINGS->language);
include(FOLDER_PATH.'inc/functions.php');
include(RELATIVE_PATH.'inc/functions.php');
include(RELATIVE_PATH.'classes/class_generic.inc.php');
include(FOLDER_PATH.'classes/PaginateIt.php');
include(FOLDER_PATH.'classes/class_mail.inc.php');
 
//========================================================================================================
// DEFINED VARIABLES
//========================================================================================================
//
// INCLUDE_FILES          = Makes sure data files are being called from parent file. Do not alter this.
// BANNER_DISPLAY_WIDTH   = Banner display width for banners when shown in list.
// BANNER_DISPLAY_HEIGHT  = Banner display height for banners when shown in list
// MAX_UPLOADS            = This is the maximum uploads drop down. Shows 1-20. Alter to suit.
// UPLOAD_FIELDS          = Upload fields for admin to upload files to visitor increase.
//                          update the offset. ie: +1 hours = Time + 1 hour, -1 hours = Time - 1 hour
// REDIRECT_MESSAGE       = Displays success box if action is ok.
//                          1 = Show, 0 = No Show
// MGBS                   = A megabyte in bytes. Never needs altering. 
//
//=======================================================================================================

define('INCLUDE_FILES', 1);
define('BANNER_DISPLAY_WIDTH', 175);
define('BANNER_DISPLAY_HEIGHT', 40);
define('MAX_UPLOADS', '1-20');
define('UPLOAD_FIELDS', 8);
define('REDIRECT_MESSAGE', 1);
define('MGBS','1048576');
define('NAME_CHARS_TO_DISPLAY',60);
define('NAME_CHARS_TO_DISPLAY_GREYBOX',100);
define('NAME_CHARS_TO_DISPLAY_UPLOAD',80);
define('CODEGEN_WINDOW_SIZE', '200, 100');
define('MP3_WINDOW_SIZE', '310, 70');
define('FLV_WINDOW_SIZE', '450, 380');
define('NAME_LENGTH',100);

// Default vars..
$cmd           = (isset($_GET['cmd']) ? strip_tags($_GET['cmd']) : 'home');
$page          = (isset($_GET['page']) ? strip_tags($_GET['page']) : '1');
$error_string  = array();
$count         = 0;
$limit         = $SETTINGS->data_per_page;
$limitvalue    = $page * $limit - ($limit);
$title         = $msg_header5;
 
// Create class instances..
$MUP_MAIL      = new mailClass();
 
// Default mail/account variables..
$MUP_MAIL->smtp_host  = $SETTINGS->smtp_host;
$MUP_MAIL->smtp_port  = $SETTINGS->smtp_port;
$MUP_MAIL->smtp_user  = $SETTINGS->smtp_user;
$MUP_MAIL->smtp_pass  = $SETTINGS->smtp_pass;
$MUP_MAIL->smtp       = $SETTINGS->smtp;
$MUP_MAIL->addTag('{WEBSITE_NAME}',$SETTINGS->webname);
$MUP_MAIL->addTag('{WEBSITE_URL}',$SETTINGS->url);
$MUP_MAIL->addTag('{WEBSITE_EMAIL}',$SETTINGS->email);

// Main switch..
switch ($cmd)
{
  /*+++++++++++++++++++++++++
    + CASE: HOME            +
    + Administration Home   +
    +++++++++++++++++++++++++*/

  case "home":
      
  isWebmasterLoggedIn();
      
  // Check for installation directory..
  if (file_exists('../install/')) {
    $INSTALL_DIR = true;
  }

  include(FOLDER_PATH.'inc/header.php');
  include(FOLDER_PATH.'data_files/home.php');
  include(FOLDER_PATH.'inc/footer.php');
  break;
      
  /*+++++++++++++++++++++++++
    + CASE: SETTINGS        +
    + Program Settings      +
    +++++++++++++++++++++++++*/

  case "settings":
  
  $title = $msg_header6;
      
  isWebmasterLoggedIn();
      
  // Reload based on tab selection..
  if (isset($_GET['tab'])) {
    toggleTab($_GET['tab'],'settings');
  }    
      
  // Update Settings..
  if (isset($_POST['process']))
  {
    // Apply call back element to trim post vars..
    $_POST = array_map('trim',$_POST);
    
    include(FOLDER_PATH.'classes/class_settings.inc.php');
                
    $MUP_SETTINGS          = new settings();
    $MUP_SETTINGS->prefix  = $database['prefix'];
                
    switch ($_POST['area'])
    {
      case 'main':
      
      $MUP_SETTINGS->update_settings($_POST);

      if ($MUP_SETTINGS->rename_dir(RELATIVE_PATH,$SETTINGS->uploaddir,$_POST['uploaddir']))
      {
        updated($msg_settings26,
                'index.php?cmd=settings',
                $msg_script10,
                $msg_script9,
                $msg_charset
                );
      } else {
        $error_string[] = $msg_settings28;

        error($msg_script12,
              $msg_script11,
              $msg_charset,
              $error_string
              );
      }
      
      break;
      
      case 'pages':
      
      $MUP_SETTINGS->update_pages($_POST);
      
      updated($msg_settings25,
              'index.php?cmd=settings',
              $msg_script10,
              $msg_script9,
              $msg_charset
              );
      
      break;
      
      case 'smtp':
      
      $MUP_SETTINGS->update_smtp($_POST);
      
      updated($msg_settings24,
              'index.php?cmd=settings',
              $msg_script10,
              $msg_script9,
              $msg_charset
              );
      
      break;
    }            
  }
  
  include(FOLDER_PATH.'inc/header.php');
  include(FOLDER_PATH.'data_files/settings.php');
  include(FOLDER_PATH.'inc/footer.php');
  break;
      
  /*+++++++++++++++++++++++++
    + CASE: TERMS           +
    + Terms and Conditions  +
    +++++++++++++++++++++++++*/

  case "terms":
  
  $title = $msg_header48;
      
  isWebmasterLoggedIn();
  
  if (isset($_POST['process']))
  {
    include(FOLDER_PATH.'classes/class_settings.inc.php');
                
    $MUP_SETTINGS          = new settings();
    $MUP_SETTINGS->prefix  = $database['prefix'];
    
    $MUP_SETTINGS->update_terms($_POST);
    
    updated($msg_terms3,
            'index.php?cmd=terms',
            $msg_script10,
            $msg_script9,
            $msg_charset
            );
  }
  
  include(FOLDER_PATH.'inc/header.php');
  include(FOLDER_PATH.'data_files/terms.php');
  include(FOLDER_PATH.'inc/footer.php');
  
  break;
  
  /*++++++++++++++++++++++++++
    + CASE: BANNERS          +
    + Banner Rotation System +
    ++++++++++++++++++++++++++*/

  case "banners":
  
  $title = $msg_header7;
      
  isWebmasterLoggedIn();
      
  // Reload based on tab selection..
  if (isset($_GET['tab'])) {
    toggleTab($_GET['tab'],'banners');
  }
      
  //Process banners...
  if (isset($_POST['process']))
  {
    if (!empty($_POST['banner_id']) && $_POST['options']!='0')
    {
      $file_id   = array();
      $file_img  = array();

      for ($i=0; $i<count($_POST['banner_id']); $i++) {
        $data       = explode("-", $_POST['banner_id'][$i]);
        $file_id[]  = $data[0];
        $file_img[] = $data[1];
      }
                
      switch ($_POST['options'])
      {
        case "reset":
                     
        mysql_query("UPDATE ".$database['prefix']."banners SET 
                     b_clicks = '0' 
                     WHERE id IN (".implode(",",$file_id).")
                     ") or die(mysql_error());

        updated($msg_banners22,
                'index.php?cmd=banners',
                count($_POST['banner_id'])." ".$msg_banners23."<br><br>".$msg_script10,
                $msg_script9,
                $msg_charset
                );

        break;
                     
        case "delete":
                     
        mysql_query("DELETE FROM ".$database['prefix']."banners 
                     WHERE id IN (".implode(",",$file_id).")
                     ") or die(mysql_error());
                     
        if ($file_img)
        {
          foreach ($file_img AS $image) {
            if (file_exists(RELATIVE_PATH.'images/banners/'.$image)) {
              unlink(RELATIVE_PATH.'images/banners/'.$image);
            }
          }
        }
                     
        updated($msg_banners20,
                'index.php?cmd=banners',
                count($_POST['banner_id'])." ".$msg_banners21."<br><br>".$msg_script10,
                $msg_script9,
                $msg_charset
                );

        break;
      }
    }
    else
    {
      header("Location: index.php?cmd=banners");
      exit;
    }
  }
    
  //Load edit screen..
  if (isset($_GET['code']) && $_GET['code']=="edit") {
    toggleTab('add','banners','id='.$_GET['id']);
  }

  // Update Banner..
  if (isset($_POST['edit']))
  {
    // Apply call back element to trim post vars..
    $_POST = array_map('trim',$_POST);
           
    include(FOLDER_PATH.'classes/class_banners.inc.php');

    $MUP_BANNER          = new banners();
    $MUP_BANNER->prefix  = $database['prefix'];
    
    if (!isset($_POST['b_google']))
    {
      if ($MUP_BANNER->field_check(0,75, $_POST['b_name'])) {
        $count++;
      }
      if ($MUP_BANNER->field_check(0,0,$_POST['b_url'])) {
        $count++;
      }
    }
    if ($count>0)
    {
      error($msg_script12,
            $msg_script11,
            $msg_charset,
            $error_string
            );
    }
    else
    {
      $MUP_BANNER->edit_banner($_POST);

      updated($msg_banners19,
              'index.php?cmd=banners&amp;code=edit&amp;id='.$_POST['id'],
              $msg_script10,
              $msg_script9,
              $msg_charset
              );
    }
  }

  // Add New Banner..
  if (isset($_POST['add']))
  {
    // Apply call back element to trim post vars..
    $_POST = array_map('trim',$_POST);
    
    include(FOLDER_PATH.'classes/class_banners.inc.php');
           
    $MUP_BANNER          = new banners();
    $MUP_BANNER->prefix  = $database['prefix'];
    
    if ($_POST['b_google']=='')
    {
      if ($MUP_BANNER->field_check(0,75, $_POST['b_name'])) {
        $error_string[] = $msg_banners8;
      }
      if ($MUP_BANNER->field_check(0,0,$_FILES['b_file']['tmp_name'])) {
        $error_string[] = $msg_banners9;
      }
      if ($MUP_BANNER->field_check(0,0,$_POST['b_url'])) {
        $error_string[] = $msg_banners10;
      }
    }
    if (!empty($error_string))
    {
      error($msg_script12,
            $msg_script11,
            $msg_charset,
            $error_string
            );
    }
    else
    {
      if (!$_POST['b_google'])
      {
        if ($MUP_BANNER->file_upload(RELATIVE_PATH,$_FILES['b_file']['tmp_name'],$_FILES['b_file']['name']))
        {
          $MUP_BANNER->add_banner($_POST,$_FILES['b_file']['name']);

          updated($msg_banners11,
                  'index.php?cmd=banners',
                  $msg_script10,
                  $msg_script9,
                  $msg_charset
                  );
        } else {
          error($msg_script12,
                $msg_script11,
                $msg_charset,
                array($msg_banners12)
                );
        } 
      } else {
      
        $MUP_BANNER->add_banner($_POST,$_FILES['b_file']['name']);

        updated($msg_banners11,
                'index.php?cmd=banners',
                $msg_script10,
                $msg_script9,
                $msg_charset
                );
      
      }
    }
  }
      
  // View Full Size Banner..
  if (isset($_GET['code']) && $_GET['code']=="view") {
    include(FOLDER_PATH.'data_files/popup/viewbanner.php');
    exit;
  }
      
  include(FOLDER_PATH.'inc/header.php');
  include(FOLDER_PATH.'data_files/banners.php');
  include(FOLDER_PATH.'inc/footer.php');
  break;

  /*+++++++++++++++++++++++++
    + CASE: BANIP           +
    + Ban IP Addresses      +
    +++++++++++++++++++++++++*/

  case "banip":
  
  $title = $msg_header8;
      
  isWebmasterLoggedIn();
  
  // Reload based on tab selection..
  if (isset($_GET['tab'])) {
    toggleTab($_GET['tab'],'banip');
  }

  // Delete IP Address..
  if (isset($_POST['delete']))
  {
    $ip_id = (isset($_POST['ip_id']) ? $_POST['ip_id'] : '');

    if (!empty($ip_id))
    {
      mysql_query("DELETE FROM ".$database['prefix']."ipaddresses 
                   WHERE id IN (".implode(",", $ip_id).")") or die(mysql_error());

      updated($msg_banip9,
              'index.php?cmd=banip',
              $msg_script10,
              $msg_script9,
              $msg_charset
              );
    }
    else
    {
      header("Location: index.php?cmd=banip");
    }
  }

  // Ban IP Address
  if (isset($_POST['process']))
  {
    include(FOLDER_PATH.'classes/class_banip.inc.php');
           
    $MUP_IP          = new ipBanner();
    $MUP_IP->prefix  = $database['prefix'];
    
    if ($MUP_IP->field_check(0,30,trim($_POST['ip'])))
    {
      error($msg_script12,
            $msg_script11,
            $msg_charset,
            array($msg_banip4)
            );
    }
    else
    {
      if ($MUP_IP->ban_ip($_POST['ip']))
      {
        updated($msg_banip5,
                'index.php?cmd=banip',
                $msg_script10,
                $msg_script9,
                $msg_charset
                );
      } else {
        
        error($msg_script12,
              $msg_script11,
              $msg_charset,
              array($msg_banip11)
              );
      }
    }
  }

  include(FOLDER_PATH.'inc/header.php');
  include(FOLDER_PATH.'data_files/banip.php');
  include(FOLDER_PATH.'inc/footer.php');
  break;
      
  /*+++++++++++++++++++++++++
    + CASE: IMGOPTIONS      +
    + Image Options         +
    +++++++++++++++++++++++++*/

  case "imgoptions":
  
  $title = $msg_header9;
      
  isWebmasterLoggedIn();
      
  // View RGB Converter..
  if (isset($_GET['form']) && $_GET['form']=="rgb") {
    include(FOLDER_PATH.'data_files/popup/rgbcoverter.php');
    exit;
  }
      
  // View Sample Watermark..
  if (isset($_GET['form']) && $_GET['form']=="viewsample")
  {
    if ($SETTINGS->watermarks)
    {
      include(FOLDER_PATH.'classes/class_watermarker.inc.php');

      $MUP_MARK                 = new waterMarker();
      $MUP_MARK->waterMarkText  = $MUP_MARK->char_back($MUP_MARK->strip_slashes($SETTINGS->watertext));
      $MUP_MARK->imagePath      = 'images/watermark/wmtestpic.jpg';
      $MUP_MARK->font           = RELATIVE_PATH.'classes/fonts/'.$SETTINGS->waterfont.'.ttf';
      $MUP_MARK->size           = $SETTINGS->watersize;
      $MUP_MARK->red            = $SETTINGS->watertextr;
      $MUP_MARK->green          = $SETTINGS->watertextg;
      $MUP_MARK->blue           = $SETTINGS->watertextb;
      $MUP_MARK->hSpacing       = $SETTINGS->waterhspace;
      $MUP_MARK->vSpacing       = $SETTINGS->watervspace;
      $MUP_MARK->angle          = $SETTINGS->waterangle;

      header("Content-type: image/jpeg");
                
      $MUP_MARK->mark();

      echo $MUP_MARK->imageResource;
      exit;
    } else {
      header('Content-Type: image/jpeg');
      header('Content-Disposition: inline; filename=images/watermark/wmtestpic.jpg');
      readfile('images/watermark/wmtestpic.jpg');
      exit;
    }
  }
      
  // Update Image Options..
  if (isset($_POST['process']))
  {
    // Apply call back element to trim post vars..
    $_POST = array_map('trim',$_POST);
    
    include(FOLDER_PATH.'classes/class_settings.inc.php');
           
    $MUP_IMG          = new settings();
    $MUP_IMG->prefix  = $database['prefix'];
    
    if ($MUP_IMG->field_numeric($_POST['img_width'])) {
      $error_string[] = $msg_imgoptions9;
    }
    if ($MUP_IMG->field_numeric($_POST['img_height'])) {
      $error_string[] = $msg_imgoptions10;
    }
    if ($MUP_IMG->field_numeric($_POST['res_width'])) {
      $error_string[] = $msg_imgoptions11;
    }
    if ($MUP_IMG->field_numeric($_POST['res_height'])) {
      $error_string[] = $msg_imgoptions12;
    }
    if ($_POST['watermarks']) {
      if ($MUP_IMG->field_check(0,50,$_POST['watertext'])) {
        $error_string[] = $msg_imgoptions13;
      }
      if ($MUP_IMG->field_numeric($_POST['img_vspace']) || $MUP_IMG->field_numeric($_POST['img_hspace'])) {
        $error_string[] = $msg_imgoptions23;
      }
      if ($MUP_IMG->field_numeric($_POST['img_textr']) || $MUP_IMG->field_numeric($_POST['img_textg']) || $MUP_IMG->field_numeric($_POST['img_textb'])) {
        $error_string[] = $msg_imgoptions24;
      }
    }
    if (!empty($error_string)) {
      error($msg_script12,
            $msg_script11,
            $msg_charset,
            $error_string
            );
    } else {
      $MUP_IMG->update_imgoptions($_POST);
                
      updated($msg_imgoptions14,
              'index.php?cmd=imgoptions',
              $msg_script10,
              $msg_script9,
              $msg_charset
              );
    }
  }

  include(FOLDER_PATH.'inc/header.php');
  include(FOLDER_PATH.'data_files/imgoptions.php');
  include(FOLDER_PATH.'inc/footer.php');
  break;
      
  /*+++++++++++++++++++++++++
    + CASE: ACCTYPES        +
    + Account Types         +
    +++++++++++++++++++++++++*/

  case "acctypes":
  
  $title = $msg_header10;
      
  isWebmasterLoggedIn();
  
  // Reload based on tab selection..
  if (isset($_GET['tab'])) {
    toggleTab($_GET['tab'],'acctypes');
  }
      
  // Load Edit Mode
  if (isset($_GET['code']) && $_GET['code']=="edit") {
    toggleTab('add','acctypes','id='.$_GET['id']);
  }
      
  // Delete Account Type..
  if (isset($_POST['process']))
  {
    $acc_id = (isset($_POST['acc_id']) ? $_POST['acc_id'] : '');

    if (!empty($acc_id)) {
      mysql_query("DELETE FROM ".$database['prefix']."acctypes 
                   WHERE id IN (".implode(",", $acc_id).")
                   ") or die(mysql_error());
                   
      mysql_query("DELETE FROM ".$database['prefix']."members 
                   WHERE accid IN (".implode(",", $acc_id).")
                   ") or die(mysql_error());             

      updated($msg_acctypes35,
              'index.php?cmd=acctypes',
              $msg_script10,
              $msg_script9,
              $msg_charset
              );
    }
    else
    {
      header("Location: index.php?cmd=acctypes");
    }
  }
      
  // Update Account Type
  if (isset($_POST['edit']))
  {
    include(FOLDER_PATH.'classes/class_acctypes.inc.php');
           
    $MUP_ATYPE          = new accType();
    $MUP_ATYPE->prefix  = $database['prefix'];
    
    if ($MUP_ATYPE->field_check(0,50,$_POST['name'])) {
      $error_string[] = $msg_acctypes23;
    }
    if ($MUP_ATYPE->field_numeric($_POST['max_size'])){
      $error_string[] = $msg_acctypes24;
    }
    if ($MUP_ATYPE->field_numeric($_POST['storage'])) {
      $error_string[] = $msg_acctypes24;
    }
    if (!empty($error_string))
    {
      error($msg_script12,
            $msg_script11,
            $msg_charset,
            $error_string
            );
    }
    else
    {
      $MUP_ATYPE->update_acc_type($_POST);
                
      if (isset($_POST['process_accounts']) && $_POST['process_accounts']=="yes") {
        $acc_count = $MUP_ATYPE->update_user_accounts($_POST);
      }

      updated($msg_acctypes34,
              'index.php?cmd=acctypes&amp;id='.$_POST['id'],
              (isset($acc_count) && $acc_count>0 ? $acc_count.' '.$msg_acctypes37.'<br><br>' : '').$msg_script10,
              $msg_script9,
              $msg_charset
              );
    }
  }

  // Add Account Type..
  if (isset($_POST['add']))
  {
    // Apply call back element to trim post vars..
    $_POST = array_map('trim',$_POST);
    
    include(FOLDER_PATH.'classes/class_acctypes.inc.php');
           
    $MUP_ATYPE          = new accType();
    $MUP_ATYPE->prefix  = $database['prefix'];
    
    if ($MUP_ATYPE->field_check(0,15,$_POST['name'])) {
      $error_string[] = $msg_acctypes23;
    }
    if ($MUP_ATYPE->field_numeric($_POST['max_size'])) {
      $error_string[] = $msg_acctypes24;
    }
    if ($MUP_ATYPE->field_numeric($_POST['storage'])) {
      $error_string[] = $msg_acctypes24;
    }
    if (!empty($error_string))
    {
      error($msg_script12,
            $msg_script11,
            $msg_charset,
            $error_string
            );
    }
    else
    {  
      $MUP_ATYPE->add_acc_type($_POST);

      updated($msg_acctypes26,
              'index.php?cmd=acctypes',
              $msg_script10,
              $msg_script9,
              $msg_charset
              );
    }
  }

  include(FOLDER_PATH.'inc/header.php');
  include(FOLDER_PATH.'data_files/acctypes.php');
  include(FOLDER_PATH.'inc/footer.php');
  break;
      
  /*+++++++++++++++++++++++++
    + CASE: CREATE          +
    + Create New Account    +
    +++++++++++++++++++++++++*/

  case "create":
  
  $title = $msg_header11;
      
  isWebmasterLoggedIn();
      
  // Create Account..
  if (isset($_POST['process']))
  {
    $send  = (isset($_POST['send']) ? $_POST['send'] : 0);

    include(FOLDER_PATH.'classes/class_accounts.inc.php'); 

    $MUP_CREATE          = new accounts();
    $MUP_CREATE->prefix  = $database['prefix'];
    $MUP_CREATE->date    = date($SETTINGS->dateformat, strtotime(($SETTINGS->time_offset=='0' ? "+0 hours" : $SETTINGS->time_offset)));
    $UNIQUEID            = $MUP_CREATE->random_data(20,'unicode');
    $MUP_CREATE->code    = $UNIQUEID;
           
    if ($MUP_CREATE->field_check(5,15,$_POST['username']) || $MUP_CREATE->is_alpha($_POST['username'],15)) {
      $error_string[] = $msg_usercreate8;
    }
    if ($MUP_CREATE->is_user_unique($_POST['username'])) {
      $error_string[] = $msg_usercreate14;
    }
    if ($MUP_CREATE->is_email_unique($_POST['email'])) {
      $error_string[] = $msg_usercreate15;
    }
    if ($MUP_CREATE->is_email_valid($_POST['email'])) {
      $error_string[] = $msg_usercreate6;
    }
    if ($MUP_CREATE->field_check(5,10,$_POST['password']) || $MUP_CREATE->is_alpha($_POST['password'],10)) {
      $error_string[] = $msg_usercreate8;
    }
    if ($MUP_CREATE->field_check(0,0,$_POST['type'])) {
      $error_string[] = $msg_acctypes33;
    }
    if (!empty($error_string)) {
    
      error($msg_script12,
            $msg_script11,
            $msg_charset,
            $error_string
            );
    
    } else {
    
      //--------------------------
      // Explode package
      // [0] = ID
      // [1] = Package Name
      // [2] = Package Cost
      //--------------------------

      $pack                   = explode("##", $_POST['type']);
      $MUP_CREATE->username   = $_POST['username'];
      $MUP_CREATE->packageid  = $pack[0];
      $MUP_CREATE->type       = $pack[1];
      $MUP_CREATE->cost       = $pack[2];
      $FOLDERNAME             = $MUP_CREATE->setup_folder();
                
      // Log data..
      $MUP_CREATE->add_account_sql(1,1,$FOLDERNAME,$UNIQUEID,$_POST);
                
      // Attempt to create directory..
      if ($MUP_CREATE->create_folder(RELATIVE_PATH.$SETTINGS->uploaddir,$FOLDERNAME)) {
        $MUP_CREATE->create_index(RELATIVE_PATH.$SETTINGS->uploaddir,$SETTINGS->autoindex,$msg_manage26,$FOLDERNAME);
      }
                
      // Send e-mail if selected..
      if ($send)
      {
        $MUP_MAIL->addTag('{USERNAME}',$_POST['username']);  
        $MUP_MAIL->addTag('{PASSWORD}',$_POST['password']);  
        $MUP_MAIL->addTag('{DATE}',date($SETTINGS->dateformat, strtotime(($SETTINGS->time_offset=='0' ? "+0 hours" : $SETTINGS->time_offset)))); 
        $MUP_MAIL->addTag('{TYPE}',$pack[1]); 
        $MUP_MAIL->addTag('{EMAIL}',$_POST['email']); 
        
        $MUP_MAIL->sendMail($_POST['username'],
                            $_POST['email'],
                            $SETTINGS->webname,
                            $SETTINGS->email,
                            '['.$SETTINGS->webname.'] '.$msg_create7,
                            $MUP_MAIL->template(RELATIVE_PATH.'templates/email/manual_setup.txt')
                            );       
      }

      updated($msg_create6,
              'index.php?cmd=create',
              $msg_script10,
              $msg_script9,
              $msg_charset
              );
    }
  }

  include(FOLDER_PATH.'inc/header.php');
  include(FOLDER_PATH.'data_files/create.php');
  include(FOLDER_PATH.'inc/footer.php');
  break;
      
  /*+++++++++++++++++++++++++++++
    + CASE: MOVE                +
    + Move Files                +
    + New as of v3.2            +
    +++++++++++++++++++++++++++++*/
        
  case "move":
  
  $title = $msg_movefiles2;
      
  $MV_FILE      = explode(",", $_POST['files']);
  $MAIL_STRING  = '';

  include(FOLDER_PATH.'classes/class_movefiles.inc.php');
      
  $MUP_MOVE          = new mov_File();
  $MUP_MOVE->prefix  = $database['prefix'];
  $MUP_MOVE->folder  = $SETTINGS->uploaddir;
  $MUP_MOVE->path    = RELATIVE_PATH;
  $file_name         = '';
  
  // Get destination account info..
  $ACC = $MUP_MOVE->destination($_POST['account']);

  for ($i=0; $i<count($MV_FILE); $i++)
  {
    // Get file data..
    $FILE = loadFileData($MV_FILE[$i]);
    
    if ($MUP_MOVE->check_file($_POST['account'],$FILE->upload_name))
    {
      $file_name = $MUP_MOVE->random_data(10,'random').'_'.substr($FILE->upload_name,0,5).strrchr(strtolower($FILE->upload_name), '.');
    } else {
      $file_name = $FILE->upload_name;
    }

    if ($MUP_MOVE->move_file($_POST['memberID'],
                             $_POST['member'],
                             $MV_FILE[$i],
                             $_POST['folder'],
                             $FILE->upload_name,
                             $FILE->file_size,
                             $_POST['account'],
                             $ACC->accfolder,
                             $ACC->username,
                             $ACC->email,
                             $file_name
                             ))
    {
      $MAIL_STRING .= $msg_tempupload10.": ".cleanData($FILE->file_name).define_newline();
      $MAIL_STRING .= $msg_tempupload11.": ".$file_name.define_newline();
      $MAIL_STRING .= $msg_tempupload12.": ".file_size_conversion($FILE->file_size,MGBS).define_newline().define_newline();

      $count++;
    }
        
    unset ($file_name,$FILE);
  }
      
  // Send mail..
  if ($MAIL_STRING && $count>0)
  {
    if (isset($_POST['send']))
    {
      $MUP_MAIL->addTag('{USERNAME}',$ACC->username);
      $MUP_MAIL->addTag('{DATE}',date($SETTINGS->dateformat, strtotime(($SETTINGS->time_offset=='0' ? "+0 hours" : $SETTINGS->time_offset))));
      $MUP_MAIL->addTag('{FILES}',trim($MAIL_STRING));
      
      $MUP_MAIL->sendMail($ACC->username,
                          $ACC->email,
                          $SETTINGS->webname,
                          $SETTINGS->email,
                          '['.$SETTINGS->webname.'] '.$msg_movefiles8,
                          $MUP_MAIL->template(RELATIVE_PATH.'templates/email/admin_move_files.txt')
                          );
    }
    
    updated($msg_movefiles5,'index.php?cmd=accounts&amp;view='.$_POST['memberID'],
            count($MV_FILE).' '.$msg_movefiles6.'<br><br>'.$msg_script10,
            $msg_script9,
            $msg_charset
            );
    
  } else {
      error($msg_script12,
            $msg_script11,
            $msg_charset,
            array($msg_movefiles7)
            );
  }

  break;

  /*+++++++++++++++++++++++++
    + CASE: MIMETYPE        +
    + Mime Types            +
    +++++++++++++++++++++++++*/

  case "mimetypes":
  
  $title = $msg_header30;
      
  isWebmasterLoggedIn();
      
  // Update Mime Types
  if (isset($_POST['process']))
  {
    // Apply call back element to trim post vars..
    $_POST = array_map('trim',$_POST);
    
    include(FOLDER_PATH.'classes/class_settings.inc.php');
           
    $MUP_MIME          = new settings();
    $MUP_MIME->prefix  = $database['prefix'];
    
    $MUP_MIME->update_mime($_POST);
           
    updated($msg_mimetypes6,
            'index.php?cmd=mimetypes',
            $msg_script10,
            $msg_script9,
            $msg_charset
            );
  }

  include(FOLDER_PATH.'inc/header.php');
  include(FOLDER_PATH.'data_files/mimetypes.php');
  include(FOLDER_PATH.'inc/footer.php');
  break;
  
  /*+++++++++++++++++++++++++
    + CASE: ACCOUNTS        +
    + Manage Accounts       +
    +++++++++++++++++++++++++*/

  case "accounts":
  
  $title = $msg_header12;
  
  isWebmasterLoggedIn();
  
  // Remove accounts..
  if (isset($_POST['process_remove']))
  {
    if (isset($_POST['acc_id']))
    {
      //---------------------------------------------------
      // Firstly delete files and directories
      // Then delete data from database
      // For this we need 2 loops
      // We also need to create instance of accounts class
      //---------------------------------------------------
                
      include(FOLDER_PATH.'classes/class_accounts.inc.php'); 
                
      for($i=0; $i<count($_POST['acc_id']); $i++)
      {
        //-------------------------
        // Explode array
        // $DATA[0] = Account ID
        // $DATA[1] = Folder Name
        // $DATA[2] = Username
        //-------------------------
                     
        $DATA = explode("##", $_POST['acc_id'][$i]);

        $MUP_DELETE          = new accounts();         
        $MUP_DELETE->prefix  = $database['prefix'];
        $new_count           = $MUP_DELETE->remove_data($DATA[0],$DATA[1],RELATIVE_PATH,$SETTINGS->uploaddir,$DATA[2]);
        $count               = $count+$new_count;
                     
        unset($new_count,$MUP_DELETE,$DATA);
      }
                
      updated($msg_manage53,
              'index.php?cmd=accounts',
              count($_POST['acc_id']).' '.$msg_manage54.'<br>'.number_format($count).' '.$msg_manage55.'<br><br>'.$msg_script10,
              $msg_script9,
              $msg_charset
              );
    }
  }
  
  // Edit account..
  if (isset($_GET['edit']))
  {
    if (isset($_POST['process']))
    {
      // Apply call back element to trim post vars..
      $_POST = array_map('trim',$_POST);
    
      include(FOLDER_PATH.'classes/class_accounts.inc.php');

      $MUP_UPDATE          = new accounts();
      $MUP_UPDATE->prefix  = $database['prefix'];
                
      if ($MUP_UPDATE->field_check(5,15,$_POST['username'])) {
        $error_string[] = $msg_usercreate7;
      }
      if ($MUP_UPDATE->is_email_valid($_POST['email'])) {
        $error_string[] = $msg_usercreate6;
      }
      if ($MUP_UPDATE->is_email_unique($_POST['email'],$_POST['id'])) {
        $error_string[] = $msg_email5;
      }
      if ($MUP_UPDATE->is_alpha($_POST['folder'],30)) {
        $error_string[] = $msg_manage48;
      }
      if ($MUP_UPDATE->field_numeric($_POST['max_size'])) {
        $error_string[] = $msg_manage49;
      }
      if ($MUP_UPDATE->field_numeric($_POST['webspace'])) {
        $error_string[] = $msg_manage50;
      }
      if ($MUP_UPDATE->field_numeric($_POST['clicks'])) {
        $error_string[] = $msg_manage51;
      }

      if (!empty($error_string)) {
        error($msg_script12,
              $msg_script11,
              $msg_charset,
              $error_string
              );
      } else {
      
        // Rename folder if different..
        if ($_POST['folder']!=$_POST['fld']) {
          $MUP_UPDATE->update_dir(RELATIVE_PATH,$SETTINGS->uploaddir,$_POST['fld'],$_POST['folder']);
        }
                     
        // Update DB
        $MUP_UPDATE->update_sql($_POST);

        updated($msg_manage45,
                'index.php?cmd=accounts&amp;edit='.$_POST['id'],
                $msg_script10,
                $msg_script9,
                $msg_charset
                );
      }
    }
    
    include(FOLDER_PATH.'inc/header.php');
    include(FOLDER_PATH.'data_files/accounts/edit.php');
    include(FOLDER_PATH.'inc/footer.php');
    exit;
  }
  
  // Contact member..
  if (isset($_GET['contact']))
  {
    if (isset($_POST['process']))
    {
      // Apply call back element to trim post vars..
      $_POST = array_map('trim',$_POST);
      
      if ($_POST['subject']=="" || $_POST['comments']=="") {
        error($msg_script12,
              $msg_script11,
              $msg_charset,
              array($msg_manage56)
              );
      } else {
        $MUP_MAIL->sendMail($_POST['user'],
                            $_POST['email'],
                            $SETTINGS->webname,
                            $SETTINGS->email,
                            '['.$SETTINGS->webname.'] '.$_POST['subject'],
                            $_POST['comments']
                            );

        updated($msg_manage34,
                'index.php?cmd=accounts&amp;contact='.$_GET['contact'],
                $msg_script10,
                $msg_script9,
                $msg_charset
                );
      }
    }
    
    include(FOLDER_PATH.'inc/header.php');
    include(FOLDER_PATH.'data_files/accounts/contact.php');
    include(FOLDER_PATH.'inc/footer.php');
    exit;
  }
  
  // Resend validation e-mail..
  if (isset($_GET['resend']))
  {
    if (isset($_POST['process']))
    {
      // Apply call back element to trim post vars..
      $_POST = array_map('trim',$_POST);
      
      // Update e-mail..
      if (isset($_POST['updatedata']))
      {
        $query = mysql_query("SELECT email FROM ".$database['prefix']."members 
                              WHERE email = '".$_POST['email']."' 
                              AND id != '".$_GET['resend']."' 
                              LIMIT 1
                              ") or die(mysql_error());
                     
        if (mysql_num_rows($query)>0) {
          $EXIST = true;
        } else {
          mysql_query("UPDATE ".$database['prefix']."members SET 
                       email     = '".$_POST['email']."' 
                       WHERE id  = '".$_GET['resend']."' 
                       LIMIT 1
                       ") or die(mysql_error());
        }
      }

      $MUP_MAIL->addTag('{VERIFICATION_LINK}','index.php?cmd=verify&code='.$_POST['code']);
      $MUP_MAIL->addTag('{USERNAME}',$_POST['user']);
      
      $MUP_MAIL->sendMail($_POST['user'],
                          ($_POST['email'] ? $_POST['email'] : $_POST['accemail']),
                          $SETTINGS->webname,
                          $SETTINGS->email,
                          '['.$SETTINGS->webname.'] '.$msg_usercreate25,
                          $MUP_MAIL->template(RELATIVE_PATH.'templates/email/resend_verification.txt')
                          );
      
      $SENT = false;
    }
    
    include(FOLDER_PATH.'data_files/accounts/resend.php');
    exit;
  }
  
  // View paypal data..
  if (isset($_GET['paypal']))
  {
    include(FOLDER_PATH.'data_files/accounts/paypal.php');
    exit;
  }
  
  // FTP access..
  if (isset($_GET['ftp']))
  {
    if (isset($_POST['process']))
    {
      // Apply call back element to trim post vars..
      $_POST = array_map('trim',$_POST);
      
      include(FOLDER_PATH.'classes/class_accounts.inc.php');

      $MUP_FTP          = new accounts();
      $MUP_FTP->prefix  = $database['prefix'];
      
      // Update/create ftp dir..
      if ($_POST['fld']=='') {
        $MUP_FTP->update_ftp_dir(RELATIVE_PATH,$SETTINGS->uploaddir,$_POST['folder'],$_POST['ftp_folder']);
      }
      if ($_POST['fld'] && ($_POST['ftp_folder']!=$_POST['fld'])) {
        $MUP_FTP->update_ftp_dir(RELATIVE_PATH,$SETTINGS->uploaddir,$_POST['folder'],$_POST['fld'],$_POST['ftp_folder']);
      }
      
      // Update..
      $MUP_FTP->update_ftp($_POST);
      
      header("Location: index.php?cmd=accounts&ftp=".$_POST['id']);
      exit;
    }
    
    include(FOLDER_PATH.'data_files/accounts/ftp.php');
    exit;
  }
  
  // View files..
  if (isset($_GET['view']))
  {
    if (isset($_POST['process']))
    {
      if (isset($_POST['fileinfo']))
      {
        switch ($_POST['option'])
        {
          // Delete files..
          case "del":
                     
          for ($i=0; $i<count($_POST['fileinfo']); $i++)
          {
            $DATA = explode("##", $_POST['fileinfo'][$i]);

            // $DATA[0] => Remove from database..
            mysql_query("DELETE FROM ".$database['prefix']."uploads 
                         WHERE id = '".$DATA[0]."' 
                         LIMIT 1
                         ") or die(mysql_error());
            
            // $DATA[1] => Remove file..
            if (file_exists(RELATIVE_PATH.$SETTINGS->uploaddir.'/'.$_POST['folder'].'/'.$DATA[1]))
            {
              unlink(RELATIVE_PATH.$SETTINGS->uploaddir.'/'.$_POST['folder'].'/'.$DATA[1]);
            }              
          }

          updated($msg_view20,
                  'index.php?cmd=accounts&amp;view='.$_POST['id'],
                  count($_POST['fileinfo']).' '.$msg_manage55.'<br><br>'.$msg_script10,
                  $msg_script9,
                  $msg_charset
                  );
           
          break;

          // Download in zip archive..
          case "zip":
                     
          include(FOLDER_PATH.'classes/class_zipcompression.inc.php');
                               
          $MUP_ZIP = new createZip();
          $MUP_ZIP->AddDirectory($_POST['folder']."/");
                               
          for ($i=0; $i<count($_POST['fileinfo']); $i++)
          {
            $DATA = explode("##", $_POST['fileinfo'][$i]);

            //$DATA[1] => File path. Use this to load file into archive
            if (file_exists(RELATIVE_PATH.$SETTINGS->uploaddir.'/'.$_POST['folder'].'/'.$DATA[1]))
            {
              $getContents = file_get_contents(RELATIVE_PATH.$SETTINGS->uploaddir.'/'.$_POST['folder'].'/'.$DATA[1]);

              $MUP_ZIP->addFile($getContents, $_POST['folder']."/".$DATA[1]);
            }
          }
                               
          // Create .zip file and force download..
          $ZIPFILENAME  = RELATIVE_PATH.'log/files.zip';
          $fd           = fopen ($ZIPFILENAME, "wb");
          $out          = fwrite ($fd, $MUP_ZIP->getZippedfile());
          fclose ($fd);

          $MUP_ZIP->forceDownload($ZIPFILENAME);
          
          if (file_exists($ZIPFILENAME))
          {
            unlink($ZIPFILENAME);
          }
                          
          exit;
          
          break;
                     
          // Move files..
          // Added in v3.2..
          case 'mov':
                     
          $idRun = array();

          foreach($_POST['fileinfo'] AS $fdata)
          {
            $gt       = explode("##", $fdata);
            $idRun[]  = $gt[0];
          }

          include(FOLDER_PATH.'inc/header.php');
          include(FOLDER_PATH.'data_files/move.php');
          include(FOLDER_PATH.'inc/footer.php');
          exit;
          
          break;
        }
      }
      else
      {
        header("Location: index.php?cmd=accounts&view=".$_POST['id']);
        exit;
      }
    }
    
    if (isset($_POST['process_file_name']))
    {
      mysql_query("UPDATE ".$database['prefix']."uploads SET
                   file_name  = '".mysql_real_escape_string(($_POST['name'] ? $_POST['name'] : $SETTINGS->default_name))."'
                   WHERE id   = '".$_POST['file']."'
                   LIMIT 1
                   ") or die(mysql_error());
                   
      updated($msg_manage96,
              'index.php?cmd=accounts&amp;view='.$_GET['view'],
              $msg_script10,
              $msg_script9,
              $msg_charset
              );
    }
    
    if (isset($_GET['orderby']))
    {
      switch ($_GET['orderby'])
      {
        case "smallest":
        $sql_orderclause = ' ORDER BY file_size';
        break;

        case "largest":
        $sql_orderclause = ' ORDER BY file_size DESC';
        break;

        case "oldest":
        $sql_orderclause = ' ORDER BY file_filter_date';
        break;

        case "newest":
        $sql_orderclause = ' ORDER BY file_filter_date DESC';
        break;

        case "name":
        $sql_orderclause = ' ORDER BY file_name';
        break;
                     
        case "admin":
        $sql_orderclause = ' ORDER BY admin_status DESC';
        break;
      }
    }
    
    // Over ride limit..
    $limit = (isset($_GET['display']) ? strip_tags($_GET['display']) : $SETTINGS->data_per_page);
    
    include(FOLDER_PATH.'inc/header.php');
    include(FOLDER_PATH.'data_files/accounts/view.php');
    include(FOLDER_PATH.'inc/footer.php');
    exit;
  }
  
  // Code generator..
  // Updated in v4.0..
  if (isset($_GET['code']))
  {
    // Get file data..
    $FILE  = loadFileDataToString($_GET['code'],'',''); 
    $type  = 'download';
    
    // Determine file type for this file..
    if(in_array($FILE->file_type, getMimeTypes('view'))) {
      $type = 'view';
    } else if (in_array($FILE->file_type, getMimeTypes('download'))) {
      $type = 'download';
    } else if (in_array($FILE->file_type, getMimeTypes('media'))) {
      $type = 'media';
    }
   
    // Path to file..
    $path = $SETTINGS->url.'/'.$SETTINGS->uploaddir.'/'.$FILE->folder_name.'/'.$FILE->upload_name;
   
    // Send e-mail with code..
    $MUP_MAIL->addTag('{NAME}',$FILE->user_name);
    $MUP_MAIL->addTag('{FILE}',$FILE->file_name);
    $MUP_MAIL->addTag('{TYPE}',$FILE->file_type);
    $MUP_MAIL->addTag('{HTML_CODE}',$MUP_MAIL->codeGenerator(false,$type,$FILE->upload_name,$path,$FILE->file_name,$FILE->file_type,RELATIVE_PATH));
    $MUP_MAIL->addTag('{BB_CODE}',$MUP_MAIL->codeGenerator(true,$type,$FILE->upload_name,$path,$FILE->file_name,$FILE->file_type,RELATIVE_PATH));
   
    $MUP_MAIL->sendMail($SETTINGS->webname,
                        $SETTINGS->email,
                        $SETTINGS->webname,
                        $SETTINGS->email,
                        '['.$SETTINGS->webname.'] '.$msg_script38,
                        $MUP_MAIL->template(RELATIVE_PATH.'templates/email/codegen_message.txt')
                        );
                        
    include(FOLDER_PATH.'data_files/popup/codegen.php');
    exit;                    
  }
  
  // Load file based on option..
  // View => View file
  // Media => Play file
  // Download => Download file
  if (isset($_GET['viewfile']) || 
      isset($_GET['media']) || 
      isset($_GET['download']) || 
      isset($_GET['mp3']) ||
      isset($_GET['flv'])
      )
  {
    $mp_flv    = (isset($_GET['mp3']) ? strip_tags($_GET['mp3']) : (isset($_GET['flv']) ? strip_tags($_GET['flv']) : ''));
    $view      = (isset($_GET['viewfile']) ? strip_tags($_GET['viewfile']) : '');
    $media     = (isset($_GET['media']) ? strip_tags($_GET['media']) : ($mp_flv ? $mp_flv : ''));
    $download  = (isset($_GET['download']) ? strip_tags($_GET['download']) : '');
     
    // Load file data into string..
    $FILE = loadFileDataToString($view,$media,$download);     
     
    // View files...
    if ($view)
    {
      include(FOLDER_PATH.'data_files/popup/viewfile.php');
      exit;
    } 
         
    // Force download..
    if ($download)
    {
      if (isset($_SERVER['HTTP_USER_AGENT']) && preg_match("/MSIE/", $_SERVER['HTTP_USER_AGENT']))
      {
        if(ini_get('zlib.output_compression'))
        {
          ini_set('zlib.output_compression', 'Off');
        }
      }
      
      if (file_exists(RELATIVE_PATH.$SETTINGS->uploaddir.'/'.$FILE->folder_name.'/'.$FILE->upload_name))
      {
        header('Pragma: public');
        header('Expires: 0');
        header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
        header('Cache-Control: private', false);
        header('Content-Type: '.$FILE->file_type);
        header('Content-Disposition: attachment; filename='.basename(RELATIVE_PATH.$SETTINGS->uploaddir.'/'.$FILE->folder_name.'/'.$FILE->upload_name));
        header('Content-Transfer-Encoding: binary');
        header('Content-Length: '.filesize(RELATIVE_PATH.$SETTINGS->uploaddir.'/'.$FILE->folder_name.'/'.$FILE->upload_name));
        
        readfile(RELATIVE_PATH.$SETTINGS->uploaddir.'/'.$FILE->folder_name.'/'.$FILE->upload_name);
        exit;
      }
    }
     
    // Play file..
    if ($media || isset($_GET['mp3']) || isset($_GET['flv']))
    {
      include(FOLDER_PATH.'inc/flash_functions.php');
       
      // MP3 Player. Added in v4.0
      if (isset($_GET['mp3']))
      {
        include(FOLDER_PATH.'data_files/popup/multimedia_mp3.php');
        exit;
      }
       
      // FLV Player. Added in v4.0
      if (isset($_GET['flv']))
      {
        include(FOLDER_PATH.'data_files/popup/multimedia_flv.php');
        exit;
      }
      
      include(FOLDER_PATH.'data_files/popup/mediacontrols.php');
      exit;
    }
  }
      
  $type     = (isset($_GET['type']) ? $_GET['type'] : '');
  $orderby  = (isset($_GET['orderby']) ? $_GET['orderby'] : 'username');
  
  include(FOLDER_PATH.'inc/header.php');
  include(FOLDER_PATH.'data_files/accounts.php');
  include(FOLDER_PATH.'inc/footer.php');
  break;
  
  /*+++++++++++++++++++++++++
    + CASE: PAYPAL          +
    + Paypal IPN System     +
    +++++++++++++++++++++++++*/

  case "paypal":
  
  $title = $msg_header42;
      
  isWebmasterLoggedIn();
      
  // Update IPN Settings..
  if (isset($_POST['process']))
  {
    // Apply call back element to trim post vars..
    $_POST = array_map('trim',$_POST);
    
    include(FOLDER_PATH.'classes/class_settings.inc.php');

    $MUP_IPN          = new settings();
    $MUP_IPN->prefix  = $database['prefix'];
    
    if ($MUP_IPN->is_email_valid($_POST['email'])) {
      $error_string[] = $msg_settings23;
    }
    if (!empty($error_string)) {
      error($msg_script12,
            $msg_script11,
            $msg_charset,
            $error_string
            );
    } else {
      $MUP_IPN->update_paypal($_POST);
                
      updated($msg_paypal10,
              'index.php?cmd=paypal',
              $msg_script10,
              $msg_script9,
              $msg_charset
              );
    }
  }

  include(FOLDER_PATH.'inc/header.php');
  include(FOLDER_PATH.'data_files/paypal.php');
  include(FOLDER_PATH.'inc/footer.php');
  break;

  /*+++++++++++++++++++++++++
    + CASE: ANNOUNCEMENTS   +
    + Add Announcements     +
    +++++++++++++++++++++++++*/

  case "news":
  
  $title = $msg_header29;
      
  isWebmasterLoggedIn();
  
  // Reload based on tab selection..
  if (isset($_GET['tab'])) {
    toggleTab($_GET['tab'],'news');
  }
      
  // Load Preview window..
  if ((isset($_GET['code'])) && ($_GET['code']=="preview")) {
    include(FOLDER_PATH.'data_files/popup/previewnews.php');
    exit;
  }      
      
  if (isset($_GET['code']) && $_GET['code']=="edit") {
    toggleTab('add','news','id='.$_GET['id']);
  }  
  
  // Delete Announcement..
  if (isset($_POST['process']))
  {
    $news_id = (isset($_POST['news_id']) ? $_POST['news_id'] : '');

    if (!empty($news_id)) {
      foreach ($news_id AS $value) {
        $split = explode("##",$value);
        mysql_query("DELETE FROM ".$database['prefix']."news 
                     WHERE id = '".$split[1]."' LIMIT 1
                     ") or die(mysql_error());
        mysql_query("DELETE FROM ".$database['prefix']."readnews 
                     WHERE news_code = '".$split[0]."'
                     ") or die(mysql_error());             
      }          
      updated($msg_news16,
              'index.php?cmd=news',
              $msg_script10,
              $msg_script9,
              $msg_charset
              );
    }
  }
      
  // Edit Announcement..
  if (isset($_POST['edit']))
  {
    // Apply call back element to trim post vars..
    $_POST = array_map('trim',$_POST);
    
    include(FOLDER_PATH.'classes/class_news.inc.php');
           
    $MUP_NEWS          = new newsItem();
    $MUP_NEWS->prefix  = $database['prefix'];
    
    if ($MUP_NEWS->field_check(0,150,$_POST['title'])) {
      $error_string[] = $msg_news6;
    }
    if ($MUP_NEWS->field_check(0,0,$_POST['comments'])) {
      $error_string[] = $msg_news7;
    }
    if (!empty($error_string)) {
      error($msg_script12,$msg_script11,$msg_charset,$error_string);
    } else {
      $MUP_NEWS->news_updated($_POST);
                
      updated($msg_news17,
              'index.php?cmd=news&amp;code=edit&amp;id='.$_POST['id'],
              $msg_script10,
              $msg_script9,
              $msg_charset
              );
    }
  }
      
  // Add Announcement..
  if (isset($_POST['add']))
  {
    // Apply call back element to trim post vars..
    $_POST = array_map('trim',$_POST);
           
    include(FOLDER_PATH.'classes/class_news.inc.php');
           
    $MUP_NEWS          = new newsItem();
    $MUP_NEWS->prefix  = $database['prefix'];
    
    if ($MUP_NEWS->field_check(0,150,$_POST['title'])) {
      $error_string[] = $msg_news6;
    }
    if ($MUP_NEWS->field_check(0,0,$_POST['comments'])) {
      $error_string[] = $msg_news7;
    }
    if (!empty($error_string)) {
      error($msg_script12,
            $msg_script11,
            $msg_charset,
            $error_string
            );
    } else {
      $id = $MUP_NEWS->add_news($_POST);
                
      updated($msg_news8,
              'index.php?cmd=news',
              $msg_script10,
              $msg_script9,
              $msg_charset
              );
    }
  }

  include(FOLDER_PATH.'inc/header.php');
  include(FOLDER_PATH.'data_files/announcements.php');
  include(FOLDER_PATH.'inc/footer.php');
  break;
      
  /*+++++++++++++++++++++++++
    + CASE: UPGRADE         +
    + Upgrade Storage       +
    +++++++++++++++++++++++++*/

  case "upgrade":
  
  $title = $msg_header13;
      
  isWebmasterLoggedIn();
      
  // Upgrade Storage..
  if (isset($_POST['process']))
  {
    // Apply call back element to trim post vars..
    $_POST = array_map('trim',$_POST);
    
    if ($_POST['from_day'] && $_POST['from_month'] && $_POST['from_year']) {
      $from_date_string = $_POST['from_year'].'-'.$_POST['from_month'].'-'.$_POST['from_day'];
    }
    if ($_POST['to_day'] && $_POST['to_month'] && $_POST['to_year']) {
      $to_date_string = $_POST['to_year'].'-'.$_POST['to_month'].'-'.$_POST['to_day'];
    }

    include(FOLDER_PATH.'classes/class_accounts.inc.php');

    $MUP_UPGRADE              = new accounts();
    $MUP_UPGRADE->prefix      = $database['prefix'];
           
    if ($MUP_UPGRADE->field_check(0,0,$_POST['storage']) || $MUP_UPGRADE->field_numeric($_POST['storage'])) {
      $error_string[] = $msg_upgrade9;
    }
    if ($_POST['less'] && $_POST['greater'])
    {
      if ($MUP_UPGRADE->field_numeric($_POST['less']) || $MUP_UPGRADE->field_numeric($_POST['greater'])) {
        $error_string[] = $msg_upgrade11;
      }
      if ($MUP_UPGRADE->compare_data($_POST['greater'],$_POST['less'])) {
        $error_string[] = $msg_upgrade14;
      }
    }
    if (!empty($error_string))
    {
      error($msg_script12,
            $msg_script11,
            $msg_charset,
            $error_string
            );
    }
    else
    {
      $sql_base_string  = '';
      $sql_string       = array();
      $SQL_DATA_STRING  = '';

      if ($_POST['type']!="all")
      {
        $sql_base_string = "WHERE accid = '".$_POST['type']."'";
      }
      if ($_POST['current'])
      {
        $sql_string[] = "webspace = '".$_POST['current']."'";
      }
      if ($_POST['greater'] && $_POST['less'] && !$_POST['current'])
      {
        $sql_string[] = "webspace > '".$_POST['greater']."' AND webspace < '".$_POST['less']."'";
      }
      if (isset($from_date_string) && isset($to_date_string))
      {
        $sql_string[] = "joindate BETWEEN '$from_date_string' AND '$to_date_string'";
      }
      if (empty($sql_string))
      {
        $SQL_DATA_STRING = $sql_base_string;
      } else {
        $SQL_DATA_STRING = ($sql_base_string ? $sql_base_string.' AND ' : 'WHERE ');

        for ($i=0; $i<count($sql_string); $i++) {
          if ($i!=count($sql_string)-1) {
            $SQL_DATA_STRING .= $sql_string[$i].' AND ';
          } else {
            $SQL_DATA_STRING .= $sql_string[$i];
          }
        }
      }
                
      $acc_count = $MUP_UPGRADE->upgrade_storage($SQL_DATA_STRING,$_POST['storage']);

      updated($msg_upgrade15,
              'index.php?cmd=upgrade',
              $acc_count.' '.$msg_upgrade16.'<br><br>'.$msg_script10,
              $msg_script9,
              $msg_charset
              );
    }

  }

  include(FOLDER_PATH.'inc/header.php');
  include(FOLDER_PATH.'data_files/upgrade.php');
  include(FOLDER_PATH.'inc/footer.php');
  break;

  /*+++++++++++++++++++++++++
    + CASE: UPGRADEACC      +
    + Upgrade Accounts      +
    +++++++++++++++++++++++++*/

  case "upgradeacc":
  
  $title = $msg_header45;
      
  isWebmasterLoggedIn();
      
  // Upgrade Account..
  if (isset($_POST['process']))
  {
    // Apply call back element to trim post vars..
    $_POST = array_map('trim',$_POST);
    
    if ($_POST['from_day'] && $_POST['from_month'] && $_POST['from_year']) {
      $from_date_string = $_POST['from_year'].'-'.$_POST['from_month'].'-'.$_POST['from_day'];
    }
    if ($_POST['to_day'] && $_POST['to_month'] && $_POST['to_year']) {
      $to_date_string = $_POST['to_year'].'-'.$_POST['to_month'].'-'.$_POST['to_day'];
    }
    
    include(FOLDER_PATH.'classes/class_accounts.inc.php');

    $MUP_UPGRADE           = new accounts();
    $MUP_UPGRADE->prefix   = $database['prefix'];
           
    if ($_POST['acc_one']==$_POST['acc_two'])
    {
      error($msg_script12,
            $msg_script11,
            $msg_charset,
            array($msg_upgradeacc6)
            );
    } else {
      $sql_base_string  = '';
      $sql_base_string2 = '';
      $SQL_DATA_STRING  = '';

      if ($_POST['type'] != "all")
      {
        $sql_base_string = "WHERE id = '".$_POST['type']."'";
      } else {
        $sql_base_string = "WHERE accid = '".$_POST['acc_one']."'";
      }
      if (isset($from_date_string) && isset($to_date_string) && $_POST['type'] == "all") {
        $sql_base_string2 = "joindate BETWEEN '$from_date_string' AND '$to_date_string'";
      }

      $SQL_DATA_STRING = $sql_base_string.($sql_base_string2 ? ' AND '.$sql_base_string2 : '');

      $acc_count = $MUP_UPGRADE->upgrade_accounts($SQL_DATA_STRING,$_POST['acc_two']);
                
      updated($msg_upgradeacc7,
              'index.php?cmd=upgradeacc',
              $acc_count.' '.$msg_upgrade16.'<br><br>'.$msg_script10,
              $msg_script9,
              $msg_charset
              );
    }
  }

  include(FOLDER_PATH.'inc/header.php');
  include(FOLDER_PATH.'data_files/upgradeacc.php');
  include(FOLDER_PATH.'inc/footer.php');
  break;

  /*+++++++++++++++++++++++++++++
    + CASE: SIGNFIELD           +
    + Specify additional fields +
    +++++++++++++++++++++++++++++*/

  case "signfields":
  
  $title = $msg_header14;
      
  isWebmasterLoggedIn();
      
  if (isset($_POST['process']))
  {
    include(FOLDER_PATH.'classes/class_signfields.inc.php');
           
    $MUP_FIELDS          = new signFields();
    $MUP_FIELDS->prefix  = $database['prefix'];
           
    $MUP_FIELDS->update_fields($_POST);
           
    updated($msg_signfields11,
            'index.php?cmd=signfields',
            $msg_script10,
            $msg_script9,
            $msg_charset
            );
  }

  include(FOLDER_PATH.'inc/header.php');
  include(FOLDER_PATH.'data_files/signfields.php');
  include(FOLDER_PATH.'inc/footer.php');
  break;

  /*+++++++++++++++++++++++++
    + CASE: UPLOAD          +
    + Upload Files          +
    +++++++++++++++++++++++++*/

  case "upload":
  
  $title = $msg_header15;
      
  isWebmasterLoggedIn();
      
  // Upload Files..
  if (isset($_POST['process']))
  {
    if ($_POST['member']=="0") {
      error($msg_script12,
            $msg_script11,
            $msg_charset,
            array($msg_upload7)
            );
    }
           
    //----------------------------------------
    // Explode member variable and get data
    // $DATA[0] = Member ID
    // $DATA[1] = Member Username
    // $DATA[2] = Member E-Mail
    // $DATA[3] = Member Folder
    //----------------------------------------
           
    $DATA = explode("*", $_POST['member']);
           
    $MAIL_STRING = '';

    include(FOLDER_PATH.'classes/class_accounts.inc.php');

    for ($i=0; $i<count($_FILES['user_file']['tmp_name']); $i++)
    {
      $name      = filterUploadName($_FILES['user_file']['name'][$i]);
      $size      = $_FILES['user_file']['size'][$i];
      $temp      = $_FILES['user_file']['tmp_name'][$i];
      $type      = $_FILES['user_file']['type'][$i];
      $filename  = $_POST['file_name'][$i];
                
      if (!empty($name))
      {
        $count++;
                     
        $MUP_UPLOAD                = new accounts();
        $MUP_UPLOAD->prefix        = $database['prefix'];
        $MUP_UPLOAD->name          = $name;
        $MUP_UPLOAD->size          = $size;
        $MUP_UPLOAD->temp          = $temp;
        $MUP_UPLOAD->type          = $type;
        $MUP_UPLOAD->username      = $DATA[1];
        $MUP_UPLOAD->email         = $DATA[2];
        $MUP_UPLOAD->folder        = $DATA[3];
        $MUP_UPLOAD->folder_main   = $SETTINGS->uploaddir;
        $MUP_UPLOAD->date          = date($SETTINGS->dateformat, strtotime(($SETTINGS->time_offset=='0' ? "+0 hours" : $SETTINGS->time_offset)));
        $MUP_UPLOAD->id            = $DATA[0];
        $MUP_UPLOAD->filename      = ($filename ? $filename : $SETTINGS->default_name);
        
        // Upload Files, Add to Database..
        $FILEPREFIX = $MUP_UPLOAD->get_file_prefix();
        $MUP_UPLOAD->upload_file(RELATIVE_PATH,$FILEPREFIX);
        $MUP_UPLOAD->insert_sql($FILEPREFIX);
                     
        // Format file size from bytes to KBytes or Megabytes
        $new_size = file_size_conversion($size,MGBS);
                     
        // Build mail string..
        $MAIL_STRING .= $msg_tempupload10.": ".($filename ? $filename : $SETTINGS->default_name).define_newline();
        $MAIL_STRING .= $msg_tempupload11.": ".$FILEPREFIX.define_newline();
        $MAIL_STRING .= $msg_tempupload12.": ".$new_size.define_newline().define_newline();

        unset($MUP_UPLOAD,$name,$size,$type,$filename,$temp);
      }
    }
           
    // Check to see if at least 1 file was uploaded..
    if ($count>0)
    {
      // Send mail if enabled..
      if ($_POST['send'])
      {
        $MUP_MAIL->addTag('{USERNAME}',$DATA[1]);
        $MUP_MAIL->addTag('{DATE}',date($SETTINGS->dateformat, strtotime(($SETTINGS->time_offset=='0' ? "+0 hours" : $SETTINGS->time_offset))));
        $MUP_MAIL->addTag('{FILES}',trim($MAIL_STRING));
        
        $MUP_MAIL->sendMail($DATA[1],
                            $DATA[2],
                            $SETTINGS->webname,
                            $SETTINGS->email,
                            '['.$SETTINGS->webname.'] '.$msg_upload9,
                            $MUP_MAIL->template(RELATIVE_PATH.'templates/email/admin_acc_upload.txt')
                            );
      }

      unset($MAIL_STRING,$DATA);

      updated($msg_upload8,
              'index.php?cmd=upload',
              $msg_script10,
              $msg_script9,
              $msg_charset
              );
    }
    else
    {
      header("Location: index.php?cmd=upload");
    }
  }

  include(FOLDER_PATH.'inc/header.php');
  include(FOLDER_PATH.'data_files/upload.php');
  include(FOLDER_PATH.'inc/footer.php');
  break;
  
  /*+++++++++++++++++++++++++
    + CASE: OVERVIEW        +
    + Storage Overview      +
    +++++++++++++++++++++++++*/

  case "overview":
  
  $title = $msg_header53;
      
  isWebmasterLoggedIn();
  
  if (isset($_GET['orderby']))
  {
    switch ($_GET['orderby'])
    {
      case 'least':
      $SQL = 'GROUP BY 1 ORDER BY 2,size';
      break;
      
      case 'most':
      $SQL = 'GROUP BY 1 ORDER BY 2,size DESC';
      break;
    }
  }
  
  // Over ride limit..
  $limit = (isset($_GET['display']) ? strip_tags($_GET['display']) : $SETTINGS->data_per_page);
      
  include(FOLDER_PATH.'inc/header.php');
  include(FOLDER_PATH.'data_files/overview.php');
  include(FOLDER_PATH.'inc/footer.php');
  break;  
  
  /*+++++++++++++++++++++++++
    + CASE: FTP             +
    + Add Files via FTP     +
    +++++++++++++++++++++++++*/

  case "ftp":
      
  $title = $msg_ftp;    
      
  isWebmasterLoggedIn();
      
  // Process files..
  if (isset($_POST['process']))
  {
    if (!empty($_POST['name']))
    {
      include(FOLDER_PATH.'classes/class_accounts.inc.php'); 
      $MUP_ADD          = new accounts();
      $MUP_ADD->prefix  = $database['prefix'];
      $MUP_ADD->date    = date($SETTINGS->dateformat, strtotime(($SETTINGS->time_offset=='0' ? "+0 hours" : $SETTINGS->time_offset)));
      $MAIL_STRING      = '';
      
      for ($i=0; $i<count($_POST['file']); $i++)
      {
        $ACC   = loadMemberData($_POST['account'][$i]);
        $FILE  = $MUP_ADD->get_file_prefix($_POST['file'][$i]);
        
        // Build mail string..
        $MAIL_STRING .= $msg_tempupload10.": ".($_POST['name'][$i] ? $_POST['name'][$i] : $SETTINGS->default_name).define_newline();
        $MAIL_STRING .= $msg_tempupload11.": ".$FILE.define_newline();
        $MAIL_STRING .= $msg_tempupload12.": ".file_size_conversion(filesize(RELATIVE_PATH.$SETTINGS->ftpdir.'/'.$_POST['file'][$i]),MGBS).define_newline().define_newline();
      
        // Move file from ftp dir to account folder..
        $MUP_ADD->add_ftp_file($_POST['account'][$i],
                               $FILE,
                               ($_POST['name'][$i] ? $_POST['name'][$i] : $SETTINGS->default_name),
                               filesize(RELATIVE_PATH.$SETTINGS->ftpdir.'/'.$_POST['file'][$i]),
                               $_POST['mime'][$i],
                               RELATIVE_PATH.$SETTINGS->ftpdir.'/'.$_POST['file'][$i],
                               RELATIVE_PATH.$SETTINGS->uploaddir.'/'.$ACC->accfolder.'/'.$FILE
                               );
      }
      
      // Send e-mail to account..
      if ($_POST['send'])
      {
        $MUP_MAIL->addTag('{USERNAME}',$ACC->username);
        $MUP_MAIL->addTag('{DATE}',date($SETTINGS->dateformat, strtotime(($SETTINGS->time_offset=='0' ? "+0 hours" : $SETTINGS->time_offset))));
        $MUP_MAIL->addTag('{FILES}',trim($MAIL_STRING));
        
        $MUP_MAIL->sendMail($ACC->username,
                            $ACC->email,
                            $SETTINGS->webname,
                            $SETTINGS->email,
                            '['.$SETTINGS->webname.'] '.$msg_upload9,
                            $MUP_MAIL->template(RELATIVE_PATH.'templates/email/admin_acc_upload.txt')
                            );
      }
      
      updated($msg_ftp9,
              'index.php?cmd=ftp',
              str_replace("{count}",count($_POST['file']),$msg_ftp10).'<br><br>'.$msg_script10,
              $msg_script9,
              $msg_charset
              );
      
    } else {
      header("Location: index.php?cmd=ftp");
      exit;
    }
  }

  include(FOLDER_PATH.'inc/header.php');
  include(FOLDER_PATH.'data_files/ftp.php');
  include(FOLDER_PATH.'inc/footer.php');
  break;  
      
  /*+++++++++++++++++++++++++
    + CASE: SETUP           +
    + Setup Accounts        +
    +++++++++++++++++++++++++*/

  case "setup":
      
  $title = $msg_header49;
      
  isWebmasterLoggedIn();

  // Activate Accounts
  if (isset($_POST['process']))
  {
    $acc_id  = (isset($_POST['acc_id']) ? $_POST['acc_id'] : '');
    $send    = (isset($_POST['send']) ? $_POST['send'] : 0);
           
    if (!empty($acc_id))
    {
      include(FOLDER_PATH.'classes/class_accounts.inc.php');

      for ($i=0; $i<count($acc_id); $i++)
      {
        $MUP_ACTIVATE          = new accounts();
        $MUP_ACTIVATE->prefix  = $database['prefix'];
                
        // Get member data..
        $ACC = loadMemberData($acc_id[$i]);
        
        // Activate account..
        $MUP_ACTIVATE->activation($ACC->id,$ACC->accpass);
                
        // Send e-mail..
        if ($send)
        {
          $MUP_MAIL->addTag('{USERNAME}',$ACC->username);
          $MUP_MAIL->addTag('{PASSWORD}',$ACC->accpass);
          
          $MUP_MAIL->sendMail($ACC->username,
                              $ACC->email,
                              $SETTINGS->webname,
                              $SETTINGS->email,
                              '['.$SETTINGS->webname.'] '.$msg_setup9,
                              $MUP_MAIL->template(RELATIVE_PATH.'templates/email/welcome.txt')
                              );
        }        
      }
      
      updated($msg_setup7,
              'index.php?cmd=setup',
              count($acc_id).' '.$msg_setup8.'<br><br>'.$msg_script10,
              $msg_script9,
              $msg_charset
              );
    }
    else
    {
      header("Location: index.php?cmd=setup");
      exit;
    }
  }

      include(FOLDER_PATH.'inc/header.php');
      include(FOLDER_PATH.'data_files/setup.php');
      include(FOLDER_PATH.'inc/footer.php');
      break;

  /*+++++++++++++++++++++++++
    + CASE: ACCESS          +
    + Disable Access        +
    +++++++++++++++++++++++++*/

  case "access":
  
  $title = $msg_header46;
      
  isWebmasterLoggedIn();
      
  // Update access..
  if (isset($_POST['process']))
  {
    include(FOLDER_PATH.'classes/class_accounts.inc.php');
           
    $MUP_ACCESS          = new accounts();
    $MUP_ACCESS->prefix  = $database['prefix'];
           
    $access_count        = $MUP_ACCESS->update_access($_POST);

    updated($msg_access5,
            'index.php?cmd=access',
            $access_count.' '.(!$_POST['enable'] ? $msg_access3 : $msg_access4).'<br><br>'.$msg_script10,
            $msg_script9,
            $msg_charset
            );
  }

  include(FOLDER_PATH.'inc/header.php');
  include(FOLDER_PATH.'data_files/access.php');
  include(FOLDER_PATH.'inc/footer.php');
  break;

  /*+++++++++++++++++++++++++
    + CASE: SEARCH          +
    + Search Options        +
    +++++++++++++++++++++++++*/

  case "search":
      
  $title = $msg_header20;
      
  isWebmasterLoggedIn();

  // Search Database..
  if (isset($_GET['process']))
  {
    if ($_GET['from_day'] && $_GET['from_month'] && $_GET['from_year'])
    {
      $from_date_string = $_GET['from_year'].'-'.$_GET['from_month'].'-'.$_GET['from_day'];
    }
    if ($_GET['to_day'] && $_GET['to_month'] && $_GET['to_year'])
    {
      $to_date_string = $_GET['to_year'].'-'.$_GET['to_month'].'-'.$_GET['to_day'];
    }
           
    if ($_GET['keywords']!="")
    {
      $keys              = explode(" ", $_GET['keywords']);
      $SQL_ARRAY_STRING  = '';
      $QUERY_STRING      = '';

      // Build search string..
      for($i=0; $i<count($keys); $i++)
      {
        if ($_GET['area']=='accounts')
        {
          $SQL_ARRAY_STRING .= ($i ? 'OR ' : '')."username LIKE '%".mysql_real_escape_string($keys[$i])."%' OR field_name LIKE '%".mysql_real_escape_string($keys[$i])."%' OR field_company LIKE '%".mysql_real_escape_string($keys[$i])."%' ";
        } else {
          $SQL_ARRAY_STRING .= ($i ? 'OR ' : '')."user_name LIKE '%".mysql_real_escape_string($keys[$i])."%' OR upload_name LIKE '%".mysql_real_escape_string($keys[$i])."%' OR file_name LIKE '%".mysql_real_escape_string($keys[$i])."%' ";
        }
      }
                
      // Build date string..
      if (isset($from_date_string) && isset($to_date_string))
      {
        $QUERY_STRING = $SQL_ARRAY_STRING.($_GET['area']=='accounts' ? " AND joindate BETWEEN '$from_date_string' AND '$to_date_string'" : " AND file_filter_date BETWEEN '$from_date_string' AND '$to_date_string'");
      } else {
        $QUERY_STRING = $SQL_ARRAY_STRING;
      }
                
      // Count..
      $q_search_count = mysql_query("SELECT count(*) AS s_count 
                                     FROM ".($_GET['area']=='accounts' ? $database['prefix'].'members' : $database['prefix'].'uploads')." 
                                     WHERE (".$QUERY_STRING.") 
                                     ") or die(mysql_error());          
      $COUNT = mysql_fetch_object($q_search_count);          
                
      // Search query..
      $q_search = mysql_query("SELECT * FROM ".($_GET['area']=='accounts' ? $database['prefix'].'members' : $database['prefix'].'uploads')." 
                               WHERE (".$QUERY_STRING.") 
                               LIMIT $limitvalue, $limit
                               ") or die(mysql_error());                         
      
      if (mysql_num_rows($q_search)>0)
      {
        $SEARCH_RESULTS  = true;
      } else {
        $NO_RESULTS      = true;
      }
    }
    else
    {
      header("Location: index.php?cmd=search");
      exit;
    }
  }

  include(FOLDER_PATH.'inc/header.php');
  include(FOLDER_PATH.'data_files/search.php');
  include(FOLDER_PATH.'inc/footer.php');
  break;

  /*+++++++++++++++++++++++++
    + CASE: CONTACT         +
    + Contact Members       +
    +++++++++++++++++++++++++*/

  case "contact":
  
  $title = $msg_header21;
      
  isWebmasterLoggedIn();
      
  // Contact Members..
  if (isset($_POST['process']))
  {
    // Apply call back element to trim post vars..
    $_POST = array_map('trim',$_POST);
    
    if ($_POST['subject']=='') {
      $error_string[] = $msg_contact6;
    }
    if ($_POST['comments']=='') {
      $error_string[] = $msg_contact7;
    }
    if (!empty($error_string))
    {
      error($msg_script12,
            $msg_script11,
            $msg_charset,
            $error_string
            );
    } else {
      
      $q_member = mysql_query("SELECT * FROM ".$database['prefix']."members
                               ".($_POST['type']!='all' ? 'WHERE accid=\''.$_POST['type'].'\'' : '')."
                               ") or die(mysql_error());
      
      while ($MEMBER = mysql_fetch_object($q_member))
      {
        $MUP_MAIL->sendMail($MEMBER->username,
                            $MEMBER->email,
                            $SETTINGS->webname,
                            $SETTINGS->email,
                            '['.$SETTINGS->webname.'] '.$_POST['subject'],
                            str_replace("%NAME",$MEMBER->username,$_POST['comments'])
                            );
      }                                            
      
      
      updated($msg_contact14,
              'index.php?cmd=contact',
              mysql_num_rows($q_member).' '.$msg_addcontact3.'<br><br>'.$msg_script10,
              $msg_script9,
              $msg_charset
              );
    }
  }

  include(FOLDER_PATH.'inc/header.php');
  include(FOLDER_PATH.'data_files/contact.php');
  include(FOLDER_PATH.'inc/footer.php');
  break;

  /*+++++++++++++++++++++++++
    + CASE: CREATECSV       +
    + Create CSV File       +
    +++++++++++++++++++++++++*/

  case "createcsv":
      
  $title = $msg_header22;    
      
  isWebmasterLoggedIn();
      
  // Create CSV File..
  if (isset($_POST['process']))
  {
    $csvdata  = (isset($_POST['csvdata']) ? $_POST['csvdata'] : '');
           
    if (!empty($csvdata))
    {
      include(FOLDER_PATH.'classes/class_csvdump.inc.php');

      $MUP_CSV          = new csvDump();
      $MUP_CSV->prefix  = $database['prefix'];
      $MUP_CSV->fields  = $csvdata;
      $MUP_CSV->sql     = ($_POST['type']=="all" ? '' : " WHERE accid = '".$_POST['type']."'");
                
      $MUP_CSV->dump();
      exit;
    }
    else
    {
      header("Location: index.php?cmd=createcsv");
    }
  }

  include(FOLDER_PATH.'inc/header.php');
  include(FOLDER_PATH.'data_files/createcsv.php');
  include(FOLDER_PATH.'inc/footer.php');
  break;

  /*+++++++++++++++++++++++++
    + CASE: BACKUP          +
    + Create Backup         +
    +++++++++++++++++++++++++*/

  case "backup":
      
  $title = $msg_header23;    
      
  if (!isset($_COOKIE['uploader_cookie']) && !isset($_SESSION['uploader_user'])) {
   header("Location: index.php?cmd=login");
   exit;
  }

  // Backup Database
  if (isset($_POST['process']))
  {
    $table      = (isset($_POST['table']) ? $_POST['table'] : '');
    $structure  = (isset($_POST['structure']) ? 1 : 0);
    $compress   = (isset($_POST['compress']) ? 1 : 0);
           
    if (!empty($table))
    {
      include(FOLDER_PATH.'classes/class_backup.inc.php');
                
      $MUP_BACKUP               = new SQL_Backup();
      $MUP_BACKUP->dbname       = $database['database'];
      $MUP_BACKUP->scriptname   = $msg_script.' '.$msg_script2;
      $MUP_BACKUP->sqltables    = $table;
      $MUP_BACKUP->struct_only  = (isset($_POST['structure']) ? true : false);
      $MUP_BACKUP->compress     = (isset($_POST['compress']) ? true : false);
      $MUP_BACKUP->newline      = define_newline();
                
      $MUP_BACKUP->perform_backup();
                
      exit;
    }
    else
    {
      header("Location: index.php?cmd=backup");
    }
  }

  include(FOLDER_PATH.'inc/header.php');
  include(FOLDER_PATH.'data_files/backup.php');
  include(FOLDER_PATH.'inc/footer.php');
  break;
      
  /*+++++++++++++++++++++++++
    + CASE: LOGIN           +
    + Admin Login           +
    +++++++++++++++++++++++++*/

  case "login":
      
  if (isset($_COOKIE['uploader_cookie']) || isset($_SESSION['uploader_user'])) {
    header("Location: index.php");
    exit;
  }
      
  // Login
  if (isset($_POST['process']))
  {
    include(FOLDER_PATH.'inc/password.inc.php');

    if (encrypt($admin_username) != encrypt($_POST['user'])) {
      $error_string[] = $msg_login4;
    }
    if (encrypt($admin_password) != encrypt($_POST['pass'])) {
      $error_string[] = $msg_login5;
    }
    if ($error_string)
    {
      error($msg_script12,
            $msg_script11,
            $msg_charset,
            $error_string
            );
    } else {
      $_SESSION['uploader_user'] = $_POST['user'];
      $_SESSION['uploader_pass'] = $_POST['pass'];

      if (isset($_POST['cookie'])) {
        setcookie($database['cookieName'], encrypt($database['cookieKey']), time()+60*60*24*30);
      }
    }
           
    header("Location: index.php?cmd=home");
  }

  include(FOLDER_PATH.'inc/header.php');
  include(FOLDER_PATH.'data_files/login.php');
  include(FOLDER_PATH.'inc/footer.php');
  break;

  /*+++++++++++++++++++++++++
    + CASE: LOGOUT          +
    + Admin Logout          +
    +++++++++++++++++++++++++*/

  case "logout":
      
  session_unset();
  session_destroy();

  if (isset($_COOKIE[$database['cookieName']])) {
    setcookie($database['cookieName'], "");
  }

  unset ($_SESSION);

  header("Location: index.php?cmd=login");
      
  break; 
}

?>
