<?php

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  Script: Maian Uploader v4.0
  Written by: David Ian Bennett
  E-Mail: support@maianscriptworld.co.uk
  Website: http://www.maianscriptworld.co.uk

  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  
  This File: class_uploader.inc.php
  Description: File Upload Class

  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/


class uploader extends genericOptions {
                  
                                       var $name;
                                       var $size;
                                       var $temp;
                                       var $type;
                                       var $max_size;
                                       var $storage;
                                       var $prefix;
                                       var $username;
                                       var $email;
                                       var $folder;
                                       var $folder_main;
                                       var $file_types;
                                       var $allowed_storage;
                                       var $date;
                                       var $img_width;
                                       var $img_height;
                                       var $width;
                                       var $height;
                                       var $id;
                                       var $filename;
                                       var $mgbs;

                                       //======================================
                                       // FUNCTION: CHECK_FILE_SIZE()
                                       // Desc: Check if file size is valid
                                       // Parameters: 0
                                       //======================================

                                       function check_file_size()
                                       {
                                          if ($this->size <=$this->max_size) {
                  	                       return true;
             	                            } else {
                                           return false;
                                          }
                                       }

                                       //======================================
                                       // FUNCTION: CHECK_FILE_EXISTS()
                                       // Desc: Check if file exists
                                       // Parameters: 0
                                       //======================================

                                       function check_file_exists()
                                       {
                                         if (file_exists($this->folder_main."/".$this->folder."/".$this->name)) {
                  	                      return true;
                  	                     } else {
                                          return false;
                                         }
                                       }
                  
                                       //======================================
                                       // FUNCTION: CHECK_TYPE()
                                       // Desc: Checks file type is valid
                                       // Parameters: 0
                                       //======================================

                                       function check_type()
                                       {
                                         $types  = explode(",", $this->file_types);
                  	                     
                                         if (in_array(strrchr($this->name, '.'), $types)) {
                                          return true;
                                         } else {
                                          return false;
                                         }
                                       }
                                       
                                       //======================================
                                       // FUNCTION: CLEARTEMP_FILE
                                       // Desc: Clears the temporary file
                                       // Param: 1
                                       //======================================
                                       
                                       function clear_temp_file($file)
                                       {
                                         if (file_exists($file)) {
                                          unlink($file);
                                         }
                                       }

                                       //======================================
                                       // FUNCTION: CHECK_UPLOAD_SIZE()
                                       // Desc: Checks if space is available
                                       // Parameters: 0
                                       //======================================

                                       function check_upload_size()
                                       {
                                         $allowed_storage   = $this->allowed_storage * $this->mgbs;
                  	                     $new_storage_size  = $this->size + $this->storage;
                  	                    
                  	                     if ($new_storage_size <= $allowed_storage) {
                  	                      return true;
                  	                     } else {
                        	                return false;
                                         }
                                       }
                  
                                       //======================================
                                       // FUNCTION: GET_FILE_PREFIX()
                                       // Desc: Adds prefix if file exists
                                       // Parameters: 0
                                       //======================================

                                       function get_file_prefix()
                                       {
                                         return substr(md5(uniqid(rand(),1)),3,4)."_".$this->name;
                                       }
                                       
                                       //======================================
                                       // FUNCTION: IMAGE_RESIZER()
                                       // Desc: If enabled resizes images
                                       // Parameters: 2
                                       //======================================

                                       function image_resizer($name,$debug_mode)
                                       {
                                         // If debug mode is enabled, returns true and adds no data..
                                         // For development only..
                                         if ($debug_mode) { return true; }
                                         
                                         $img_file = $this->folder_main.'/'.$this->folder.'/'.$name;

             	                           // Get original image width and height..
             	                           $image_data  = getimagesize($img_file);
                                         $img         = imagecreatefromjpeg($img_file);

                                         if ($img && $image_data[0]>$this->width && $image_data[1]>$this->height)
                                         {
                                           $i_width    = imagesx($img);
                   	                       $i_height   = imagesy($img);
                                           $scale      = min($this->img_width/$i_width, $this->img_height/$i_height);

                   	                       // For thumbnail, maintain aspect ratio of original image
                   	                       // If image is smaller or equal to new sizes, no resize is necessary

                                           if ($scale<1)
                   	                       {
                   	                         $new_width    = floor($scale * $i_width);
                   	 	                       $new_height   = floor($scale * $i_height);
                   	 	                       $tmp_img      = imagecreatetruecolor($new_width,$new_height);

                                             imagecopyresampled($tmp_img,$img,0,0,0,0,$new_width,$new_height,$i_width,$i_height);
                                             imagejpeg($tmp_img, $this->folder_main.'/'.$this->folder.'/'.$name);
                                             imagedestroy($img);
                                             imagedestroy($tmp_img);

                                             if (file_exists($this->folder_main.'/'.$this->folder.'/'.$name)) {
                                              return true;
                                             } else {
                                              return false;
                                             }
                                            } else {
                                              imagedestroy($img);
                                              return false;
                                            }
                                          } else {
                                            imagedestroy($img);
                                            return false;
                                          }
                                       }

                                       //======================================
                                       // FUNCTION: UPDATE_LOCK_LIMIT()
                                       // Desc: Increment lock limit
                                       // Parameters: 1
                                       //======================================
                                       
                                       function update_lock_limit($id)
                                       {
                                         $query = mysql_query("SELECT * FROM ".$this->prefix."members 
                                                               WHERE id = '$id'
                                                               LIMIT 1") or die(mysql_error());
                                         $MEMBER = mysql_fetch_object($query);
                                         
                                         if ($MEMBER->locklimit>0)
                                         {
                                           mysql_query("UPDATE ".$this->prefix."members SET
                                                        lockattempts = (lockattempts+1)
                                                        WHERE id     = '$id'
                                                        LIMIT 1") or die(mysql_error());
                                         }
                                         
                                       }
                                       
                                       //======================================
                                       // FUNCTION: UPLOAD_FILE()
                                       // Desc: Upload file to directory
                                       // Parameters: 2
                                       //======================================
                                       
                                       function upload_file($name,$debug_mode)
                                       {
                                         // If debug mode is enabled, returns true and adds no data..
                                         // For development only..
                                         if ($debug_mode) { return true; }
                                         
                                         if (is_writeable($this->folder_main.'/'.$this->folder))
                                         {
                                           if (is_uploaded_file($this->temp)) {
                                            move_uploaded_file($this->temp, $this->folder_main.'/'.$this->folder.'/'.$name);
                                            @chmod($this->folder_main.'/'.$this->folder.'/'.$name, 0644);
                                           }
                                           
                                           if (file_exists($this->folder_main.'/'.$this->folder.'/'.$name)) {
                                            if (file_exists($this->temp)) {
                                             unlink($this->temp);
                                            }
                                            return true;
                                           } else {
                                            return false;
                                           }
                                          } else {
                                            return false;
                                          }
                                       }
                                       
                                       //======================================
                                       // FUNCTION: MOVE_FTP_FILE()
                                       // Desc: Move file to account folder
                                       // Parameters: 2
                                       // Added in v4.0
                                       //======================================

                                       function move_ftp_file($dir,$file)
                                       {
                                         rename($this->folder_main.'/'.$this->folder.'/'.$dir.'/'.$file,
                                                $this->folder_main.'/'.$this->folder.'/'.$this->filename);
                                                
                                         if (file_exists($this->folder_main.'/'.$this->folder.'/'.$this->filename)) 
                                         {
                                           mysql_query("INSERT INTO ".$this->prefix."uploads (
                                                        user_id,
                                                        user_name,
                                                        user_email,
                                                        upload_name,
                                                        file_name,
                                                        file_size,
                                                        file_type,
                                                        file_date,
                                                        file_filter_date,
                                                        admin_status,
                                                        folder_name
                                                        ) VALUES (
                                                        '".$this->id."',
                                                        '".$this->username."',
                                                        '".$this->email."',
                                                        '".$this->filename."',
                                                        '".$this->add_slashes($this->char_entities($this->name))."',
                                                        '".$this->size."',
                                                        '".$this->type."',
                                                        '".$this->date."',
                                                        '".date("Y-m-d")."',
                                                        '0',
                                                        '".$this->folder."'
                                                        )") or die(mysql_error());
                                                        
                                           // Update uni code..guaranteed to be random by appending file id..
                                           // This was added in v4.0..
                                           $uni = substr(mysql_insert_id().rand(500,999).substr(md5(uniqid(rand(),1)),3,100),0,50);
                                         
                                           mysql_query("UPDATE ".$this->prefix."uploads SET
                                                        uni_code  = '$uni'
                                                        WHERE id  = '".mysql_insert_id()."'
                                                        LIMIT 1
                                                        ") or die(mysql_error());              
                                                        
                                           // Check to make sure original file doesn`t exist..
                                           if (file_exists($this->folder_main.'/'.$this->folder.'/'.$dir.'/'.$file))
                                           {
                                             unlink($this->folder_main.'/'.$this->folder.'/'.$dir.'/'.$file);
                                           } 
                                           
                                           return true;
                                           
                                         } else {
                                           return false;
                                         }
                                       }

                                       //======================================
                                       // FUNCTION: INSERT_SQL()
                                       // Desc: Adds upload info to database
                                       // Parameters: 2
                                       //======================================

                                       function insert_sql($name,$debug_mode,$default)
                                       {
                                         // If debug mode is enabled, returns true and adds no data..
                                         // For development only..
                                         if ($debug_mode) { return true; }
                                         
                                         mysql_query("INSERT INTO ".$this->prefix."uploads (
                                                      user_id,
                                                      user_name,
                                                      user_email,
                                                      upload_name,
                                                      file_name,
                                                      file_size,
                                                      file_type,
                                                      file_date,
                                                      file_filter_date,
                                                      admin_status,
                                                      folder_name
                                                      ) VALUES (
                                                      '".$this->id."',
                                                      '".$this->username."',
                                                      '".$this->email."',
                                                      '".$name."',
                                                      '".($this->filename ? $this->add_slashes($this->char_entities($this->filename)) : $this->add_slashes($this->char_entities($default)))."',
                                                      '".$this->size."',
                                                      '".$this->type."',
                                                      '".$this->date."',
                                                      '".date("Y-m-d")."',
                                                      '0',
                                                      '".$this->folder."'
                                                      )") or die(mysql_error());
                                                      
                                         // Update uni code..guaranteed to be random by appending file id..
                                         // This was added in v4.0..
                                         $uni = substr(mysql_insert_id().rand(500,999).substr(md5(uniqid(rand(),1)),3,100),0,50);
                                         
                                         mysql_query("UPDATE ".$this->prefix."uploads SET
                                                      uni_code  = '$uni'
                                                      WHERE id  = '".mysql_insert_id()."'
                                                      LIMIT 1
                                                      ") or die(mysql_error());           
                                       }
}

?>
