<?php

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  Script: Maian Uploader v4.0
  Written by: David Ian Bennett
  E-Mail: support@maianscriptworld.co.uk
  Website: http://www.maianscriptworld.co.uk

  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  
  This File: class_paypal.inc.php
  Description: Paypal Process Class
  Original code written by: 
   scriptdevelopers.net & Micah Carrick
  Modified by: David Ian Bennett

  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

class paypalIPN extends genericOptions {
        
                                         var $paypal_post_vars;
                                         var $paypal_response;
	                                       var $protocol;
	                                       var $url_string;
                                         var $timeout;
                                         var $error_log_file = 'log/paypal_errors.txt';
                                         var $fields         = array();
                                         var $error_email;
                                         var $prefix;
                                         
                                         //======================================
                                         // FUNCTION: paypalIPN()
                                         // Desc: Class Constructor
                                         // Parameters: 3
                                         //======================================

                                         function paypalIPN($paypal_post_vars,$settings,$protocol="s")
                                         {
                                           $this->paypal_post_vars  = $paypal_post_vars;
		                                       $this->timeout           = 120;
		                                       $this->url_string        = "http".$protocol.($settings->paypal_test ? '://www.sandbox.paypal.com/cgi-bin/webscr?' : '://www.paypal.com/cgi-bin/webscr?');
                                         }

                                         //======================================
                                         // FUNCTION: SEND_RESPONSE()
                                         // Desc: Send data back to Paypal
                                         // Parameters: 0
                                         //======================================

                                         function send_response()
                                         {
                                           foreach($this->paypal_post_vars AS $key => $value)
                                           {
                                             $values[] = $key.'='.urlencode($this->strip_slashes($value));
                                           }
                                             
                                           $this->url_string .= @implode("&", $values);
                                           $this->url_string .= "&cmd=_notify-validate";

                                           $ch = curl_init();
                                           curl_setopt ($ch, CURLOPT_URL, $this->url_string);
                                           curl_setopt ($ch, CURLOPT_USERAGENT, "Mozilla/4.0 (compatible; www.ScriptDevelopers.NET; PayPal IPN Class)");
                                           curl_setopt ($ch, CURLOPT_HEADER, 1);
                                           curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
                                           
                                           // Prevent basedir & safe mode errors..
                                           if (ini_get('open_basedir') == '' && ini_get('safe_mode' == 'Off')) {
                                           curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
                                           }
                                           
                                           curl_setopt ($ch, CURLOPT_TIMEOUT, $this->timeout);
                                           $this->paypal_response = curl_exec ($ch);
                                           curl_close($ch);
                                         }

                                         //======================================
                                         // FUNCTION: IS_VERIFIED()
                                         // Desc: Logs data if payment verified
                                         // Parameters: 0
                                         //======================================

                                         function is_verified()
                                         {
                                           if(ereg("VERIFIED", $this->paypal_response)) {
                                             return true;
                                           } else {
                                             return false;
                                           }
                                         }

                                         //======================================
                                         // FUNCTION: GET_PAYMENT_STATUS()
                                         // Desc: Returns payment status
                                         // Parameters: 0
                                         //======================================

                                         function get_payment_status()
                                         {
                                           return $this->paypal_post_vars['payment_status'];
                                         }
                  
                                         //=========================================
                                         // FUNCTION: activate_subscription()
                                         // Desc: Activates subscription
                                         // Parameters: 3
                                         //=========================================

                                         function activate_subscription($DATA,$ACC,$TYPE)
                                         {
                                           mysql_query("UPDATE ".$this->prefix."members SET
                                                        subscription   = '1',
                                                        subscr_access  = '1',  
                                                        subscr_time    = '".$TYPE->billing_no."|".$TYPE->billing_time."',
                                                        subscr_date    = '".date("Y-m-d")."',
                                                        subscr_cancel  = '0000-00-00',
                                                        subscr_expiry  = '".date("Y-m-d", strtotime("+ ".$TYPE->billing_no." ".$TYPE->billing_time."s"))."',
                                                        subscr_cost    = '".$TYPE->cost."',
                                                        subscr_id      = '".$DATA['subscr_id']."'
                                                        WHERE id       = '".$ACC->id."'
                                                        LIMIT 1
                                                        ") or die(mysql_error());
                                         }
                                         
                                         //=========================================
                                         // FUNCTION: update_subscription()
                                         // Desc: Updates subscription
                                         // Parameters: 2
                                         //=========================================

                                         function update_subscription($ACC,$TYPE)
                                         {
                                           mysql_query("UPDATE ".$this->prefix."members SET
                                                        subscr_expiry  = '".date("Y-m-d", strtotime("+ ".$TYPE->billing_no." ".$TYPE->billing_time."s"))."'
                                                        WHERE id       = '".$ACC->id."'
                                                        LIMIT 1
                                                        ") or die(mysql_error());
                                         }
                                      
                                         //=========================================
                                         // FUNCTION: cancel_subscription()
                                         // Desc: Cancels subscription
                                         // Parameters: 1
                                         //=========================================

                                         function cancel_subscription($ACC)
                                         {
                                           mysql_query("UPDATE ".$this->prefix."members SET
                                                        subscr_access  = '".(date("Y-m-d")==$ACC->subscr_expiry ? '0' : '1')."',  
                                                        subscr_cancel  = '".date("Y-m-d")."'
                                                        WHERE id       = '".$ACC->id."'
                                                        LIMIT 1
                                                        ") or die(mysql_error());
                                         }
                        
                                         //=========================================
                                         // FUNCTION: ipnData()
                                         // Desc: Gets ipn data for member
                                         // Parameters: 1
                                         //=========================================
                                         
                                         function ipnData($member,$fetch=false)
                                         {
                                           $query = mysql_query("SELECT *,DATE_FORMAT(ipn_date,'%e %M %Y') AS i_date 
                                                                 FROM ".$this->prefix."payipn
                                                                 WHERE ipn_user = '$member' 
                                                                 LIMIT 1
                                                                 ") or die(mysql_error());
                                           
                                           if (mysql_num_rows($query)>0) {
                                             return ($fetch ? mysql_fetch_object($query) : true);
                                           } else {
                                             return false;
                                           }
                                         }
                                         
                                         //======================================
                                         // FUNCTION: ERROR_OUT()
                                         // Desc: Logs error messages
                                         // Parameters: 6
                                         //======================================

                                         function error_out($message2,$subject,$subject2,$subject4,$name,$log)
                                         {
                                           $date     = date("D M j G:i:s T Y", time());
                                           $message  = '';
                                              
                                           $message .= "\n\n".$subject4."\n\n";

                                           reset($this->paypal_post_vars);

                                           while(list($key,$value) = each($this->paypal_post_vars) )
                                           {
                                             $message .= $key.':'." \t$value\n";
                                           }

		                                       $message .= "\n\n".$this->url_string."\n\n".$this->paypal_response."\n\n";
		                                       $message .= $subject2;

                                           if($log)
                                           {
                                             $fp = fopen($this->error_log_file, 'ab');
                                             fwrite($fp, $message);
                                             fclose($fp);

                                             mail($this->error_email, "[".$date."]"." ".$subject, $message, "From:".$name."<".$this->error_email.">");
                                           }

		                                       exit;
                                         }

                                         //======================================
                                         // FUNCTION: ADD_FIELD()
                                         // Desc: Assigns user data
                                         // Parameters: 2
                                         //======================================
                  
                                         function add_field($field,$value)
                                         {
                                           $this->fields["$field"] = $value;
                                         }
                  
                                         //======================================
                                         // FUNCTION: LOADHIDDENFIELDS()
                                         // Desc: Loads processing screen
                                         // Parameters: 0
                                         //======================================

                                         function loadHiddenFields()
                                         {
                                           $html = '';
                                           
                                           foreach ($this->fields AS $name => $value) { 
                                             $html .= '<input type="hidden" name="'.$name.'" value="'.$this->strip_slashes($value).'">'."\n";
                                           }

                                           return $html;
                                         }
                                         
                                         //======================================
                                         // FUNCTION: IPN_SQL()
                                         // Desc: Logs IPN data in database
                                         // Parameters: 3
                                         //======================================
                                         
                                         function ipn_sql($DATA,$username,$status)
                                         {
                                           if ($_POST['address_street']) {
                                             $address = $DATA['address_street'].$this->newline().$DATA['address_city'].$this->newline().$DATA['address_state'].$this->newline().$DATA['address_zip'].$this->newline().$DATA['address_country'];
                                           }

                                           mysql_query("INSERT INTO ".$this->prefix."payipn (
                                                        ipn_user,
                                                        ipn_date,
                                                        ipn_name,
                                                        ipn_iname,
                                                        ipn_number,
                                                        ipn_address,
                                                        ipn_email,
                                                        ipn_status,
                                                        ipn_txnid,
                                                        ipn_pending,
                                                        ipn_gross,
                                                        ipn_fee,
                                                        ipn_currency,
                                                        ipn_memo
                                                        ) VALUES (
                                                        '".$username."',
                                                        '".date("Y-m-d")."',
                                                        '".$this->add_slashes($this->char_entities($DATA['first_name'])).' '.$this->add_slashes($this->char_entities($DATA['last_name']))."',
                                                        '".$this->add_slashes($this->char_entities($DATA['item_name']))."',
                                                        '".$DATA['item_number']."',
                                                        '".(isset($address) ? $this->add_slashes($this->char_entities($address)) : '')."',
                                                        '".$DATA['payer_email']."',
                                                        '".$status."',
                                                        '".(isset($DATA['subscr_id']) ? $DATA['subscr_id'] : $DATA['txn_id'])."',
                                                        '".$DATA['pending_reason']."',
                                                        '".$DATA['mc_gross']."',
                                                        '".$DATA['mc_fee']."',
                                                        '".$DATA['mc_currency']."',
                                                        '".$this->add_slashes($this->char_entities($DATA['memo']))."'
                                                        )") or die(mysql_error());
                                         }
}

?>
