-- 
-- Table structure for table 'mu_acctypes'
-- 

CREATE TABLE mu_acctypes (
  id int(3) NOT NULL auto_increment,
  dateStamp TIMESTAMP(14),
  accname varchar(50) NOT NULL default '',
  cost varchar(10) NOT NULL default '0',
  currency char(3) NOT NULL default '',
  itemcode varchar(10) NOT NULL default '',
  filetypes text NOT NULL,
  uploadmax int(10) unsigned NOT NULL default '0',
  fileprefix enum('0','1') NOT NULL default '0',
  codegen enum('0','1') NOT NULL default '0',
  webspace int(10) unsigned NOT NULL default '0',
  maxuploads int(2) NOT NULL default '1',
  banners enum('0','1') NOT NULL default '0',
  imageresize enum('0','1') NOT NULL default '0',
  imgwatermarks enum('0','1') NOT NULL default '0',
  viewfiles varchar(4) NOT NULL default 'no',
  contact enum('0','1') NOT NULL default '0',
  zipcompress enum('0','1') NOT NULL default '0',
  folderprefix varchar(10) NOT NULL default '',
  allowaccess enum('0','1') NOT NULL default '1',
  subscription enum('0','1') NOT NULL default '1',
  billing_cycle enum('0','1') NOT NULL default '1',
  billing_no tinyint(2) NOT NULL default '0',
  billing_time varchar(5) NOT NULL default '',
  rename_files enum('0','1') NOT NULL default '1',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

-- 
-- Table structure for table 'mu_banners'
-- 

CREATE TABLE mu_banners (
  id int(5) NOT NULL auto_increment,
  b_name varchar(75) NOT NULL default '',
  b_url text NOT NULL,
  b_google text NOT NULL,
  b_file varchar(50) NOT NULL default '',
  b_date TIMESTAMP(14),
  b_clicks int(10) unsigned NOT NULL default '0',
  b_display varchar(100) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

-- 
-- Table structure for table 'mu_ipaddresses'
-- 

CREATE TABLE mu_ipaddresses (
  id int(5) NOT NULL auto_increment,
  ipaddress varchar(30) NOT NULL default '',
  PRIMARY KEY  (id),
  UNIQUE KEY ipaddress (ipaddress)
) TYPE=MyISAM;

-- 
-- Table structure for table 'mu_members'
-- 

CREATE TABLE mu_members (
  id int(7) NOT NULL auto_increment,
  joindate date NOT NULL default '0000-00-00',
  sign_date varchar(50) NOT NULL default '',
  joinstamp TIMESTAMP(14),
  username varchar(15) NOT NULL default '',
  email varchar(200) NOT NULL default '',
  accpass varchar(32) NOT NULL default '',
  accname varchar(50) NOT NULL default '',
  accid int(5) NOT NULL default '0',
  accfolder varchar(30) NOT NULL default '',
  itemcode varchar(10) NOT NULL default '',
  cost varchar(10) NOT NULL default '0',
  currency char(3) NOT NULL default '',
  filetypes text NOT NULL,
  uploadmax int(10) unsigned NOT NULL default '0',
  fileprefix enum('0','1') NOT NULL default '0',
  codegen enum('0','1') NOT NULL default '0',
  webspace int(10) unsigned NOT NULL default '0',
  maxuploads int(5) NOT NULL default '1',
  banners enum('0','1') NOT NULL default '0',
  imageresize enum('0','1') NOT NULL default '0',
  imgwatermarks enum('0','1') NOT NULL default '0',
  `unicode` varchar(20) NOT NULL default '',
  activate enum('0','1') NOT NULL default '0',
  viewfiles varchar(4) NOT NULL default 'no',
  contact enum('0','1') NOT NULL default '0',
  zipcompress enum('0','1') NOT NULL default '0',
  rename_files enum('0','1') NOT NULL default '1',
  allowaccess enum('0','1') NOT NULL default '1',
  adminban enum('0','1') NOT NULL default '0',
  ip varchar(50) NOT NULL default '',
  bannerclicks int(10) unsigned NOT NULL default '0',
  news enum('0','1') NOT NULL default '0',
  field_company text NOT NULL,
  field_name text NOT NULL,
  field_address text NOT NULL,
  field_tel varchar(25) NOT NULL default '',
  field_fax varchar(25) NOT NULL default '',
  field_mobile varchar(25) NOT NULL default '',
  field_location varchar(100) NOT NULL default '',
  locklimit int(5) NOT NULL default '0',
  lockattempts int(5) NOT NULL default '0',
  ftp_enable enum('0','1') NOT NULL default '0',
  ftp_folder varchar(250) NOT NULL default '',
  ftp_host varchar(250) NOT NULL default '',
  ftp_user varchar(250) NOT NULL default '',
  ftp_pass varchar(250) NOT NULL default '',
  subscription enum('0','1') NOT NULL default '0',
  subscr_access enum('0','1') NOT NULL default '0',
  subscr_time varchar(50) NOT NULL default '',
  subscr_date date NOT NULL default '0000-00-00',
  subscr_cancel date NOT NULL default '0000-00-00',
  subscr_expiry date NOT NULL default '0000-00-00',
  subscr_cost varchar(10) NOT NULL default '0',
  subscr_id char(19) NOT NULL default '',
  PRIMARY KEY  (id),
  UNIQUE KEY username (username),
  UNIQUE KEY email (email)
) TYPE=MyISAM;

-- 
-- Table structure for table 'mu_news'
-- 

CREATE TABLE mu_news (
  id int(3) NOT NULL auto_increment,
  news_date TIMESTAMP(14),
  news_title varchar(150) NOT NULL default '',
  news_type varchar(50) NOT NULL default '',
  news_comments text NOT NULL,
  news_code varchar(50) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

-- 
-- Table structure for table 'mu_payipn'
-- 

CREATE TABLE mu_payipn (
  id int(5) NOT NULL auto_increment,
  ipn_user varchar(15) NOT NULL default '',
  ipn_date date NOT NULL default '0000-00-00',
  ipn_name varchar(128) NOT NULL default '',
  ipn_iname varchar(127) NOT NULL default '',
  ipn_number varchar(127) NOT NULL default '',
  ipn_address text NOT NULL,
  ipn_email varchar(127) NOT NULL default '',
  ipn_status varchar(20) NOT NULL default '',
  ipn_txnid varchar(17) NOT NULL default '',
  ipn_pending varchar(20) NOT NULL default '',
  ipn_gross varchar(20) NOT NULL default '',
  ipn_fee varchar(20) NOT NULL default '',
  ipn_currency char(3) NOT NULL default '',
  ipn_memo text NOT NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

-- 
-- Table structure for table 'mu_readnews'
-- 

CREATE TABLE mu_readnews (
  id int(8) NOT NULL auto_increment,
  news_code varchar(50) NOT NULL default '',
  member int(7) NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

-- 
-- Table structure for table 'mu_settings'
-- 

CREATE TABLE mu_settings (
  id tinyint(1) NOT NULL auto_increment,
  webname text NOT NULL,
  email varchar(100) NOT NULL default '',
  url varchar(200) NOT NULL default '',
  `language` varchar(20) NOT NULL default 'english.php',
  dateStamp TIMESTAMP(14),
  dateformat varchar(20) NOT NULL default 'D j M Y, G:ia',
  time_offset varchar(10) NOT NULL default '',
  uploaddir varchar(15) NOT NULL default '',
  ftpdir varchar(15) NOT NULL default '',
  `enable` enum('0','1') NOT NULL default '1',
  setuptype enum('0','1') NOT NULL default '1',
  passpref enum('0','1') NOT NULL default '1',
  sameip enum('0','1') NOT NULL default '0',
  autoindex enum('0','1') NOT NULL default '0',
  mail_notify enum('0','1') NOT NULL default '1',
  mail_message enum('0','1') NOT NULL default '1',
  max_width varchar(10) NOT NULL default '',
  max_height varchar(10) NOT NULL default '',
  new_width varchar(10) NOT NULL default '',
  new_height varchar(10) NOT NULL default '',
  watermarks enum('0','1') NOT NULL default '0',
  watertext varchar(50) NOT NULL default '',
  waterhspace int(3) NOT NULL default '0',
  watervspace int(3) NOT NULL default '0',
  waterfont varchar(7) NOT NULL default '',
  watersize int(2) NOT NULL default '0',
  watertextr int(3) NOT NULL default '0',
  watertextg int(3) NOT NULL default '0',
  watertextb int(3) NOT NULL default '0',
  waterangle int(2) NOT NULL default '0',
  paypal_ipn enum('0','1') NOT NULL default '0',
  paypal_email varchar(200) NOT NULL default '',
  paypal_error enum('0','1') NOT NULL default '0',
  paypal_test enum('0','1') NOT NULL default '0',
  mime_view text NOT NULL,
  mime_download text NOT NULL,
  mime_media text NOT NULL,
  url_signup text NOT NULL,
  url_accthanks text NOT NULL,
  url_accpending text NOT NULL,
  url_account text NOT NULL,
  url_login text NOT NULL,
  url_success text NOT NULL,
  url_error text NOT NULL,
  url_ipbanned text NOT NULL,
  url_ppthanks text NOT NULL,
  url_ppcancel text NOT NULL,
  smtp enum('0','1') NOT NULL default '0',
  smtp_host varchar(100) NOT NULL default 'localhost',
  smtp_user varchar(100) NOT NULL default '',
  smtp_pass varchar(100) NOT NULL default '',
  smtp_port varchar(100) NOT NULL default '25',
  email_links enum('0','1') NOT NULL default '0',
  pass_update enum('0','1') NOT NULL default '0',
  captcha_code enum('0','1') NOT NULL default '0',
  thumb_width int(3) NOT NULL default '0',
  thumb_height int(3) NOT NULL default '0',
  file_seperator varchar(5) NOT NULL default '',
  default_name varchar(20) NOT NULL default '',
  per_page_options varchar(150) NOT NULL default '',
  data_per_page int(3) NOT NULL default '0',
  greybox enum('0','1') NOT NULL default '0',
  image_width int(3) NOT NULL default '0',
  image_height int(3) NOT NULL default '0',
  enable_flv enum('0','1') NOT NULL default '0',
  enable_mp3 enum('0','1') NOT NULL default '0',
  terms mediumtext NOT NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

-- 
-- Dumping data for table 'mu_settings'
-- 

INSERT INTO mu_settings (id, webname, email, url, language, dateStamp, dateformat, time_offset, 
                         uploaddir, ftpdir, enable, setuptype, passpref, sameip, autoindex, mail_notify, 
                         mail_message, max_width, max_height, new_width, new_height, watermarks, watertext, 
                         waterhspace, watervspace, waterfont, watersize, watertextr, watertextg, watertextb, 
                         waterangle, paypal_ipn, paypal_email, paypal_error, paypal_test, mime_view, mime_download, 
                         mime_media, url_signup, url_accthanks, url_accpending, url_account, url_login, url_success, 
                         url_error, url_ipbanned, url_ppthanks, url_ppcancel, smtp, smtp_host, smtp_user, smtp_pass, 
                         smtp_port, email_links, pass_update, captcha_code, thumb_width, thumb_height, file_seperator, 
                         default_name, per_page_options, data_per_page, greybox, image_width, image_height, enable_flv, 
                         enable_mp3, terms) VALUES (1, 'Website Name', 'you@yoursite.com', 
                         'http://www.yoursite.com/uploader', 'english.php', now(), 'D j M Y, G:ia', '0', 'user_uploads', 
                         'ftp', '1', '1', '0', '0', '1', '1', '1', '700', '500', '640', '480', '1', 'Test Watermark', 
                         150, 150, 'arial', 12, 255, 255, 255, 35, '1', 'business@yoursite.com', '0', '0', 
                         'image/bmp\r\nimage/bmp\r\nimage/x-windows-bmp\r\nimage/gif\r\nimage/x-icon\r\nimage/jpeg\r\nimage/pjpeg\r\nimage/png\r\nimage/tiff\r\nimage/x-tiff', 
                         'application/pdf\r\napplication/zip\r\nmultipart/x-zip\r\napplication/x-gzip\r\nmultipart/x-gzip\r\napplication/x-compressed\r\napplication/x-zip-compressed\r\napplication/x-tar\r\napplication/octet-stream\r\napplication/wordperfect\r\napplication/wordperfect6.0\r\napplication/msword', 
                         'application/x-midi\r\naudio/midi\r\naudio/x-midi\r\naudio/aiff\r\naudio/x-aiff\r\naudio/x-aiff\r\naudio/x-wav\r\naudio/x-realaudio\r\nvideo/mpeg\r\naudio/mpeg\r\naudio/mpeg2\r\naudio/mpeg3\r\naudio/x-pn-realaudio\r\naudio/x-pn-realaudio-plugin\r\naudio/x-realaudio\r\napplication/vnd.rn-realmedia\r\nvideo/quicktime\r\nvideo/x-msvideo\r\napplication/x-shockwave-flash\r\nvideo/x-flv', 
                         '', '', '', '', '', '', '', '', '', '', '0', 'localhost', '', '', '25', '0', '1', '1', 160, 120, 
                         '|', 'File', '15,25,35,50,75,100,150,250', 25, '1', 640, 480, '1', '1', '');

-- --------------------------------------------------------

-- 
-- Table structure for table 'mu_signfields'
-- 

CREATE TABLE mu_signfields (
  id tinyint(1) NOT NULL auto_increment,
  field_company enum('0','1') NOT NULL default '0',
  field_name enum('0','1') NOT NULL default '0',
  field_address enum('0','1') NOT NULL default '0',
  field_tel enum('0','1') NOT NULL default '0',
  field_fax enum('0','1') NOT NULL default '0',
  field_mobile enum('0','1') NOT NULL default '0',
  field_location enum('0','1') NOT NULL default '0',
  company_required enum('0','1') NOT NULL default '0',
  name_required enum('0','1') NOT NULL default '0',
  address_required enum('0','1') NOT NULL default '0',
  tel_required enum('0','1') NOT NULL default '0',
  fax_required enum('0','1') NOT NULL default '0',
  mobile_required enum('0','1') NOT NULL default '0',
  location_required enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

-- 
-- Dumping data for table 'mu_signfields'
-- 

INSERT INTO mu_signfields (id, field_company, field_name, field_address, field_tel, field_fax, field_mobile, field_location, company_required, name_required, address_required, tel_required, fax_required, mobile_required, location_required) VALUES (1, '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');

-- --------------------------------------------------------

-- 
-- Table structure for table 'mu_uploads'
-- 

CREATE TABLE mu_uploads (
  id int(10) unsigned NOT NULL auto_increment,
  uni_code varchar(50) NOT NULL default '',
  user_id int(10) unsigned NOT NULL default '0',
  user_name varchar(200) NOT NULL default '',
  user_email varchar(200) NOT NULL default '',
  upload_name varchar(250) NOT NULL default '',
  file_name varchar(100) NOT NULL default '',
  file_size int(50) NOT NULL default '0',
  file_type varchar(50) NOT NULL default '',
  file_date varchar(100) NOT NULL default '',
  file_filter_date date NOT NULL default '0000-00-00',
  admin_status enum('0','1','2') NOT NULL default '0',
  folder_name varchar(30) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM;
