<?php

/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  Script: Maian Uploader v4.0
  Written by: David Ian Bennett
  E-Mail: support@maianscriptworld.co.uk
  Website: http://www.maianscriptworld.co.uk

  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  This File: index.php
  Description: Main User Admin Parsing File

  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

session_start();
error_reporting(E_ALL ^ E_NOTICE);
set_magic_quotes_runtime(0);
define('FOLDER_PATH',dirname(__FILE__).'/');
define ('PARENT',1);
include(FOLDER_PATH.'inc/db_connection.inc.php');
include(FOLDER_PATH.'inc/functions.php');

//======================================================================================================
// DEFINED VARIABLES
//======================================================================================================
//
// LOG_UPLOAD_ERRORS                =  Set to 1 to log upload errors
// INCLUDE_FILES                    =  Do not change
// DEBUG_MODE                       =  Set to 1 to enable debug mode. For development.
// MGBS                             =  Bytes per MB
// NAME_CHARS_TO_DISPLAY            =  Max number of name characters to display
// NAME_CHARS_TO_DISPLAY_GREYBOX    =  Max number of name characters to display in greybox
// NAME_CHARS_TO_DISPLAY_UPLOAD     =  Max number of name characters to display for upload report
// CODEGEN_WINDOW_SIZE              =  Size of codegen window. width, height
// MP3_WINDOW_SIZE                  =  Size of mp3 window. width, height
// FLV_WINDOW_SIZE                  =  Size of flash video file window. width, height
// NAME_LENGTH                      =  Max name length for file name. If changed in the DB change here
//
//======================================================================================================

define('LOG_UPLOAD_ERRORS', 0);
define('INCLUDE_FILES', 1);
define('DEBUG_MODE', 0);
define('MGBS','1048576');
define('NAME_CHARS_TO_DISPLAY',60);
define('NAME_CHARS_TO_DISPLAY_GREYBOX',100);
define('NAME_CHARS_TO_DISPLAY_UPLOAD',80);
define('CODEGEN_WINDOW_SIZE', '200, 100');
define('MP3_WINDOW_SIZE', '310, 70');
define('FLV_WINDOW_SIZE', '450, 380');
define('NAME_LENGTH',100);

// Load settings..
$SETTINGS = mysql_fetch_object(mysql_query("SELECT *,UNIX_TIMESTAMP(dateStamp) AS prog_date 
                                            FROM ".$database['prefix']."settings 
                                            LIMIT 1
                                            ")) or die(mysql_error());

// Load language file and class files..
include(FOLDER_PATH.'lang/'.$SETTINGS->language);
include(FOLDER_PATH.'lib/Savant2.php');
include(FOLDER_PATH.'classes/class_generic.inc.php');
include(FOLDER_PATH.'classes/class_mail.inc.php');
include(FOLDER_PATH.'classes/class_accounts.inc.php');
include(FOLDER_PATH.'classes/class_create.inc.php');
include(FOLDER_PATH.'classes/php-captcha.inc.php');
include(FOLDER_PATH.'classes/PaginateIt.php');
include(FOLDER_PATH.'classes/class_watermarker.inc.php');
include(FOLDER_PATH.'classes/class_zipcompression.inc.php');
include(FOLDER_PATH.'classes/class_paypal.inc.php');
include(FOLDER_PATH.'classes/class_fileuploader.inc.php');
 
// Create class instances..
$MUP_MAIL      = new mailClass();
$MUP_ACC       = new accounts();
$MUP_WMK       = new waterMarker();
$MUP_ZIP       = new createZip();
$MUP_CREATE    = new signUp();
$MUP_IPN       = new paypalIPN('',$SETTINGS);
 
// Initialise login variables..
$ULN_COOKIE    = (isset($_COOKIE['uploader_user_cookie']) ? $_COOKIE['uploader_user_cookie'] : '');
$ULE_COOKIE    = (isset($_COOKIE['uploader_email_cookie']) ? $_COOKIE['uploader_email_cookie'] : '');
$ULN_SESSION   = (isset($_SESSION['uploader_mem_user']) ? $_SESSION['uploader_mem_user'] : '');
$ULE_SESSION   = (isset($_SESSION['uploader_mem_email']) ? $_SESSION['uploader_mem_email'] : '');
$cmd           = (isset($_GET['cmd']) ? strip_tags($_GET['cmd']) : 'home');
 
// Is IP banned?..
if (isIpAddressBanned() && $cmd!='ip_banned') {
  $MUP_ACC->kill_session();
  header("Location: ".($SETTINGS->url_ipbanned ? $SETTINGS->url_ipbanned : 'index.php?cmd=ip_banned')."");
  exit;
}

if (($ULN_COOKIE && $ULE_COOKIE) || ($ULN_SESSION && $ULE_SESSION))
{
  $q_member = mysql_query("SELECT *,
                           DATE_FORMAT(subscr_date,'%e %M %Y') AS sub_date,
                           DATE_FORMAT(subscr_cancel,'%e %M %Y') AS cancel_date,
                           DATE_FORMAT(subscr_expiry,'%e %M %Y') AS exp_date 
                           FROM ".$database['prefix']."members 
                           WHERE username  = '".($ULN_COOKIE ? $ULN_COOKIE : $ULN_SESSION)."' 
                           AND email       = '".($ULE_COOKIE ? $ULE_COOKIE : $ULE_SESSION)."' 
                           AND activate    = '1' 
                           LIMIT 1
                           ") or die(mysql_error());
  $MEMBER_INFO = mysql_fetch_object($q_member);    

  if (mysql_num_rows($q_member)==0) {
    header("Location: index.php");
    exit;
  }
  // Has access been disallowed for this member?..
  if ($MEMBER_INFO->adminban && mysql_num_rows($q_member)>0) {
    $MUP_ACC->kill_session();
    header("Location: ".($SETTINGS->url_account ? $SETTINGS->url_account : 'index.php?cmd=banned')."");
    exit;
  }
  if (!$MEMBER_INFO->allowaccess && mysql_num_rows($q_member)>0) {
    $MUP_ACC->kill_session();
    header("Location: ".($SETTINGS->url_login ? $SETTINGS->url_login : 'index.php?cmd=no_entry')."");
    exit;
  }
  if (isIpAddressBanned($MEMBER_INFO->ip) && mysql_num_rows($q_member)>0  && $cmd!='ip_banned') {
    $MUP_ACC->kill_session();
    header("Location: ".($SETTINGS->url_ipbanned ? $SETTINGS->url_ipbanned : 'index.php?cmd=ip_banned')."");
    exit;
  }
   
  //-----------------------------------
  // If IP address is empty update it
  //-----------------------------------
     
  if (!$MEMBER_INFO->ip)
  {
    mysql_query("UPDATE ".$database['prefix']."members SET 
                 ip        = '".$_SERVER['REMOTE_ADDR']."' 
                 WHERE id  = '".$MEMBER_INFO->id."' 
                 LIMIT 1
                 ") or die(mysql_error());
  }
  
  //-------------------------------------------------
  // Has this subscription expired?
  // If so, update status and direct to error page
  //-------------------------------------------------
  
  if ($MEMBER_INFO->subscription) 
  {
    if (date("Y-m-d")>$MEMBER_INFO->subscr_expiry && $MEMBER_INFO->subscr_access)
    {
      mysql_query("UPDATE ".$database['prefix']."members SET 
                   subscr_access = '0' 
                   WHERE id  = '".$MEMBER_INFO->id."' 
                   LIMIT 1
                   ") or die(mysql_error());
      
      $MUP_ACC->kill_session();
      header("Location: index.php?cmd=subscription_expired");
      exit;             
    }
  }
}

if (isset($MEMBER_INFO->id)) {
  if (!isset($q_member) || (isset($q_member) && mysql_num_rows($q_member)==0)) {
    header("Location: index.php");
    exit;
  }
}
 
$page             = (isset($_GET['page']) ? strip_tags($_GET['page']) : '1');
$page_title_data  = '';
$count            = 0;
$limitvalue       = $page * $SETTINGS->data_per_page - ($SETTINGS->data_per_page);

// Default mail/account variables..
$MUP_MAIL->smtp_host  = $SETTINGS->smtp_host;
$MUP_MAIL->smtp_port  = $SETTINGS->smtp_port;
$MUP_MAIL->smtp_user  = $SETTINGS->smtp_user;
$MUP_MAIL->smtp_pass  = $SETTINGS->smtp_pass;
$MUP_MAIL->smtp       = $SETTINGS->smtp;
$MUP_MAIL->addTag('{WEBSITE_NAME}',$SETTINGS->webname);
$MUP_MAIL->addTag('{WEBSITE_URL}',$SETTINGS->url);
$MUP_MAIL->addTag('{WEBSITE_EMAIL}',$SETTINGS->email);
$MUP_ACC->prefix      = $database['prefix'];
$MUP_CREATE->prefix   = $database['prefix'];
$MUP_IPN->prefix      = $database['prefix'];
 
// Security check..
if (!ctype_digit($page)) {
  header("Location: index.php");
}

switch ($cmd)
{
  //===================
  // CASE: HOME
  //===================

  case "home":
      
  // Check for news..
  isNewsLive();
   
  // Process login..
  if (isset($_POST['process']))
  {
    // Apply call back element to trim post vars..
    $_POST = array_map('trim',$_POST);
    
    if ($MUP_ACC->field_check(5,15,$_POST['user']) || $MUP_ACC->is_alpha($_POST['user'],15)) {
      $U_ERROR = '<br /><span class="login_error">'.$msg_home22.'</span>';
      $count++;
    }
    if ($MUP_ACC->field_check(5,10,$_POST['pass']) || $MUP_ACC->is_alpha($_POST['pass'],15)) {
      $P_ERROR = '<br /><span class="login_error">'.$msg_home22.'</span>';
      $count++;
    }
    if ($count==0 && $MUP_ACC->check_login($_POST)) {
      $P_ERROR = '<br /><span class="login_error">'.$msg_home21.'</span>';
      $count++;
    }
    if ($count==0 && $MUP_ACC->check_subscription_login($_POST)) {
      $P_ERROR = '<br /><span class="login_error">'.$msg_home28.'</span>';
      $count++;
    }
    if ($count==0)
    {
      // Get account e-mail..
      $email = $MUP_ACC->check_login($_POST,true);

      // Create session/cookie data..
      $MUP_ACC->create_login_data($_POST,$email);

      // Refresh page..
      header("Location: index.php");
      exit;
    }
  } 
  
  $paymentInfo  = '';
  $paymentData  = '';
  
  // Show payment details...
  // If no payment details are present, its a free account..
  if (isset($MEMBER_INFO->id))
  {
    // Does subscription data exist for member..
    if ($MEMBER_INFO->subscription) 
    {
      $time = explode("|", $MEMBER_INFO->subscr_time);
      
      switch($time[1]) {
        case 'day':   $var = $msg_acctypes46; break;
        case 'week':  $var = $msg_acctypes53; break;
        case 'month': $var = $msg_acctypes47; break;
        case 'year':  $var = $msg_acctypes48; break;
      }
      
      $paymentData = 
      $msg_manage99.': <span class="text_bold_blue">'.($MEMBER_INFO->subscr_access ? $msg_script26 : $msg_script20).'</span><br />'.
      $msg_manage101.': <span class="text_bold_blue">'.$MEMBER_INFO->sub_date.'</span><br />'.
      $msg_manage100.': <span class="text_bold_blue">'.$msg_script19.' '.$time[0].' '.$var.'</span><br />'.
      $msg_manage102.': <span class="text_bold_blue">'.curSymbol($MEMBER_INFO->currency).number_format($MEMBER_INFO->subscr_cost,2).'</span><br />'.
      $msg_manage103.': <span class="text_bold_blue">'.$MEMBER_INFO->exp_date.'</span><br /><br />
      '.$msg_ipn12;
    } 
    else 
    {
      // Does IPN data exist for member..
      if ($MUP_IPN->ipnData($MEMBER_INFO->username)) 
      {
        $IPN = $MUP_IPN->ipnData($MEMBER_INFO->username,true);
        
        $paymentData = str_replace(array('{date}','{status}','{amount}','{txn_id}'),
                                   array($IPN->i_date,$IPN->ipn_status,curSymbol($IPN->ipn_currency).$IPN->ipn_gross,$IPN->ipn_txnid),
                                   $msg_home29
                                   );
      }
    }
    
    $paymentInfo = str_replace(array('{title}','{data}'),array(($MEMBER_INFO->subscription ? $msg_home26 : $msg_home25),($paymentData ? $paymentData : $msg_home27)),
                   file_get_contents(FOLDER_PATH.'templates/tpl_files/blockquote.tpl'));
  }
   
  $page_title_data = (isset($MEMBER_INFO->id) ? $msg_home2 : $msg_home5);

  include(FOLDER_PATH.'inc/header.php');
      
  $tpl_home =& new Savant2();
  $tpl_home->assign('WELCOME_MESSAGE', (isset($MEMBER_INFO->id) ? str_replace("{username}",$MEMBER_INFO->username,$msg_home) : str_replace("{website}",cleanData($SETTINGS->webname),$msg_home9)));
  $tpl_home->assign('PAYMENT_INFO', $paymentInfo);
  $tpl_home->display('templates/home.tpl.php');
      
  include(FOLDER_PATH.'inc/footer.php');
  break;
      
  //===================
  // CASE: SEARCH
  // Added in v3.2
  //===================

  case "search":
    
  if (!isset($MEMBER_INFO->id)) {
    header("Location: index.php");
    exit;
  }  
      
  // Check for news..
  isNewsLive();

  $results    = '';
  $sql_query  = '';
  $q_type     = '';
      
  if ($_GET['keywords'])
  {
    $words = explode(" ", cleanEvilTags($_GET['keywords'],true));
          
    for ($i=0; $i<count($words); $i++)
    {
      $sql_query .= ($i ? 'OR ' : 'WHERE (').$database['prefix']."uploads.upload_name LIKE '%".mysql_real_escape_string($words[$i])."%' OR ".$database['prefix']."uploads.file_name LIKE '%".mysql_real_escape_string($words[$i])."%' ";
    }
          
    if ($_GET['filter']=='personal') {
      $q_type = ") AND ".$database['prefix']."uploads.user_id='$MEMBER_INFO->id'";
    } else {
      $q_type = ($MEMBER_INFO->viewfiles=='same' ? ") AND (".$database['prefix']."members.accid = '$MEMBER_INFO->accid')" : ($MEMBER_INFO->viewfiles=='all' ? ") AND (".$database['prefix']."uploads.user_id != '$MEMBER_INFO->id')" : ")"));

      if ($MEMBER_INFO->viewfiles=='no') {
        header("Location:index.php");
      }
    }
          
    $q_count = mysql_query("SELECT count(*) as s_count FROM ".$database['prefix']."uploads
                            LEFT JOIN ".$database['prefix']."members
                            ON ".$database['prefix']."uploads.user_id = ".$database['prefix']."members.id
                            ".$sql_query.$q_type."
                            ") or die(mysql_error());
    $COUNT = mysql_fetch_object($q_count);                                  
                                            
    $q_search = mysql_query("SELECT *,".$database['prefix']."uploads.id AS up_id,".$database['prefix']."uploads.user_id AS check_id 
                             FROM ".$database['prefix']."uploads
                             LEFT JOIN ".$database['prefix']."members
                             ON ".$database['prefix']."uploads.user_id = ".$database['prefix']."members.id
                             ".$sql_query.$q_type."
                             LIMIT $limitvalue,$SETTINGS->data_per_page
                             ") or die(mysql_error());
          
    if (mysql_num_rows($q_search)>0)
    {
      $display_image  = '';
      $codegen        = '';
      
      while ($FILES = mysql_fetch_object($q_search))
      {
        $imgPreview = '';
      
        // Determine which link to show based on mime type..
        // For media, mp3/mp4 and flv files overwrite mime type and launch player..
        if (in_array($FILES->file_type, getMimeTypes('view')))
        {
          $display_image = '<a href="'.($SETTINGS->greybox && substr($FILES->file_type,0,5)=='image' ? $SETTINGS->uploaddir.'/'.$FILES->folder_name.'/'.$FILES->upload_name.'" title="'.substr(cleanData($FILES->file_name),0,NAME_CHARS_TO_DISPLAY_GREYBOX).'" rel="gb_image[]"' : 'javascript:viewFile(\'index.php?cmd=view&amp;view='.$FILES->uni_code.'\')"').'><img class="button_image" src="images/buttons/view.gif" title="'.$msg_view22.'" alt="'.$msg_view22.'" /></a>';
        }
        else if (in_array($FILES->file_type, getMimeTypes('download')))
        {
          $display_image = '<a href="index.php?cmd=view&amp;download='.$FILES->uni_code.'"><img class="button_image" src="images/buttons/download.gif" title="'.$msg_view30.'" alt="'.$msg_view30.'" /></a>';
        }
        else if (in_array($FILES->file_type, getMimeTypes('media')))
        {
          $musicFiles    = array('mp3','mp4');
          $display_image = '<a href="'.(in_array(strtolower(substr($FILES->upload_name,-3)),$musicFiles) && $SETTINGS->enable_mp3 ? 'index.php?cmd=view&amp;mp3='.$FILES->uni_code.'" rel="gb_page_center['.MP3_WINDOW_SIZE.']"' : (strtolower(substr($FILES->upload_name,-3))=='flv' && $SETTINGS->enable_flv ? 'index.php?cmd=view&amp;flv='.$FILES->uni_code.'" rel="gb_page_center['.FLV_WINDOW_SIZE.']"' : 'javascript:viewMedia(\'index.php?cmd=view&amp;media='.$FILES->uni_code.'\')"')).'><img class="button_image" src="images/buttons/media.gif" title="'.$msg_view29.'" alt="'.$msg_view29.'" /></a>';
        }
        else
        {
          $display_image = '<a href="index.php?cmd=view&amp;download='.$FILES->uni_code.'"><img class="button_image" src="images/buttons/download.gif" title="'.$msg_view30.'" alt="'.$msg_view30.'" /></a>';
        }
               
        // Is code generator enabled..
        if ($MEMBER_INFO->codegen)
        {
          $codegen = '<a href="index.php?cmd=codegen&amp;code='.$FILES->uni_code.'" rel="gb_page_center['.CODEGEN_WINDOW_SIZE.']"><img class="button_image" src="images/buttons/codegen.gif" title="'.$msg_codegen2.'" alt="'.$msg_codegen2.'" /></a>';
        }
      
        // Are we showing javascript image preview?
        if ($SETTINGS->thumb_width>0 && 
            $SETTINGS->thumb_height>0 && 
            substr($FILES->file_type,0,5)=='image')
        {
          $imgPreview = '<a href="javascript:void(0);" onmouseover="return overlib(\''.imagePreviewBuilder($SETTINGS->url.'/'.$SETTINGS->uploaddir.'/'.$FILES->folder_name.'/'.$FILES->upload_name,$SETTINGS->thumb_width,$SETTINGS->thumb_height,cleanData($FILES->file_name)).'\',ol_width=\''.($SETTINGS->thumb_width+10).'\', CENTER);" onmouseout="nd();"><img class="button_image" src="images/buttons/preview.gif" title="'.$msg_javascript16.'" alt="'.$msg_javascript16.'" /></a>';
        }
               
        // File data..
        $fileData = '&#8226; <span class="text_bold">'.$msg_view12.'</span>: '.substr(cleanData($FILES->file_name),0,NAME_CHARS_TO_DISPLAY).($FILES->admin_status==1 ? ' (<span class="admin_files">'.$msg_view33.'</span>)' : '').' '.($MEMBER_INFO->id==$FILES->user_id && $MEMBER_INFO->rename_files ? '[<a href="javascript:void(0);" onclick="return overlib(\''.fileNameBuilder($FILES->user_id,cleanData($FILES->file_name),$FILES->up_id,'form_box','button').'\',STICKY,CAPTION,\''.$msg_manage95.'\',RIGHT,ol_width=\'275\');" onmouseout="nd();" title="'.$msg_script15.'">'.$msg_script15.'</a>]' : '').'<br />
                     &#8226; <span class="text_bold">'.$msg_view13.'</span>: '.$FILES->upload_name.'<br />
                     &#8226; <span class="text_bold">'.$msg_view24.'</span>: '.file_size_conversion($FILES->file_size,MGBS).' | <span class="text_bold">'.$msg_view14.'</span>: '.$FILES->file_type.'<br />
                     &#8226; <span class="text_bold">'.$msg_view15.'</span>: '.$FILES->file_date;
      
        // Load data into string..
        $find      = array('{files}','{options}','{checkbox}');
        $replace   = array($fileData,$display_image.$codegen.$imgPreview,(!$MEMBER_INFO->zipcompress ? '' : '<input type="checkbox" name="fileinfo[]" value="'.$FILES->up_id.'###'.$FILES->upload_name.'###'.$FILES->uni_code.'" />'));
        $results  .= str_replace($find,$replace,
                                 file_get_contents(FOLDER_PATH.'templates/tpl_files/file_box.tpl')
                                 );
                                 
        // Which options are we showing..
        $fileOptions = ($MEMBER_INFO->zipcompress ? '<span class="radio_button"><input type="radio" name="option" value="zip" checked="checked" /></span><span class="text_bold">'.$msg_view18.'</span>' : '').
                       ($FILES->check_id==$MEMBER_INFO->id ? '<span class="radio_button"><input type="radio" name="option" value="del"'.(!$MEMBER_INFO->zipcompress ? ' checked="checked"' : ' ').' /></span><span class="text_bold">'.$msg_view17.'</span>' : '');
           
        unset($fileSize);
      }
      
      // Load data into string..
      if ($fileOptions)
      {
        $find      = array('{options}','{process}');
        $replace   = array($fileOptions,$msg_view19);
        $results  .= str_replace($find,$replace,
                                 file_get_contents(FOLDER_PATH.'templates/tpl_files/file_options.tpl')
                                 );
      }
      
      // Set session vars for redirect if files deleted..
      $_SESSION['search_keys']    = cleanEvilTags($_GET['keywords']);
      $_SESSION['search_filter']  = $_GET['filter'];
      $_SESSION['search_page']    = $page;
    }
    else
    {
      $results = str_replace('{message}',$msg_searchfiles2,
                              file_get_contents(FOLDER_PATH.'templates/tpl_files/general_message.tpl')
                              );
    }
  }
  else
  {
    header("Location: index.php");
  }
      
  $page_title_data = $msg_searchfiles;

  include(FOLDER_PATH.'inc/header.php');

  $tpl_search =& new Savant2();
  $tpl_search->assign('SEARCH_TEXT', $msg_searchfiles);
  $tpl_search->assign('SEARCH_MESSAGE', str_replace(array('{count}','{keywords}'),array($COUNT->s_count,cleanEvilTags($_GET['keywords'])),$msg_searchfiles3));
  $tpl_search->assign('SEARCH_RESULTS', $results);
  $tpl_search->assign('PAGENUMBERS', ($COUNT->s_count>0 ? page_numbers($COUNT->s_count,$SETTINGS->data_per_page,$page) : ''));
  $tpl_search->assign('AREYOUSURE', $msg_javascript);
  $tpl_search->display('templates/search.tpl.php');
      
  include(FOLDER_PATH.'inc/footer.php');

  break;
      
  //===================
  // CASE: UPLOAD
  //===================

  case "upload":
      
  if (!isset($MEMBER_INFO->id)) {
    header("Location: index.php");
    exit;
  }
  
  // Check for news..
  isNewsLive();
  
  // Has account been locked..
  if ($MEMBER_INFO->locklimit>0 && ($MEMBER_INFO->locklimit==$MEMBER_INFO->lockattempts))
  {
    $page_title_data = $msg_tempupload8;
    
    include(FOLDER_PATH.'inc/header.php');
                
    $tpl_error =& new Savant2();
    $tpl_error->assign('TEXT', $msg_tempupload8);
    $tpl_error->assign('MESSAGE', $msg_tempupload22);
    $tpl_error->display('templates/error.tpl.php');
                
    include(FOLDER_PATH.'inc/footer.php');
    exit;
  }
      
  $upload_file_string  = '';

  if (isset($_POST['process']))
  {
    set_time_limit(0);

    $upload_count    = 0;
    $upload_success  = 0;

    // Declare arrays/file names..
    $UPLOAD_STATUS     = array();
    $UPLOAD_FILE_NAME  = array();
    $UPLOAD_FILE_SIZE  = array();
    $UPLOAD_MIME_TYPE  = array();
    $UPLOAD_FILE_TEXT  = array();
    $EMAIL_FILES       = '';
    $EMAIL_REJECTED    = '';
    $LIB1              = array();
    $LIB2              = array();
    $LIB3              = array();
    $LIB4              = array();
           
    // Specify allowable types for resizing..
    $resize_types      = array('image/jpeg','image/pjpeg');
           
    //-----------------------------------------------------------
    // Error Status when uploading ($UPLOAD_STATUS array)
    //
    // [1] = File uploaded ok
    // [2] = File uploaded ok with changes
    // [3] = Error with no warning
    // [4] = Warning Issued
    //
    //-----------------------------------------------------------
           
    for ($i=0; $i<count($_FILES['user_file']['tmp_name']); $i++)
    {
      $MUP_UPL   = new uploader();
      $NAME      = filterUploadName($_FILES['user_file']['name'][$i]);
      $SIZE      = $_FILES['user_file']['size'][$i];
      $TEMP      = $_FILES['user_file']['tmp_name'][$i];
      $MIME      = $_FILES['user_file']['type'][$i];
      $FILE      = $_POST['file_name'][$i];

      // Log errors if enabled..
      if (LOG_UPLOAD_ERRORS || DEBUG_MODE) {
        upload_errors($_FILES['user_file']['error'][$i]);
      }
                
      // Assign strings for messages..
      // The second string was updated in v4.0 to include all changes..
      $lib_string1  = '';
      $lib_string2  = array();
      $lib_string3  = '';
      $lib_string4  = '';

      if (!empty($NAME))
      {
        // Increment upload count
        // We use this to see if any files are being uploaded
        $upload_count++;

        // Add data to arrays
        $UPLOAD_FILE_SIZE[]        = file_size_conversion($SIZE,MGBS);
        $UPLOAD_MIME_TYPE[]        = $MIME;
        $UPLOAD_FILE_TEXT[]        = ($FILE ? $FILE : cleanData($SETTINGS->default_name));

        $MUP_UPL->name             = $NAME;
        $MUP_UPL->size             = $SIZE;
        $MUP_UPL->temp             = $TEMP;
        $MUP_UPL->type             = $MIME;
        $MUP_UPL->max_size         = $MEMBER_INFO->uploadmax;
        $MUP_UPL->storage          = getUsedStorageValue($MEMBER_INFO->id,true);
        $MUP_UPL->prefix           = $database['prefix'];
        $MUP_UPL->username         = $MEMBER_INFO->username;
        $MUP_UPL->email            = $MEMBER_INFO->email;
        $MUP_UPL->folder           = $MEMBER_INFO->accfolder;
        $MUP_UPL->folder_main      = $SETTINGS->uploaddir;
        $MUP_UPL->date             = date($SETTINGS->dateformat, strtotime(($SETTINGS->time_offset=='0' ? "+0 hours" : $SETTINGS->time_offset)));
        $MUP_UPL->file_types       = $MEMBER_INFO->filetypes;
        $MUP_UPL->allowed_storage  = $MEMBER_INFO->webspace;
        $MUP_UPL->img_width        = $SETTINGS->new_width;
        $MUP_UPL->img_height       = $SETTINGS->new_height;
        $MUP_UPL->width            = $SETTINGS->max_width;
        $MUP_UPL->height           = $SETTINGS->max_height;
        $MUP_UPL->id               = $MEMBER_INFO->id;
        $MUP_UPL->filename         = cleanData($FILE);
        $MUP_UPL->mgbs             = MGBS;

        // [1] > Check file size..

        if ($MUP_UPL->check_file_size())
        {
          $STAGE_1 = true;

          // [2] > Does file exist..
                          
          if ($MUP_UPL->check_file_exists())
          {
            if ($MEMBER_INFO->fileprefix)
            {
              $NEW_FILE_NAME  = $MUP_UPL->get_file_prefix();
              $lib_string2[]  = $msg_javascript71;
              $STAGE_2        = true;
            }
            else
            {
              $lib_string3 = $msg_javascript79;

              $EMAIL_REJECTED .= $msg_tempupload10.": ".($FILE ? $FILE : $SETTINGS->default_name).define_newline();
              $EMAIL_REJECTED .= $msg_tempupload11.": ".$NAME.define_newline();
              $EMAIL_REJECTED .= $msg_tempupload12.": ".file_size_conversion($SIZE,MGBS).define_newline();
              $EMAIL_REJECTED .= $msg_tempupload13.": ".$msg_tempupload16.define_newline().define_newline();
              
              $MUP_UPL->clear_temp_file($TEMP);
            }
          }
          else
          {
            $STAGE_2 = true;
          }

          // [5] > Is this an invalid file type..

          if (isset($STAGE_2))
          {
            if ($MEMBER_INFO->filetypes)
            {
              if ($MUP_UPL->check_type())
              {
                $STAGE_3 = true;
              }
              else
              {
                $lib_string4 = $msg_javascript69;

                $EMAIL_REJECTED .= $msg_tempupload10.": ".($FILE ? $FILE : $SETTINGS->default_name).define_newline();
                $EMAIL_REJECTED .= $msg_tempupload11.": ".$NAME.define_newline();
                $EMAIL_REJECTED .= $msg_tempupload12.": ".file_size_conversion($SIZE,MGBS).define_newline();
                $EMAIL_REJECTED .= $msg_tempupload13.": ".$msg_tempupload17.define_newline().define_newline();
                
                // Increment lock..
                // Added in v4.0..
                $MUP_UPL->update_lock_limit($MEMBER_INFO->id);
                
                // Clear temporary file..
                $MUP_UPL->clear_temp_file($TEMP);
              }
            }
            else
            {
              $STAGE_3 = true;
            }     
          }

          // [6] > Has the storage limit been exceeded..

          if (isset($STAGE_3))
          {
            if ($MUP_UPL->check_upload_size())
            {
              $STAGE_4 = true;
            }
            else
            {
              $lib_string3 .= $msg_javascript72;

              $EMAIL_REJECTED .= $msg_tempupload10.": ".($FILE ? $FILE : $SETTINGS->default_name).define_newline();
              $EMAIL_REJECTED .= $msg_tempupload11.": ".$NAME.define_newline();
              $EMAIL_REJECTED .= $msg_tempupload12.": ".file_size_conversion($SIZE,MGBS).define_newline();
              $EMAIL_REJECTED .= $msg_tempupload13.": ".$msg_tempupload18.define_newline().define_newline();
              
              // Clear temporary file..
              $MUP_UPL->clear_temp_file($TEMP);
            }
          }

          // [7] > Was file name too big..
                          
          if (strlen($FILE)>NAME_LENGTH)
          {
            $lib_string2[] = str_replace("{count}",NAME_LENGTH,$msg_javascript73);

            $STAGE_5 = true;
          }
                          
          $UPLOAD_FILE_NAME[] = (isset($NEW_FILE_NAME) ? $NEW_FILE_NAME : $NAME);
                          
          // If we are at this point, file is ok, so we can upload it..
          if (isset($STAGE_1) && isset($STAGE_2) && isset($STAGE_3) && isset($STAGE_4))
          {
            if ($MUP_UPL->upload_file((isset($NEW_FILE_NAME) ? $NEW_FILE_NAME : $NAME),DEBUG_MODE))
            {
              $upload_success++;

              // Resize image if too big and image resizing is enabled..
              if ($MEMBER_INFO->imageresize)
              {
                if (in_array($MIME, $resize_types))
                {
                  if ($MUP_UPL->image_resizer((isset($NEW_FILE_NAME) ? $NEW_FILE_NAME : $NAME),DEBUG_MODE))
                  {
                    $lib_string2[] = $msg_javascript80.' '.$SETTINGS->new_width.'x'.$SETTINGS->new_height.' '.$msg_javascript81;;

                    $STAGE_6 = true;
                  }
                }
              }
                               
              // Add data to database..
              $MUP_UPL->insert_sql((isset($NEW_FILE_NAME) ? $NEW_FILE_NAME : $NAME),DEBUG_MODE,$SETTINGS->default_name);

              $EMAIL_FILES .= $msg_tempupload10.": ".($FILE ? $FILE : $SETTINGS->default_name).define_newline();
                               
              // Are hyperlinks enabled?
              if ($SETTINGS->email_links)
              {
                if ($MUP_MAIL->html) {
                  $EMAIL_FILES .= $msg_tempupload11.": <a href='".$SETTINGS->url.'/'.$SETTINGS->uploaddir.'/'.$MEMBER_INFO->accfolder.'/'.(isset($NEW_FILE_NAME) ? $NEW_FILE_NAME : $NAME)."'>".$SETTINGS->url.'/'.$SETTINGS->uploaddir.'/'.$MEMBER_INFO->accfolder.'/'.(isset($NEW_FILE_NAME) ? $NEW_FILE_NAME : $NAME)."</a>".define_newline();
                } else {
                  $EMAIL_FILES .= $msg_tempupload11.": ".$SETTINGS->url.'/'.$SETTINGS->uploaddir.'/'.$MEMBER_INFO->accfolder.'/'.(isset($NEW_FILE_NAME) ? $NEW_FILE_NAME : $NAME).define_newline();
                }
              } else {
                  $EMAIL_FILES .= $msg_tempupload11.": ".(isset($NEW_FILE_NAME) ? $NEW_FILE_NAME : $NAME).define_newline();
              }

              // If images were resized or renamed append details to e-mails..
              $add_data = (isset($NEW_FILE_NAME) ? "(".$msg_tempupload19.")" : "");

              if ($add_data && isset($STAGE_6))
              {
                $add_data .= " (".$msg_tempupload21.")";
              }
              else if (!$add_data && isset($STAGE_6))
              {
                $add_data = "(".$msg_tempupload21.")";
              }
              else
              {
                $add_data = '';
              }

              $EMAIL_FILES .= $msg_tempupload12.": ".file_size_conversion($SIZE,MGBS).define_newline();
              $EMAIL_FILES .= $msg_tempupload13.": ".$msg_tempupload14." ".$add_data.define_newline().define_newline();
            }
            else
            {
              $lib_string2[] = $msg_javascript102;
              
              // Clear temporary file..
              $MUP_UPL->clear_temp_file($TEMP);
            }
          }
                               
          // Build arrays for display messages..
          if (empty($lib_string2) && $lib_string3=='' && $lib_string4=='')
          {
            $UPLOAD_STATUS[] = '1';
            $LIB1[]          = $msg_javascript74;
            $LIB2[]          = '0';
            $LIB3[]          = '0';
            $LIB4[]          = '0';
          }
          else
          {
            $LIB1[]          = '0';
            empty($lib_string2) ? $LIB2[] = '0' : $LIB2[] = $lib_string2;
            $lib_string3=='' ? $LIB3[] = '0' : $LIB3[] = $lib_string3;
            $lib_string4=='' ? $LIB4[] = '0' : $LIB4[] = $lib_string4;
                               
            if ($lib_string4)
            {
              $UPLOAD_STATUS[] = '4';
            }
            else if ($lib_string3 && !$lib_string4)
            {
              $UPLOAD_STATUS[] = '3';
            }
            else
            {
              $UPLOAD_STATUS[] = '2';
            }
          }
        }
        else
        {
          $UPLOAD_FILE_NAME[] = $NAME;
          
          // This was updated in v4.0 to overwrite message if file type was invalid..
          $UPLOAD_STATUS[] = ($MEMBER_INFO->filetypes && !$MUP_UPL->check_type() ? '4' : '3');
          $lib_string3     = ($MEMBER_INFO->filetypes && !$MUP_UPL->check_type() ? '' : $msg_javascript70);
          $LIB1[]          = '0';
          $LIB2[]          = '0';
          $LIB3[]          = ($MEMBER_INFO->filetypes && !$MUP_UPL->check_type() ? '0' : $lib_string3);
          $LIB4[]          = ($MEMBER_INFO->filetypes && !$MUP_UPL->check_type() ? $msg_javascript69 : '0');

          $EMAIL_REJECTED .= $msg_tempupload10.": ".($FILE ? $FILE : $SETTINGS->default_name).define_newline();
          $EMAIL_REJECTED .= $msg_tempupload11.": ".$NAME.define_newline();
          $EMAIL_REJECTED .= $msg_tempupload12.": ".file_size_conversion($SIZE,MGBS).define_newline();
          $EMAIL_REJECTED .= $msg_tempupload13.": ".($lib_string3 ? $msg_tempupload15 : $msg_tempupload17).define_newline().define_newline();
          
          // Increment lock if invalid..
          // Added in v4.0..
          if ($MEMBER_INFO->filetypes && !$MUP_UPL->check_type())
          {
            $MUP_UPL->update_lock_limit($MEMBER_INFO->id);
          }
                
          // Clear temporary file..
          $MUP_UPL->clear_temp_file($TEMP);
        }

        unset($NAME,$SIZE,$TEMP,$MIME,$FILE,$lib_string1,
              $lib_string2,$lib_string3,$lib_string4,$NEW_FILE_NAME,
              $STAGE_1,$STAGE_2,$STAGE_3,$STAGE_4,$STAGE_5,$STAGE_6,$add_data);
      }
    }
           
    // For development/debugging ONLY..
    // Do not enable debug mode above when live..
    if (DEBUG_MODE) {
      debugReport($UPLOAD_STATUS,$LIB1,$LIB2,$LIB3,$LIB4,$UPLOAD_FILE_SIZE,$UPLOAD_MIME_TYPE,$UPLOAD_FILE_TEXT);
    }

    // If no files were selected, redirect to uploads page..
    if ($upload_count==0)
    {
      header("Location: index.php?cmd=upload");
      exit;
    }
    else
    {
      $MUP_MAIL->addTag('{USERNAME}', $MEMBER_INFO->username);
      $MUP_MAIL->addTag('{DATE}', date($SETTINGS->dateformat, strtotime(($SETTINGS->time_offset=='0' ? "+0 hours" : $SETTINGS->time_offset))));
      $MUP_MAIL->addTag('{FILES}', ($EMAIL_FILES ? trim($EMAIL_FILES) : $msg_script32));
      $MUP_MAIL->addTag('{REJECTED}', ($EMAIL_REJECTED ? trim($EMAIL_REJECTED) : $msg_script32));
        
      // Send e-mail to visitor if enabled..
      if ($SETTINGS->mail_message && $upload_success>0)
      {
        $MUP_MAIL->sendMail($MEMBER_INFO->username,
                            $MEMBER_INFO->email,
                            $SETTINGS->webname,
                            $SETTINGS->email,
                            '['.$SETTINGS->webname.'] '.$msg_tempupload20,
                            $MUP_MAIL->template('templates/email/upload_visitor.txt')
                            );
      }
      // Send e-mail to webmaster if enabled..
      if ($SETTINGS->mail_notify)
      {
        $MUP_MAIL->sendMail($SETTINGS->webname,
                            $SETTINGS->email,
                            $SETTINGS->webname,
                            $SETTINGS->email,
                            '['.$SETTINGS->webname.'] '.$msg_tempupload20,
                            $MUP_MAIL->template('templates/email/upload_webmaster.txt')
                            );
      }

      // Display results on upload results page...
      $report_string = '';
      $fInfo         = '';

      for($i=0; $i<count($UPLOAD_MIME_TYPE); $i++)
      {
        $lib_string = '';
        
        switch ($UPLOAD_STATUS[$i])
        {
          case 1:
          $img_path    = 'ok.gif';
          $img_alt     = $msg_javascript75;
          $lib_string  = '&#8226; '.$LIB1[$i];
          break;

          case 2:
          $img_path    = 'okchanges.gif';
          $img_alt     = $msg_javascript76;
          
          // If this lib string is an array, loop through array..
          // Array will hold information about changes..
          for ($j=0; $j<count($LIB2[$i]); $j++)
          {
            $lib_string .= '&#8226; '.$LIB2[$i][$j].'<br />';
          }
          
          break;

          case 3:
          $img_path    = 'error.gif';
          $img_alt     = $msg_javascript77;
          $lib_string  = '&#8226; '.$LIB3[$i];
          break;

          case 4:
          $img_path    = 'warning.gif';
          $img_alt     = $msg_javascript78;
          $lib_string  = '&#8226; '.$LIB4[$i];
          break;
        }
        
        // Build file info string..
        if (isset($UPLOAD_FILE_TEXT[$i]) && isset($UPLOAD_FILE_NAME[$i]))
        {
          $fInfo = '
          <span class="text_bold">'.$msg_files3.'</span>: '.(strlen($UPLOAD_FILE_TEXT[$i])>NAME_CHARS_TO_DISPLAY_UPLOAD ? cleanData(substr($UPLOAD_FILE_TEXT[$i],0,NAME_CHARS_TO_DISPLAY_UPLOAD)).'...' : cleanData($UPLOAD_FILE_TEXT[$i])).'<br />
          <span class="text_bold">'.$msg_files4.'</span>: '.(strlen($UPLOAD_FILE_NAME[$i])>NAME_CHARS_TO_DISPLAY_UPLOAD ? substr($UPLOAD_FILE_NAME[$i],0,NAME_CHARS_TO_DISPLAY_UPLOAD).'...' : cleanData($UPLOAD_FILE_NAME[$i])).'<br />
          <span class="text_bold">'.$msg_files5.'</span>: '.$UPLOAD_MIME_TYPE[$i].' | <span class="text_bold">'.$msg_files6.'</span>: '.$UPLOAD_FILE_SIZE[$i];
        }
        
        // Load file string..
        $find           = array('{file_info}','{image}','{image_text}','{message}');
        $replace        = array($fInfo,$img_path,$img_alt,$lib_string);
        $report_string .= str_replace($find,$replace,
                                      file_get_contents(FOLDER_PATH.'templates/tpl_files/upload_report_file.tpl')
                                      );

        unset($img_path,$img_alt,$lib_string,$upload_count,$upload_success,$find,$replace);
      }
    }

    $page_title_data = $msg_files2;

    include(FOLDER_PATH.'inc/header.php');
                
    $tpl_report =& new Savant2();
    $tpl_report->assign('TEXT', $msg_files2);
    $tpl_report->assign('MESSAGE', $msg_files);
    $tpl_report->assign('FILES_PROCESSED', str_replace("{count}",count($UPLOAD_MIME_TYPE),$msg_files7));
    $tpl_report->assign('FILES', trim($report_string));
    $tpl_report->display('templates/upload_report.tpl.php');
                
    unset($UPLOAD_STATUS,$UPLOAD_FILE_NAME,$UPLOAD_FILE_SIZE,$UPLOAD_MIME_TYPE,
          $UPLOAD_FILE_TEXT,$EMAIL_FILES,$EMAIL_REJECTED,$lib_string,$MUP_UPL);

    include(FOLDER_PATH.'inc/footer.php');

    exit;
  }
      
  // Allowable file types and max size..  
  $accountLimits = '';
      
  // Show file types..
  $accountLimits = str_replace(array('{title}','{data}'),array($msg_tempupload3,($MEMBER_INFO->filetypes ? str_replace(","," ".$SETTINGS->file_seperator." ",$MEMBER_INFO->filetypes) : $msg_tempupload7)),
                               file_get_contents(FOLDER_PATH.'templates/tpl_files/blockquote.tpl')
                               );
      
  // Show max size per file..
  $accountLimits .= str_replace(array('{title}','{data}'),array($msg_tempupload2,file_size_conversion($MEMBER_INFO->uploadmax,MGBS)),
                                file_get_contents(FOLDER_PATH.'templates/tpl_files/blockquote.tpl')
                                );
      
      
  $page_title_data = $msg_tempupload4;
      
  include(FOLDER_PATH.'inc/header.php');
      
  $tpl_upload =& new Savant2();
  $tpl_upload->assign('UPLOADMESSAGE', str_replace(array('{file_count}','{file_name}'),array($MEMBER_INFO->maxuploads,cleanData($SETTINGS->default_name)),$msg_tempupload));
  $tpl_upload->assign('UPLOAD_TEXT',$msg_tempupload4);
  $tpl_upload->assign('LIMITS', $accountLimits);
  $tpl_upload->assign('UPLOAD_FILE_FIELDS', showUploadFields($MEMBER_INFO->maxuploads));
  $tpl_upload->assign('UPLOADPROCESS', $msg_javascript67);
  $tpl_upload->display('templates/upload.tpl.php');

  include(FOLDER_PATH.'inc/footer.php');
  break;
  
  //===================
  // CASE: FTP
  //===================

  case "ftp":
  
  $files           = '';
  $EMAIL_REJECTED  = '';
  $EMAIL_FILES     = '';
  $fInfo           = '';
  $report_string   = '';
  $status          = '';
  $img             = '';
  $img_text        = '';
  
  if (!isset($MEMBER_INFO->id)) {
    header("Location: index.php");
    exit;
  }
  
  // Check for news..
  isNewsLive();
  
  // Has account been locked..
  if ($MEMBER_INFO->locklimit>0 && ($MEMBER_INFO->locklimit==$MEMBER_INFO->lockattempts))
  {
    $page_title_data = $msg_tempupload8;
    
    include(FOLDER_PATH.'inc/header.php');
                
    $tpl_error =& new Savant2();
    $tpl_error->assign('TEXT', $msg_tempupload8);
    $tpl_error->assign('MESSAGE', $msg_tempupload22);
    $tpl_error->display('templates/error.tpl.php');
                
    include(FOLDER_PATH.'inc/footer.php');
    exit;
  }
  
  // Check member can access this function..
  if (!$MEMBER_INFO->ftp_enable) {
    header("Location: index.php");
    exit;
  }
  
  if (isset($_POST['process']))
  {
    if (empty($_POST['file_name'])) {
      header("Location: index.php?cmd=ftp");
      exit;
    }
    
    // Specify allowable types for resizing..
    $resize_types  = array('image/jpeg','image/pjpeg');
    
    for ($i=0; $i<count($_POST['file_name']); $i++)
    {
      // Split file data..
      // [0] = Name, [1] = Status
      $parse = explode("##",$_POST['file'][$i]);
      
      // Clean up file name...
      $file  = filterUploadName($parse[0]);
      $name  = $_POST['file_name'][$i];
      $size  = filesize($SETTINGS->uploaddir.'/'.$MEMBER_INFO->accfolder.'/'.$MEMBER_INFO->ftp_folder.'/'.$parse[0]);
        
      // Process file or delete it..
      if ($parse[1]=='0')
      {
        include(FOLDER_PATH.'inc/mime_types.inc.php');
        
        // Pass vars to class..
        $MUP_UPL                   = new uploader();
        $MUP_UPL->prefix           = $database['prefix'];
        $MUP_UPL->name             = $name;
        $MUP_UPL->size             = $size;
        $MUP_UPL->type             = (isset($mime_types[strrchr(strtolower($parse[0]), '.')]) ? $mime_types[strrchr(strtolower($parse[0]), '.')] : $msg_userftp13);
        $MUP_UPL->storage          = getUsedStorageValue($MEMBER_INFO->id,true);
        $MUP_UPL->folder           = $MEMBER_INFO->accfolder;
        $MUP_UPL->folder_main      = $SETTINGS->uploaddir;
        $MUP_UPL->date             = date($SETTINGS->dateformat, strtotime(($SETTINGS->time_offset=='0' ? "+0 hours" : $SETTINGS->time_offset)));
        $MUP_UPL->allowed_storage  = $MEMBER_INFO->webspace;
        $MUP_UPL->img_width        = $SETTINGS->new_width;
        $MUP_UPL->img_height       = $SETTINGS->new_height;
        $MUP_UPL->width            = $SETTINGS->max_width;
        $MUP_UPL->height           = $SETTINGS->max_height;
        $MUP_UPL->id               = $MEMBER_INFO->id;
        $MUP_UPL->filename         = $file;
        $MUP_UPL->mgbs             = MGBS;
        $MUP_UPL->username         = $MEMBER_INFO->username;
        $MUP_UPL->email            = $MEMBER_INFO->email;
        
        // Is there enough storage for this file?
        if ($MUP_UPL->check_upload_size())
        {
          // Move file to account folder..
          if ($MUP_UPL->move_ftp_file($MEMBER_INFO->ftp_folder,$parse[0]))
          {
            $count++;
           
            // Resize image if too big and image resizing is enabled..
            if ($MEMBER_INFO->imageresize)
            {
              if (isset($mime_types[strrchr(strtolower($parse[0]), '.')]) 
                  && in_array($mime_types[strrchr(strtolower($parse[0]), '.')], $resize_types)
                 )
              {
                if ($MUP_UPL->image_resizer($file,DEBUG_MODE))
                {
                  $img       = 'okchanges.gif';
                  $img_text  = str_replace(array('{width}','{height}'),array($SETTINGS->new_width,$SETTINGS->new_height),$msg_userftp16);
                  $status    = str_replace(array('{width}','{height}'),array($SETTINGS->new_width,$SETTINGS->new_height),$msg_userftp16);

                  $resize    = true;
                }
              }
            }
            
            $EMAIL_FILES .= $msg_tempupload10.": ".($name ? $name : $SETTINGS->default_name).define_newline();
                               
            // Are hyperlinks enabled?
            if ($SETTINGS->email_links)
            {
              if ($MUP_MAIL->html) {
                $EMAIL_FILES .= $msg_tempupload11.": <a href='".$SETTINGS->url.'/'.$SETTINGS->uploaddir.'/'.$MEMBER_INFO->accfolder.'/'.$file."'>".$SETTINGS->url.'/'.$SETTINGS->uploaddir.'/'.$MEMBER_INFO->accfolder.'/'.$file."</a>".define_newline();
              } else {
                $EMAIL_FILES .= $msg_tempupload11.": ".$SETTINGS->url.'/'.$SETTINGS->uploaddir.'/'.$MEMBER_INFO->accfolder.'/'.$file.define_newline();
              }
            } else {
                $EMAIL_FILES .= $msg_tempupload11.": ".$file.define_newline();
            }

            $EMAIL_FILES .= $msg_tempupload12.": ".file_size_conversion($size,MGBS).define_newline();
            $EMAIL_FILES .= $msg_tempupload13.": ".$msg_tempupload14.(isset($resize) ? ' ('.$msg_tempupload21.')' : '').define_newline().define_newline();
            
            if (!isset($resize))
            {
              $img       = 'ok.gif';
              $img_text  = $msg_javascript72;
              $status    = $msg_userftp15;
            }
          }
        }
        else
        {
          $img      = 'error.gif';
          $img_text = $msg_javascript72;
          $status   = $msg_userftp18;

          $EMAIL_REJECTED .= $msg_tempupload10.": ".($name ? $name : $SETTINGS->default_name).define_newline();
          $EMAIL_REJECTED .= $msg_tempupload11.": ".$file.define_newline();
          $EMAIL_REJECTED .= $msg_tempupload12.": ".file_size_conversion($size,MGBS).define_newline();
          $EMAIL_REJECTED .= $msg_tempupload13.": ".$msg_tempupload18.define_newline().define_newline();     
        }
      }
      else
      {
        // Determine status message..
        switch ($parse[1]) {
          case '1': $status = $msg_tempupload17; break;
          case '2': $status = $msg_tempupload15; break;
          case '3': $status = $msg_userftp10;    break;
        }
        
        // Populate e-mail var..
        $EMAIL_REJECTED .= $msg_tempupload10.": ".($name ? $name : $SETTINGS->default_name).define_newline();
        $EMAIL_REJECTED .= $msg_tempupload11.": ".$file.define_newline();
        $EMAIL_REJECTED .= $msg_tempupload12.": ".file_size_conversion($size,MGBS).define_newline();
        $EMAIL_REJECTED .= $msg_tempupload13.": ".$status.define_newline().define_newline();
        
        // Delete file..
        if (file_exists($SETTINGS->uploaddir.'/'.$MEMBER_INFO->accfolder.'/'.$MEMBER_INFO->ftp_folder.'/'.$parse[0])) {
          unlink($SETTINGS->uploaddir.'/'.$MEMBER_INFO->accfolder.'/'.$MEMBER_INFO->ftp_folder.'/'.$parse[0]);
        }  
        
        // Set image preference..
        $img      = 'error.gif';
        $img_text = $msg_userftp17;
      }
      
      $fInfo = '
      <span class="text_bold">'.$msg_files3.'</span>: '.($name ? (strlen($name)>NAME_CHARS_TO_DISPLAY_UPLOAD ? cleanData(substr($name,0,NAME_CHARS_TO_DISPLAY_UPLOAD)).'...' : cleanData($name)) : cleanData($SETTINGS->default_name)).'<br />
      <span class="text_bold">'.$msg_files4.'</span>: '.(strlen($file)>NAME_CHARS_TO_DISPLAY_UPLOAD ? substr($file,0,NAME_CHARS_TO_DISPLAY_UPLOAD).'...' : cleanData($file)).'<br />
      <span class="text_bold">'.$msg_files5.'</span>: '.(isset($mime_types[strrchr(strtolower($parse[0]), '.')]) ? $mime_types[strrchr(strtolower($parse[0]), '.')] : $msg_userftp13).' | <span class="text_bold">'.$msg_files6.'</span>: '.file_size_conversion($size,MGBS);
      
      // Load file string..
      $find           = array('{file_info}','{image}','{image_text}','{message}');
      $replace        = array($fInfo,($parse[1]>0 ? $img : $img),($parse[1]>0 ? $img_text : $img_text),($parse[1]>0 ? $status.' <span class="text_bold_blue">'.$msg_userftp14.'</span>' : $status));
      $report_string .= str_replace($find,$replace,
                                    file_get_contents(FOLDER_PATH.'templates/tpl_files/upload_report_file.tpl')
                                    );
    }
    
    // Send mail..
    if ($count>0)
    {
      $MUP_MAIL->addTag('{USERNAME}', $MEMBER_INFO->username);
      $MUP_MAIL->addTag('{DATE}', date($SETTINGS->dateformat, strtotime(($SETTINGS->time_offset=='0' ? "+0 hours" : $SETTINGS->time_offset))));
      $MUP_MAIL->addTag('{FILES}', ($EMAIL_FILES ? trim($EMAIL_FILES) : $msg_script32));
      $MUP_MAIL->addTag('{REJECTED}', ($EMAIL_REJECTED ? trim($EMAIL_REJECTED) : $msg_script32));
        
      // Send e-mail to visitor if enabled..
      if ($SETTINGS->mail_message)
      {
        $MUP_MAIL->sendMail($MEMBER_INFO->username,
                            $MEMBER_INFO->email,
                            $SETTINGS->webname,
                            $SETTINGS->email,
                            '['.$SETTINGS->webname.'] '.$msg_userftp19,
                            $MUP_MAIL->template('templates/email/ftp_visitor.txt')
                            );
      }
      // Send e-mail to webmaster if enabled..
      if ($SETTINGS->mail_notify)
      {
        $MUP_MAIL->sendMail($SETTINGS->webname,
                            $SETTINGS->email,
                            $SETTINGS->webname,
                            $SETTINGS->email,
                            '['.$SETTINGS->webname.'] '.$msg_userftp19,
                            $MUP_MAIL->template('templates/email/ftp_webmaster.txt')
                            );
      }
    }
    
    $page_title_data = $msg_files2;

    include(FOLDER_PATH.'inc/header.php');
                
    $tpl_report =& new Savant2();
    $tpl_report->assign('TEXT', $msg_userftp11);
    $tpl_report->assign('MESSAGE', $msg_userftp12);
    $tpl_report->assign('FILES_PROCESSED', str_replace("{count}",count($_POST['file_name']),$msg_files7));
    $tpl_report->assign('FILES', $report_string);
    $tpl_report->display('templates/ftp_report.tpl.php');
                
    include(FOLDER_PATH.'inc/footer.php');
    exit;
  }
  
  // Load files in FTP directory into an array..
  $FTP = getFTPFiles($MEMBER_INFO->id,
                     $SETTINGS->uploaddir.'/'.$MEMBER_INFO->accfolder.'/'.$MEMBER_INFO->ftp_folder
                     );
  
  if (!empty($FTP))
  {
    for ($i=0; $i<(count($FTP)>$MEMBER_INFO->maxuploads ? $MEMBER_INFO->maxuploads : count($FTP)); $i++)
    {
      $split = explode("##",$FTP[$i]);
      
      switch ($split[1]) {
        case '0': $status = $msg_userftp5; break;
        case '1': $status = $msg_userftp6; break;
        case '2': $status = $msg_userftp7; break;
        case '3': $status = $msg_userftp8; break;
      }
      
      $find     = array('{ftp_process}','{file}','{name}','{optional}','{file_name}','{file_path}','{status}','{status_message}','{size}','{file_size}');
      $replace  = array(($split[1]>0 ? 'error' : 'process'),$msg_tempupload10,$msg_tempupload5,$msg_script27.'. '.str_replace("{count}",NAME_LENGTH,$msg_script39),$split[0],$split[0].'##'.$split[1],$msg_userftp4,$status,$msg_tempupload12,file_size_conversion(filesize($SETTINGS->uploaddir.'/'.$MEMBER_INFO->accfolder.'/'.$MEMBER_INFO->ftp_folder.'/'.$split[0]),MGBS));
  
      $files .= str_replace($find,$replace,
                            file_get_contents(FOLDER_PATH.'templates/tpl_files/ftp_upload_fields.tpl')
                            );                    
    }
  }
  
  // Allowable file types and max size..  
  $accountLimits = '';
      
  // Show file types..
  $accountLimits = str_replace(array('{title}','{data}'),array($msg_tempupload3,($MEMBER_INFO->filetypes ? str_replace(","," ".$SETTINGS->file_seperator." ",$MEMBER_INFO->filetypes) : $msg_tempupload7)),
                               file_get_contents(FOLDER_PATH.'templates/tpl_files/blockquote.tpl')
                               );
      
  // Show max size per file..
  $accountLimits .= str_replace(array('{title}','{data}'),array($msg_tempupload2,file_size_conversion($MEMBER_INFO->uploadmax,MGBS)),
                                file_get_contents(FOLDER_PATH.'templates/tpl_files/blockquote.tpl')
                                );
                                
  // How many files were found..
  if (count($FTP)>0)
  {
    $found = str_replace('{message}',str_replace("{count}",(count($FTP)>$MEMBER_INFO->maxuploads ? $MEMBER_INFO->maxuploads : count($FTP)),$msg_userftp3),
                         file_get_contents(FOLDER_PATH.'templates/tpl_files/general_message.tpl')
                         );
  }                              
  
  $page_title_data = $msg_header52;
      
  include(FOLDER_PATH.'inc/header.php');
      
  $tpl_ftp =& new Savant2();
  $tpl_ftp->assign('FTPMESSAGE', str_replace("{count}",$MEMBER_INFO->maxuploads,$msg_userftp));
  $tpl_ftp->assign('FTP_TEXT', $msg_header52);
  $tpl_ftp->assign('FTP_HOST_TEXT', $msg_manage90);
  $tpl_ftp->assign('FTP_HOST', $MEMBER_INFO->ftp_host);
  $tpl_ftp->assign('FTP_USER_TEXT', $msg_manage91);
  $tpl_ftp->assign('FTP_USER', $MEMBER_INFO->ftp_user);
  $tpl_ftp->assign('FTP_PASS_TEXT', $msg_manage92);
  $tpl_ftp->assign('FTP_PASS', $MEMBER_INFO->ftp_pass);
  $tpl_ftp->assign('LIMITS', $accountLimits);
  $tpl_ftp->assign('FTP_FILES_FOUND', (isset($found) ? $found : ''));
  $tpl_ftp->assign('FTP_FILES', $files);
  $tpl_ftp->assign('NO_FILES', $msg_userftp2);
  $tpl_ftp->assign('FTPRUN', ($files ? true : false));
  $tpl_ftp->assign('FTPPROCESS', $msg_userftp9);
  $tpl_ftp->display('templates/ftp.tpl.php');

  include(FOLDER_PATH.'inc/footer.php');
  
  break;

  //===================
  // CASE: VIEW
  //===================

  case "view":

  if (!isset($MEMBER_INFO->id)) {
    header("Location: index.php");
    exit;
  }
  
  // Check for news..
  isNewsLive();
  
  $file_uploads     = '';
  $process_message  = '';
  $memFiles         = '';
  $user             = (isset($_GET['user']) ? strip_tags($_GET['user']) : '');
  
  // Update file name..
  if (isset($_POST['process_file_name']))
  {
    mysql_query("UPDATE ".$database['prefix']."uploads SET
                 file_name  = '".mysql_real_escape_string(($_POST['name'] ? $_POST['name'] : $SETTINGS->default_name))."'
                 WHERE id   = '".$_POST['file']."'
                 LIMIT 1
                 ") or die(mysql_error());
                 
    if ($_POST['page']=='view') {
      header("Location: index.php?cmd=view&page=".$_SESSION['view_page']."");
    } else {
      header("Location: index.php?cmd=search&keywords=".urlencode($_SESSION['search_keys'])."&filter=".$_SESSION['search_filter']."&page=".$_SESSION['search_page']."");
    } 
    exit;            
  }
  
  // Check permissions if user var is present..
  if ($user)
  {
    $MEM = $MUP_ACC->acc_data('',$user);
    
    if ($MEMBER_INFO->viewfiles=='no' || 
       ($MEMBER_INFO->viewfiles=='same' && $MEMBER_INFO->accid!=$MEM->accid)
       )
    {
      header("Location: index.php");
      exit;
    }
    
    // If no user was found, direct to homepage..
    if (!$MUP_ACC->acc_data('',$user))
    {
      header("Location: index.php");
      exit;
    }
  }
      
  //-----------------------
  // SCRIPT ACTION
  // Process Options
  //-----------------------

  if (isset($_POST['process']))
  {
    $option    = $_POST['option'];
    $fileinfo  = (isset($_POST['fileinfo']) ? $_POST['fileinfo'] : '');
        
    // Back to view page if nothing is selected..
    if (empty($fileinfo)) { header("Location: index.php?cmd=view");exit; }

    switch ($option)
    {
      // Delete files..
      case "del":
                     
      // Delete files, reduce count and delete file info
      for ($i=0; $i<count($fileinfo); $i++)
      {
        $DATA = explode("###", $fileinfo[$i]);

        // $DATA[0] => File ID. Delete from database..
                          
        mysql_query("DELETE FROM ".$database['prefix']."uploads 
                     WHERE id       = '".$DATA[0]."' 
                     AND user_id    = '".$MEMBER_INFO->id."' 
                     AND user_name  = '".$MEMBER_INFO->username."' 
                     LIMIT 1
                     ") or die(mysql_error());
                          
        // $DATA[1] => File Path. Delete file from upload directory..
                          
        if (file_exists($SETTINGS->uploaddir.'/'.$MEMBER_INFO->accfolder.'/'.$DATA[1]))
        {
          unlink($SETTINGS->uploaddir.'/'.$MEMBER_INFO->accfolder.'/'.$DATA[1]);
        }          
              
        unset($DATA);
      }
                          
      header("Location: index.php?cmd=".(isset($_POST['search']) ? 'search&keywords='.urlencode($_SESSION['search_keys']).'&filter='.$_SESSION['search_filter'].'&page='.$_SESSION['search_page'] : 'view')."");
      exit;
        
      break;

      // Download in .zip archive..
      case "zip":
                     
      // Can member access this functions..
      if (!$MEMBER_INFO->zipcompress)
      {
        header("Location: index.php");
        exit;
      }
      else
      {
        $MUP_ZIP->AddDirectory($MEMBER_INFO->accfolder."/");
                               
        for ($i=0; $i<count($fileinfo); $i++)
        {
          $DATA = explode("###", $fileinfo[$i]);
          $FILE = loadFileDataToString($DATA[2],'',''); 
                                    
          // $DATA[1] => File path. Use this to load file into archive..
                                    
          if (file_exists($SETTINGS->uploaddir.'/'.$FILE->folder_name.'/'.$DATA[1]))
          {
            $getContents = file_get_contents($SETTINGS->uploaddir.'/'.$FILE->folder_name.'/'.$DATA[1]);
                                         
            $MUP_ZIP->addFile($getContents, $MEMBER_INFO->accfolder."/".$DATA[1]);
          }
                                    
          unset($DATA);
        }
                               
        // Create .zip file and force download..
          
        $ZIPFILENAME  = "log/files.zip";
        $fd           = fopen ($ZIPFILENAME, "wb");
        $out          = fwrite ($fd, $MUP_ZIP->getZippedfile());
        fclose ($fd);

        $MUP_ZIP->forceDownload($ZIPFILENAME);
                               
        if (file_exists($ZIPFILENAME)) {
          unlink($ZIPFILENAME);
        }  

        exit;
      }
        
      break;
     }
  }   

  // Load file based on option..
  // View => View file
  // Media => Play file
  // Download => Download file
  if (isset($_GET['view']) || 
      isset($_GET['media']) || 
      isset($_GET['download']) || 
      isset($_GET['mp3']) ||
      isset($_GET['flv'])
      )
  {
    $mp_flv    = (isset($_GET['mp3']) ? strip_tags($_GET['mp3']) : (isset($_GET['flv']) ? strip_tags($_GET['flv']) : ''));
    $view      = (isset($_GET['view']) ? strip_tags($_GET['view']) : '');
    $media     = (isset($_GET['media']) ? strip_tags($_GET['media']) : ($mp_flv ? $mp_flv : ''));
    $download  = (isset($_GET['download']) ? strip_tags($_GET['download']) : '');
     
    // Security check..
    if (($view && !ctype_alnum($view)) || 
        ($media && !ctype_alnum($media)) || 
        ($download && !ctype_alnum($download))
       )
    {
      header("Location: index.php");
    }
         
    // Load file data into string..
    $FILE = loadFileDataToString($view,$media,$download);     
         
    // View files...
    if ($view)
    {
      // Double check member can view this file...
      if (($FILE->user_id!=$MEMBER_INFO->id) && ($MEMBER_INFO->viewfiles=='no'))
      {
        header("Location: index.php");
        exit;
      }
       
      include(FOLDER_PATH.'inc/popup/view_file.php');
      exit;
    }
    
    // Force download..
    if ($download)
    {
      if (isset($_SERVER['HTTP_USER_AGENT']) && preg_match("/MSIE/", $_SERVER['HTTP_USER_AGENT']))
      {
        if(ini_get('zlib.output_compression'))
        {
          ini_set('zlib.output_compression', 'Off');
        }
      }
      
      if (file_exists($SETTINGS->uploaddir.'/'.$FILE->folder_name.'/'.$FILE->upload_name))
      {
        header('Pragma: public');
        header('Expires: 0');
        header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
        header('Cache-Control: private', false);
        header('Content-Type: '.$FILE->file_type);
        header('Content-Disposition: attachment; filename='.basename(FOLDER_PATH.$SETTINGS->uploaddir.'/'.$FILE->folder_name.'/'.$FILE->upload_name));
        header('Content-Transfer-Encoding: binary');
        header('Content-Length: '.filesize(FOLDER_PATH.$SETTINGS->uploaddir.'/'.$FILE->folder_name.'/'.$FILE->upload_name));
        
        readfile(FOLDER_PATH.$SETTINGS->uploaddir.'/'.$FILE->folder_name.'/'.$FILE->upload_name);
        exit;
      }
    }
     
    // Play file..
    if ($media || isset($_GET['mp3']) || isset($_GET['flv']))
    {
      include(FOLDER_PATH.'inc/flash_functions.php');
       
      // MP3 Player. Added in v4.0
      if (isset($_GET['mp3']))
      {
        $tpl_mp3 =& new Savant2();
        $tpl_mp3->assign('LOAD_MEDIA_DATA', mp3_player($SETTINGS->uploaddir.'/'.$FILE->folder_name.'/'.$FILE->upload_name,cleanData($FILE->file_name)));
        $tpl_mp3->assign('TEXT',$msg_script37);
        $tpl_mp3->display('templates/multimedia_mp3.tpl.php');
        exit;
      }
       
      // FLV Player. Added in v4.0
      if (isset($_GET['flv']))
      {
        $tpl_flv =& new Savant2();
        $tpl_flv->assign('LOAD_MEDIA_DATA', flv_player($SETTINGS->url.'/'.$SETTINGS->uploaddir.'/'.$FILE->folder_name,$FILE->upload_name,$SETTINGS->url));
        $tpl_flv->display('templates/multimedia_flv.tpl.php');
        exit;
      }
      
      include(FOLDER_PATH.'inc/popup/play_file.php');
      exit;
    }
  }

  // Order by options when loaded..
  if (isset($_GET['orderby']))
  {
    switch ($_GET['orderby'])
    {
      case "smallest": $SQLOB = ' ORDER BY file_size';              break;
      case "largest":  $SQLOB = ' ORDER BY file_size DESC';         break;
      case "oldest":   $SQLOB = ' ORDER BY file_filter_date';       break;
      case "newest":   $SQLOB = ' ORDER BY file_filter_date DESC';  break;
      case "name":     $SQLOB = ' ORDER BY file_name';              break;
      case "admin":    $SQLOB = ' ORDER BY admin_status DESC';      break;
      default: header("Location: index.php");                       break;
    }
  }
  
  if (isset($_GET['display'])) {
   $limitvalue = $page * $_GET['display'] - ($_GET['display']);
  }
      
  // Get file count for member..
  $q_file_count = mysql_query("SELECT count(*) as file_count FROM ".$database['prefix']."uploads 
                               WHERE user_id   = '".(isset($MEM) ? $MEM->id : $MEMBER_INFO->id)."' 
                               AND user_email  = '".(isset($MEM) ? $MEM->email : $MEMBER_INFO->email)."'
                               ") or die(mysql_error());
  $COUNT = mysql_fetch_object($q_file_count);
     
  // Get file uploads..
  $q_files = mysql_query("SELECT * FROM ".$database['prefix']."uploads 
                          WHERE user_id  = '".(isset($MEM) ? $MEM->id : $MEMBER_INFO->id)."' 
                          AND user_email = '".(isset($MEM) ? $MEM->email : $MEMBER_INFO->email)."'
                          ".(isset($SQLOB) ? $SQLOB : 'ORDER BY id DESC')." 
                          LIMIT $limitvalue, ".(isset($_GET['display']) ? $_GET['display'] : $SETTINGS->data_per_page)."
                          ") or die(mysql_error());
     
  if (mysql_num_rows($q_files)==0)
  {
    // Load data into string..
    $memFiles = str_replace('{message}',$msg_view3,
                            file_get_contents(FOLDER_PATH.'templates/tpl_files/general_message.tpl')
                            );
  }
  else
  {
    $display_image  = '';
    $codegen        = '';
    
    while ($FILES = mysql_fetch_object($q_files))
    {
      $imgPreview = '';
      
      // Determine which link to show based on mime type..
      // For media, mp3/mp4 and flv files overwrite mime type and launch player..
      if (in_array($FILES->file_type, getMimeTypes('view')))
      {
        $display_image = '<a href="'.($SETTINGS->greybox && substr($FILES->file_type,0,5)=='image' ? $SETTINGS->uploaddir.'/'.$FILES->folder_name.'/'.$FILES->upload_name.'" title="'.substr(cleanData($FILES->file_name),0,NAME_CHARS_TO_DISPLAY_GREYBOX).'" rel="gb_image[]"' : 'javascript:viewFile(\'index.php?cmd=view&amp;view='.$FILES->uni_code.'\')"').'><img class="button_image" src="images/buttons/view.gif" title="'.$msg_view22.'" alt="'.$msg_view22.'" /></a>';
      }
      else if (in_array($FILES->file_type, getMimeTypes('download')))
      {
        $display_image = '<a href="index.php?cmd=view&amp;download='.$FILES->uni_code.'"><img class="button_image" src="images/buttons/download.gif" title="'.$msg_view30.'" alt="'.$msg_view30.'" /></a>';
      }
      else if (in_array($FILES->file_type, getMimeTypes('media')))
      {
        $musicFiles    = array('mp3','mp4');
        $display_image = '<a href="'.(in_array(strtolower(substr($FILES->upload_name,-3)),$musicFiles) && $SETTINGS->enable_mp3 ? 'index.php?cmd=view&amp;mp3='.$FILES->uni_code.'" rel="gb_page_center['.MP3_WINDOW_SIZE.']"' : (strtolower(substr($FILES->upload_name,-3))=='flv' && $SETTINGS->enable_flv ? 'index.php?cmd=view&amp;flv='.$FILES->uni_code.'" rel="gb_page_center['.FLV_WINDOW_SIZE.']"' : 'javascript:viewMedia(\'index.php?cmd=view&amp;media='.$FILES->uni_code.'\')"')).'><img class="button_image" src="images/buttons/media.gif" title="'.$msg_view29.'" alt="'.$msg_view29.'" /></a>';
      }
      else
      {
        $display_image = '<a href="index.php?cmd=view&amp;download='.$FILES->uni_code.'"><img class="button_image" src="images/buttons/download.gif" title="'.$msg_view30.'" alt="'.$msg_view30.'" /></a>';
      }
               
      // Is code generator enabled..
      if ($MEMBER_INFO->codegen)
      {
        $codegen = '<a href="index.php?cmd=codegen&amp;code='.$FILES->uni_code.'" rel="gb_page_center['.CODEGEN_WINDOW_SIZE.']"><img class="button_image" src="images/buttons/codegen.gif" title="'.$msg_codegen2.'" alt="'.$msg_codegen2.'" /></a>';
      }
      
      // Are we showing javascript image preview?
      if ($SETTINGS->thumb_width>0 && 
          $SETTINGS->thumb_height>0 && 
          substr($FILES->file_type,0,5)=='image')
      {
        $imgPreview = '<a href="javascript:void(0);" onmouseover="return overlib(\''.imagePreviewBuilder($SETTINGS->url.'/'.$SETTINGS->uploaddir.'/'.$FILES->folder_name.'/'.$FILES->upload_name,$SETTINGS->thumb_width,$SETTINGS->thumb_height,cleanData($FILES->file_name)).'\',ol_width=\''.($SETTINGS->thumb_width+10).'\', CENTER);" onmouseout="nd();"><img class="button_image" src="images/buttons/preview.gif" title="'.$msg_javascript16.'" alt="'.$msg_javascript16.'" /></a>';
      }
               
      // File data..
      $fileData = '&#8226; <span class="text_bold">'.$msg_view12.'</span>: '.substr(cleanData($FILES->file_name),0,NAME_CHARS_TO_DISPLAY).($FILES->admin_status==1 ? ' (<span class="admin_files">'.$msg_view33.'</span>)' : '').' '.($MEMBER_INFO->id==$FILES->user_id && $MEMBER_INFO->rename_files ? '[<a href="javascript:void(0);" onclick="return overlib(\''.fileNameBuilder($FILES->user_id,cleanData($FILES->file_name),$FILES->id,'form_box','button','view').'\',STICKY,CAPTION,\''.$msg_manage95.'\',RIGHT,ol_width=\'275\');" onmouseout="nd();" title="'.$msg_script15.'">'.$msg_script15.'</a>]' : '').'<br />
                   &#8226; <span class="text_bold">'.$msg_view13.'</span>: '.$FILES->upload_name.'<br />
                   &#8226; <span class="text_bold">'.$msg_view24.'</span>: '.file_size_conversion($FILES->file_size,MGBS).' | <span class="text_bold">'.$msg_view14.'</span>: '.$FILES->file_type.'<br />
                   &#8226; <span class="text_bold">'.$msg_view15.'</span>: '.$FILES->file_date;
      
      // Load data into string..
      $find      = array('{files}','{options}','{checkbox}');
      $replace   = array($fileData,$display_image.$codegen.$imgPreview,(!$MEMBER_INFO->zipcompress && isset($MEM) ? '' : '<input type="checkbox" name="fileinfo[]" value="'.$FILES->id.'###'.$FILES->upload_name.'###'.$FILES->uni_code.'" />'));
      $memFiles .= str_replace($find,$replace,
                               file_get_contents(FOLDER_PATH.'templates/tpl_files/file_box.tpl')
                               );
                                
      unset($fileSize);
    }
           
    // Which options are we showing..
    $fileOptions = ($MEMBER_INFO->zipcompress ? '<span class="radio_button"><input type="radio" name="option" value="zip" checked="checked" /></span><span class="text_bold">'.$msg_view18.'</span>' : '').
                  (!isset($MEM) ? '<span class="radio_button"><input type="radio" name="option" value="del"'.(!$MEMBER_INFO->zipcompress ? ' checked="checked"' : ' ').' /></span><span class="text_bold">'.$msg_view17.'</span>' : '');
           
    // Load data into string..
    if ($fileOptions)
    {
      $find      = array('{options}','{process}');
      $replace   = array($fileOptions,$msg_view19);
      $memFiles .= str_replace($find,$replace,
                               file_get_contents(FOLDER_PATH.'templates/tpl_files/file_options.tpl')
                               );
    }
    
    // Set session var..
    $_SESSION['view_page'] = $page;
  }
      
  $page_title_data = (isset($MEM) ? $msg_viewfiles3 : $msg_view2);

  include(FOLDER_PATH.'inc/header.php');

  //--------------------
  // Order by options..
  //--------------------
     
  $ob_options = array('smallest' => $msg_view5,
                      'largest'  => $msg_view6,
                      'oldest'   => $msg_view7,
                      'newest'   => $msg_view8,
                      'name'     => $msg_view9,
                      'admin'    => $msg_view32
                      );
      
  $order_option = $msg_view4.':
  <select onchange="if(this.value!= 0){location=this.options[this.selectedIndex].value}">
  <option value="0">-</option>';
      
  foreach ($ob_options AS $ob => $ob_name)
  {
    $order_option .= '<option'.(isset($_GET['orderby']) && $_GET['orderby']==$ob ? ' selected ' : ' ').'value="index.php?cmd=view'.($user ? '&amp;user='.$user : '').'&amp;orderby='.$ob.(isset($_GET['display']) ? '&amp;display='.$_GET['display'] : '').(isset($_GET['page']) ? '&amp;page='.$_GET['page'] : '').'">'.$ob_name.'</option>'."\n";
  }
      
  $order_option .= '</select>
  ';
      
  //----------------------------
  // Total options per page..
  //----------------------------
  
  $d_options = explode(",",$SETTINGS->per_page_options);

  $view_option = $msg_view10.'
  <select onchange="if(this.value!= 0){location=this.options[this.selectedIndex].value}">
  <option value="0">-</option>';
             
  foreach ($d_options AS $totals)
  {
    $view_option .= '<option'.(isset($_GET['display']) && $_GET['display']==$totals ? ' selected ' : ' ').'value="index.php?cmd=view'.($user ? '&amp;user='.$user : '').(isset($_GET['orderby']) ? '&amp;orderby='.$_GET['orderby'] : '').'&amp;display='.$totals.(isset($_GET['page']) ? '&amp;page='.$_GET['page'] : '').'">'.$totals.'</option>'."\n";
  }
             
  $view_option .= '
  </select> '.$msg_view11;

  $tpl_view =& new Savant2();
  $tpl_view->assign('VIEWMESSAGE', (isset($MEM) ? $msg_viewfiles : $msg_view));
  $tpl_view->assign('VIEWMESSAGE2', (isset($MEM) ? $msg_viewfiles3 : $msg_view2));
  $tpl_view->assign('VIEWSTORAGE' , (isset($MEM) ? $msg_viewfiles2.': '.cleanData($MEM->username).($MEMBER_INFO->contact ? ' | <a href="index.php?cmd=conmember&amp;user='.cleanData($MEM->username).'" title="'.$msg_conmember3.'">'.$msg_conmember3.'</a>' : '') : getUsedStorageValue($MEMBER_INFO->id).' '.$msg_home11.' '.$MEMBER_INFO->webspace.'MB'));
  $tpl_view->assign('VIEWOPTION', $view_option);
  $tpl_view->assign('ORDERBYOPTION', $order_option);
  $tpl_view->assign('FILESTEXT', $msg_view2);
  $tpl_view->assign('SELECTALL', $msg_view31);
  $tpl_view->assign('FILEUPLOADS', $memFiles);
  $tpl_view->assign('PAGENUMBERS', ($COUNT->file_count>0 ? page_numbers($COUNT->file_count,(isset($_GET['display']) ? $_GET['display'] : $SETTINGS->data_per_page),$page) : ''));
  $tpl_view->assign('AREYOUSURE', $msg_javascript);
  $tpl_view->display('templates/view.tpl.php');
   
  include(FOLDER_PATH.'inc/footer.php');
  break;
      
  //===================
  // CASE: VIEWMEMBER
  //===================

  case "viewmember":
      
  if (!isset($MEMBER_INFO->id)) {
    header("Location: index.php");
    exit;
  }
  
  // Check for news..
  isNewsLive();
      
  // Firstly, make sure that member can view this section
  if ($MEMBER_INFO->viewfiles=='no')
  {
    header("Location: index.php");
    exit;
  }
      
  $otherMemData = '';

  $other_count = mysql_query("SELECT count(*) as file_count FROM ".$database['prefix']."members 
                               WHERE id     != '".$MEMBER_INFO->id."' 
                               AND activate  = '1'
                               ".($MEMBER_INFO->viewfiles=='all' ? '' : 'AND accid = \''.$MEMBER_INFO->accid.'\'')."") or die(mysql_error());
  $COUNT = mysql_fetch_object($other_count);
      
  $q_othermembers = mysql_query("SELECT * FROM ".$database['prefix']."members 
                                 WHERE id     != '".$MEMBER_INFO->id."' 
                                 AND activate  = '1' 
                                 ".($MEMBER_INFO->viewfiles=='all' ? '' : 'AND accid = \''.$MEMBER_INFO->accid.'\'')."
                                 ORDER BY username 
                                 LIMIT $limitvalue,$SETTINGS->data_per_page
                                 ") or die(mysql_error());

  while ($MEMBERS = mysql_fetch_object($q_othermembers))
  {
    // Build username/file count string..
    $inString = '<span class="text_bold">'.$msg_viewmember4.'</span>: '.cleanData($MEMBERS->username).'<br />
                 <span class="text_bold">'.$msg_viewmember5.'</span>: '.getFileCount($MEMBERS->id);
    
    $find          = array('{name}','{user}','{view}');
    $replace       = array($inString,$MEMBERS->username,$msg_viewmember6);
    $otherMemData  .= str_replace($find,$replace,
                                  file_get_contents(FOLDER_PATH.'templates/tpl_files/other_members_file_box.tpl')
                                  );
  }
  
  if ($COUNT->file_count==0)
  {
    // Load data into string..
    $otherMemData = str_replace('{message}',$msg_viewmember7,
                                file_get_contents(FOLDER_PATH.'templates/tpl_files/general_message.tpl')
                                );
  }
      
  $page_title_data = $msg_viewfiles3;

  include(FOLDER_PATH.'inc/header.php');
  $tpl_viewmember =& new Savant2();
  $tpl_viewmember->assign('VIEWMESSAGE', ($MEMBER_INFO->viewfiles=='all' ? $msg_viewmember2 : $msg_viewmember));
  $tpl_viewmember->assign('VIEWTEXT', $msg_viewfiles3);
  $tpl_viewmember->assign('TOTAL', str_replace("{count}",mysql_num_rows($q_othermembers),$msg_viewmember3));
  $tpl_viewmember->assign('ACCOUNTS', $otherMemData);
  $tpl_viewmember->assign('PAGENUMBERS', ($COUNT->file_count>0 ? page_numbers($COUNT->file_count,$SETTINGS->data_per_page,$page) : ''));
  $tpl_viewmember->display('templates/viewmember.tpl.php');
  include(FOLDER_PATH.'inc/footer.php');
      
  break;

  //===================
  // CASE: CODEGEN
  //===================

  case "codegen":
   
  if (!isset($MEMBER_INFO->id)) {
    header("Location: index.php");
    exit;
  }
   
  // Check code is alphanumeric..
  if (isset($_GET['code']) && !ctype_alnum($_GET['code']))
  {
    header("Location: index.php");
    exit;
  }   
   
  // Get file data..
  $FILE = loadFileDataToString($_GET['code'],'',''); 
  $type = 'download';
  // Check to make sure member can access this file..
  if (($FILE->user_id!=$MEMBER_INFO->id) && ($MEMBER_INFO->viewfiles=='no'))
  {
    header("Location: index.php");
    exit;
  } 
   
  // Determine file type for this file..
  if(in_array($FILE->file_type, getMimeTypes('view'))) {
    $type = 'view';
  } else if (in_array($FILE->file_type, getMimeTypes('download'))) {
    $type = 'download';
  } else if (in_array($FILE->file_type, getMimeTypes('media'))) {
    $type = 'media';
  }
   
  // Path to file..
  $path = $SETTINGS->url.'/'.$SETTINGS->uploaddir.'/'.$FILE->folder_name.'/'.$FILE->upload_name;
   
  // Send e-mail with code..
  $MUP_MAIL->addTag('{NAME}',$MEMBER_INFO->username);
  $MUP_MAIL->addTag('{FILE}',$FILE->file_name);
  $MUP_MAIL->addTag('{TYPE}',$FILE->file_type);
  $MUP_MAIL->addTag('{HTML_CODE}',$MUP_MAIL->codeGenerator(false,$type,$FILE->upload_name,$path,$FILE->file_name,$FILE->file_type));
  $MUP_MAIL->addTag('{BB_CODE}',$MUP_MAIL->codeGenerator(true,$type,$FILE->upload_name,$path,$FILE->file_name,$FILE->file_type));
   
  $MUP_MAIL->sendMail($MEMBER_INFO->username,
                      $MEMBER_INFO->email,
                      $SETTINGS->webname,
                      $SETTINGS->email,
                      '['.$SETTINGS->webname.'] '.$msg_script38,
                      $MUP_MAIL->template('templates/email/codegen_message.txt')
                      );
   
  $tpl_sent =& new Savant2();
  $tpl_sent->assign('CODE_SENT', $msg_script36);
  $tpl_sent->assign('TEXT', $msg_script35);
  $tpl_sent->display('templates/code_sent.tpl.php');
   
  break;

  //===================
  // CASE: PASS
  //===================

  case "pass":
      
  if (!isset($MEMBER_INFO->id)) {
    header("Location: index.php");
    exit;
  }
   
  if (!$SETTINGS->pass_update) {
    header("Location: index.php");
    exit;
  }
     
  // Check for news..
  isNewsLive();
  
  //-----------------------
  // SCRIPT ACTION
  // Change Password
  //-----------------------
      
  if (isset($_POST['process']))
  {
    // Apply call back element to trim post vars..
    $_POST = array_map('trim',$_POST);
     
    if (md5($_POST['cur_pass'])!=$MEMBER_INFO->accpass)
    {
      $CP_ERROR = $msg_password6;
      $count++;
    }
    if ($count==0 && ($_POST['cur_pass']==$_POST['new_pass']))
    {
      $CP_ERROR = $msg_password7;
      $count++;
    }
    if ($count==0 && ($_POST['new_pass']!=$_POST['new_pass2']))
    {
      $P2_ERROR = $msg_password8;
      $count++;
    }
    if ($count==0 && (strlen($_POST['new_pass'])<5 || strlen($_POST['new_pass'])>10 || !ctype_alnum($_POST['new_pass'])))
    {
      $P_ERROR = $msg_password9;
      $count++;
    }
    if ($count==0)
    {
      $MUP_MAIL->addTag('{NAME}',$MEMBER_INFO->username);
      $MUP_MAIL->addTag('{PASSWORD}',$_POST['new_pass']);
       
      // Update..
      $MUP_ACC->update_password_sql($_POST['new_pass'],$MEMBER_INFO->email);
       
      // Send confirmation..
      $MUP_MAIL->sendMail($MEMBER_INFO->username,
                          $MEMBER_INFO->email,
                          $SETTINGS->webname,
                          $SETTINGS->email,
                          '['.$SETTINGS->webname.'] '.$msg_password11,
                          $MUP_MAIL->template('templates/email/change_password.txt')
                          );
                           
      $UPDATED = true;
    }
  }
   
  $page_title_data = $msg_password2;
   
  include(FOLDER_PATH.'inc/header.php');
   
  $tpl_pass =& new Savant2();
  $tpl_pass->assign('FORM_DISPLAY', (isset($UPDATED) ? ' style="display:none"' : ''));
  $tpl_pass->assign('PASSWORDMESSAGE', (isset($UPDATED) ? $msg_password12 : $msg_password));
  $tpl_pass->assign('PASSTEXT', (isset($UPDATED) ? $msg_password10 : $msg_password2));
  $tpl_pass->assign('CURRTEXT', $msg_password3);
  $tpl_pass->assign('NEWTEXT', $msg_password4);
  $tpl_pass->assign('RETYPETEXT', $msg_password5);
  $tpl_pass->assign('CURVALUE', (isset($_POST['cur_pass']) ? cleanData($_POST['cur_pass']) : ''));
  $tpl_pass->assign('NEWPASSVALUE', (isset($_POST['new_pass']) ? cleanData($_POST['new_pass']) : ''));
  $tpl_pass->assign('NEWPASSVALUE2', (isset($_POST['new_pass2']) ? cleanData($_POST['new_pass2']) : ''));
  $tpl_pass->assign('CP_ERROR', (isset($CP_ERROR) ? '<br /><span class="error">'.$CP_ERROR.'</span>' : ''));
  $tpl_pass->assign('P_ERROR', (isset($P_ERROR) ? '<br /><span class="error">'.$P_ERROR.'</span>' : ''));
  $tpl_pass->assign('P2_ERROR', (isset($P2_ERROR) ? '<br /><span class="error">'.$P2_ERROR.'</span>' : ''));
  $tpl_pass->display('templates/pass.tpl.php');
  
  include(FOLDER_PATH.'inc/footer.php');
  break;
      
  //===================
  // CASE: EMAIL
  //===================

  case "email":
      
  if (!isset($MEMBER_INFO->id)) {
    header("Location: index.php");
    exit;
  }
  
  // Check for news..
  isNewsLive();
      
  //-----------------------
  // SCRIPT ACTION
  // Change E-Mail Address
  //-----------------------
     
  if (isset($_POST['process']))
  {
    if (!eregi("^([a-z]|[0-9]|\.|-|_)+@([a-z]|[0-9]|\.|-|_)+\.([a-z]|[0-9]){2,4}$", trim($_POST['email'])))
    {
      $E_ERROR = $msg_usercreate6;
      $count++;
    }
    if ($count==0 && $MUP_ACC->is_email_unique($_POST['email'],$MEMBER_INFO->id))
    {
      $E_ERROR = $msg_email5;
      $count++;
    }
    if ($count==0)
    {
      // Update email address..
      $MUP_ACC->update_email_sql($_POST['email'],$MEMBER_INFO->id);
       
      // Destroy cookie vars if set..
      if ($ULN_COOKIE)
      {
        setcookie("uploader_user_cookie", "");
        setcookie("uploader_email_cookie", "");
        unset($_COOKIE,$ULN_COOKIE,$ULE_COOKIE);
      }
       
      // Update session var. Takes affect on next re-load and keeps session alive..
      $_SESSION['uploader_mem_user']   = $MEMBER_INFO->username;
      $_SESSION['uploader_mem_email']  = $_POST['email'];
       
      $UPDATED = true;
    }
  }
   
  $page_title_data = $msg_email2;

  include(FOLDER_PATH.'inc/header.php');
      
  $tpl_email =& new Savant2();
  $tpl_email->assign('FORM_DISPLAY', (isset($UPDATED) ? ' style="display:none"' : ''));
  $tpl_email->assign('EMAILMESSAGE', (isset($UPDATED) ? $msg_email6 : $msg_email));
  $tpl_email->assign('EMAILTEXT', (isset($UPDATED) ? $msg_email4 : $msg_email2));
  $tpl_email->assign('NEWTEXT', $msg_email3);
  $tpl_email->assign('E_ERROR',(isset($E_ERROR) ? '<br /><span class="error">'.$msg_email5.'</span>' : ''));
  $tpl_email->assign('EMAILVALUE', (isset($_POST['email']) ? cleanData($_POST['email']) : $MEMBER_INFO->email));
  $tpl_email->display('templates/email.tpl.php');
   
  include(FOLDER_PATH.'inc/footer.php');
  break;
      
  //===================
  // CASE: CONTACT
  //===================

  case "contact":
      
  if (isset($_POST['process']))
  {
    // Apply call back element to trim post vars..
    $_POST = array_map('trim',$_POST);
               
    if ($_POST['name']=='')
    {
      $N_ERROR = true;
      $count++;
    }
    if (!eregi("^([a-z]|[0-9]|\.|-|_)+@([a-z]|[0-9]|\.|-|_)+\.([a-z]|[0-9]){2,4}$", $_POST['email']))
    {
      $E_ERROR = true;
      $count++;
    }
    if ($_POST['subject']=='')
    {
      $S_ERROR = true;
      $count++;
    }
    if ($_POST['comments']=='')
    {
      $C_ERROR = true;
      $count++;
    }
    if ($SETTINGS->captcha_code && isset($_POST['code']))
    {
      if (!PhpCaptcha::Validate($_POST['code'])) {
       $SUM_ERROR = true;
       $count++;
      }
    }
               
    if ($count==0)
    {
      $MUP_MAIL->addTag('{NAME}',cleanEvilTags($_POST['name'],true));
      $MUP_MAIL->addTag('{EMAIL}',$_POST['email']);
      $MUP_MAIL->addTag('{COMMENTS}',cleanEvilTags($_POST['comments'],true));
      $MUP_MAIL->addTag('{IP}',$_SERVER['REMOTE_ADDR']);
       
      // Send to webmaster..
      $MUP_MAIL->sendMail($SETTINGS->webname,
                          $SETTINGS->email,
                          $SETTINGS->webname,
                          $SETTINGS->email,
                          '['.$SETTINGS->webname.'] '.cleanEvilTags($_POST['subject'],true),
                          $MUP_MAIL->template('templates/email/contact_message.txt')
                          );
       
      // Send auto responder..
      $MUP_MAIL->sendMail($_POST['name'],
                          $_POST['email'],
                          $SETTINGS->webname,
                          $SETTINGS->email,
                          '['.$SETTINGS->webname.'] re:'.cleanEvilTags($_POST['subject'],true),
                          $MUP_MAIL->template('templates/email/contact_auto.txt')
                          );
                           
      $SENT = true;                    
    }
  }
   
  $page_title_data = $msg_contact2;

  include(FOLDER_PATH.'inc/header.php');
            
  $tpl_contact =& new Savant2();
  $tpl_contact->assign('CONTACT_MESSAGE', (isset($SENT) ? $msg_contact8 : $msg_contact));
  $tpl_contact->assign('FORM_TEXT', (isset($SENT) ? $msg_contact13 : $msg_contact2));
  $tpl_contact->assign('FORM_DISPLAY', (isset($SENT) ? ' style="display:none"' : ''));
  $tpl_contact->assign('NAME_TEXT', $msg_contact9);
  $tpl_contact->assign('EMAIL_TEXT', $msg_contact10);
  $tpl_contact->assign('SUBJECT_TEXT', $msg_contact3);
  $tpl_contact->assign('COMMENT_TEXT', $msg_contact4);
  $tpl_contact->assign('NAME_VALUE', (isset($_POST['name']) ? cleanData($_POST['name']) : ''));
  $tpl_contact->assign('EMAIL_VALUE', (isset($_POST['email']) ? cleanData($_POST['email']) : ''));
  $tpl_contact->assign('SUBJECT_VALUE', (isset($_POST['subject']) ? cleanData($_POST['subject']) : ''));
  $tpl_contact->assign('COMMENT_VALUE', (isset($_POST['comments']) ? cleanData($_POST['comments']) : ''));
  $tpl_contact->assign('CAPTCHA',showCaptcha($msg_contact11,(isset($SUM_ERROR) ? '<br /><span class="error">'.$msg_contact12.'</span>' : '')));
  $tpl_contact->assign('N_ERROR', (isset($N_ERROR) ? '<br /><span class="error">'.$msg_usercreate17.'</span>' : ''));
  $tpl_contact->assign('E_ERROR', (isset($E_ERROR) ? '<br /><span class="error">'.$msg_usercreate6.'</span>' : ''));
  $tpl_contact->assign('S_ERROR', (isset($S_ERROR) ? '<br /><span class="error">'.$msg_contact6.'</span>' : ''));
  $tpl_contact->assign('C_ERROR', (isset($C_ERROR) ? '<br /><span class="error">'.$msg_contact7.'</span>' : ''));
  $tpl_contact->assign('SEND_TEXT', $msg_contact5);
  $tpl_contact->display('templates/contact.tpl.php');

  include(FOLDER_PATH.'inc/footer.php');
  break;
      
  //===================
  // CASE: BANNERS
  //===================

  case "banners":
      
  if (!isset($MEMBER_INFO->id)) {
    header("Location: index.php");
    exit;
  }
      
  if (isset($_GET['track']))
  {
    $q_banners = mysql_query("SELECT b_url FROM ".$database['prefix']."banners 
                              WHERE id = '".$_GET['track']."' 
                              LIMIT 1") or die(mysql_error());
    $BANNER = mysql_fetch_object($q_banners);
           
    mysql_query("UPDATE ".$database['prefix']."members SET 
                 bannerclicks    = (bannerclicks+1) 
                 WHERE username  = '".$MEMBER_INFO->username."' 
                 AND email       = '".$MEMBER_INFO->email."' 
                 LIMIT 1") or die(mysql_error());
                 
    mysql_query("UPDATE ".$database['prefix']."banners SET 
                 b_clicks = (b_clicks+1) 
                 WHERE id = '".$_GET['track']."' 
                 LIMIT 1
                 ") or die(mysql_error());

    header("Location: $BANNER->b_url");
    exit;
  }

  break;

  //===================
  // CASE: NEWS
  //===================

  case "news":
      
  $news_block = '';
  
  if (!isset($MEMBER_INFO->id)) {
    header("Location: index.php");
    exit;
  }
  
  // Reset read pointer..
  if (isset($_GET['read'])) {
    mysql_query("DELETE FROM ".$database['prefix']."readnews
                 WHERE news_code  = '".$_GET['read']."'
                 AND member       = '".$MEMBER_INFO->id."'
                 ") or die(mysql_error());    
                 
    // Has all news been cleared?
    $q_check = mysql_query("SELECT * FROM ".$database['prefix']."readnews
                            WHERE member = '".$MEMBER_INFO->id."' 
                            LIMIT 1") or die(mysql_error());
    
    if (mysql_num_rows($q_check)==0)
    {
      mysql_query("UPDATE ".$database['prefix']."members SET 
                   news      = '0'
                   WHERE id  = '".$MEMBER_INFO->id."'
                   LIMIT 1
                   ") or die(mysql_error());
    }                             
   
    header("Location: index.php?cmd=news");
    exit;
  }
  
  // Get count..
  $q_count = mysql_query("SELECT count(*) AS n_count FROM ".$database['prefix']."news 
                          WHERE news_type  = 'all' 
                          OR (news_type    = '".$MEMBER_INFO->accid."') 
                          OR (news_type    = 'acc".$MEMBER_INFO->id."')
                          ") or die(mysql_error());
  $COUNT = mysql_fetch_object($q_count);                       
      
  // Get announcements if there are any..
  $q_news = mysql_query("SELECT *,UNIX_TIMESTAMP(news_date) as n_date FROM ".$database['prefix']."news 
                         WHERE news_type  = 'all' 
                         OR (news_type    = '".$MEMBER_INFO->accid."') 
                         OR (news_type    = 'acc".$MEMBER_INFO->id."')
                         ORDER BY news_date
                         LIMIT $limitvalue, $SETTINGS->data_per_page
                         ") or die(mysql_error());

  if (mysql_num_rows($q_news)>0)
  {
    while ($NEWS = mysql_fetch_object($q_news))
    {
      $find     = array('{title}','{message}','{posted}','{post_date}','{mark_as_read}');
      $replace  = array(cleanData($NEWS->news_title),nl2br(cleanData($NEWS->news_comments)),$msg_newstpl5,date($SETTINGS->dateformat, $NEWS->n_date),(isNewsRead($NEWS->news_code) ? '[ <a href="index.php?cmd=news&amp;read='.$NEWS->news_code.'" title="'.$msg_newstpl4.'">'.$msg_newstpl4.'</a> ]' : ''));
    
      $news_block .= str_replace($find,$replace,
                                 file_get_contents(FOLDER_PATH.'templates/tpl_files/announcement.tpl')
                                 );
    }
  } else {
  
    $news_block = str_replace('{message}',$msg_newstpl3,
                              file_get_contents(FOLDER_PATH.'templates/tpl_files/general_message.tpl')
                              ); 
  }  
      
  $page_title_data = $msg_newstpl2;

  include(FOLDER_PATH.'inc/header.php');

  $tpl_news =& new Savant2();
  $tpl_news->assign('NEWSMESSAGE', $msg_newstpl);
  $tpl_news->assign('NEWSTEXT', $msg_newstpl2);
  $tpl_news->assign('ANNOUNCEMENTS', $news_block);
  $tpl_news->assign('PAGENUMBERS', ($COUNT->n_count>0 ? page_numbers($COUNT->n_count,$SETTINGS->data_per_page,$page) : ''));
  $tpl_news->display('templates/news.tpl.php');

  include(FOLDER_PATH.'inc/footer.php');
  break;
      
  //============================================
  // CASE: PROCESS
  // Updated in v4.0 to include subscriptions
  //============================================

  case "process":
  
  $MUP_IPN               = new paypalIPN($_POST,$SETTINGS);
  $MUP_IPN->error_email  = $SETTINGS->email;
  $MUP_IPN->prefix       = $database['prefix'];

  // Get paypal response..
  $MUP_IPN->send_response();
  
  //-------------------------------------
  // Explode custom field:
  //
  // $DATA[0] = Username
  // $DATA[1] = Unicode
  // $DATA[2] = Password
  // $DATA[3] = Is subscription?
  // $DATA[4] = Identifier
  //-------------------------------------

  $DATA = explode("-", $_POST['custom']);
  $var  = '';

  // Validate response from Paypal website..
  if(!$MUP_IPN->is_verified()) {
    $MUP_IPN->error_out($msg_ipn,$msg_ipn2,$msg_ipn3,$msg_ipn4,$MUP_IPN->char_back(cleanData($SETTINGS->webname)),$SETTINGS->paypal_error);
  }
  
  // Check call isn`t coming from another script..
  if (!strstr($_POST['custom'],'mswuploader')) {
    exit;
  }
    
  // Get account data..
  $ACC = $MUP_ACC->acc_data('',$DATA[0]);
  
  // Get account type..
  $TYPE = accountType($ACC->accid);
  
  // Assign var for billing time..
  if ($TYPE->subscription) {
    switch($TYPE->billing_time) {
      case 'day':   $var = $msg_acctypes46; break;
      case 'week':  $var = $msg_acctypes53; break;
      case 'month': $var = $msg_acctypes47; break;
      case 'year':  $var = $msg_acctypes48; break;
    }
  }
  
  // Mail vars..
  $MUP_MAIL->addTag('{USERNAME}', $DATA[0]);
  $MUP_MAIL->addTag('{TYPE}', $TYPE->accname);
  $MUP_MAIL->addTag('{COST}', $TYPE->cost);
  $MUP_MAIL->addTag('{PASSWORD}', $DATA[2]);
  $MUP_MAIL->addTag('{EMAIL}', $ACC->email);
  $MUP_MAIL->addTag('{OTHER_INFO}', ($MUP_CREATE->otherData($ACC) ? $MUP_CREATE->otherData($ACC) : 'N/A'));
  $MUP_MAIL->addTag('{DATE}', date($SETTINGS->dateformat, strtotime(($SETTINGS->time_offset=='0' ? "+0 hours" : $SETTINGS->time_offset))));
  $MUP_MAIL->addTag('{EXPIRY_DATE}', $ACC->exp_date);
  $MUP_MAIL->addTag('{DIR_NAME}', $ACC->accfolder);
  $MUP_MAIL->addTag('{ACC_STATUS}', (is_dir($SETTINGS->uploaddir.'/'.$ACC->accfolder) && $SETTINGS->setuptype ? $msg_usercreate7 : $msg_usercreate11));
  $MUP_MAIL->addTag('{DIR_STATUS}', (is_dir($SETTINGS->uploaddir.'/'.$ACC->accfolder) ? $msg_script5 : $msg_script6));
  $MUP_MAIL->addTag('{RECURRING}',($TYPE->subscription ? $msg_script19.' '.$TYPE->billing_no.' '.$var : $msg_script6));    
  $MUP_MAIL->addTag('{TXN_ID}',(isset($_POST['subscr_id']) ? $_POST['subscr_id'] : $_POST['txn_id']));
  $MUP_MAIL->addTag('{PAYPAL_STATUS}', (isset($_POST['payment_status']) ? $MUP_IPN->get_payment_status() : $msg_ipn11));
  
  // Is this a subscription based payment? 
  // If it is, additional processing is required for the txn_type var value.. 
  if ($TYPE->subscription) {
    switch ($_POST['txn_type']) {
      case 'subscr_payment':
      
      // Activate/Update subscription..
      if ($ACC->subscr_access) {
        $MUP_IPN->update_subscription($ACC,$TYPE);
      } else {
        $MUP_IPN->activate_subscription($_POST,$ACC,$TYPE);
      }
      
      exit;
      break;
      
      case 'subscr_cancel':
      
      // Cancel subscription..
      $MUP_IPN->cancel_subscription($ACC);
      
      // Send mail to member..
      $MUP_MAIL->sendMail($ACC->username,
                          $ACC->email,
                          $SETTINGS->webname,
                          $SETTINGS->email,
                          '['.$SETTINGS->webname.'] '.$msg_usercreate24,
                          $MUP_MAIL->template('templates/email/subscription_cancelled.txt')
                          );
                          
      // Send mail to webmaster..
      $MUP_MAIL->sendMail($SETTINGS->webname,
                          $SETTINGS->email,
                          $SETTINGS->webname,
                          $SETTINGS->email,
                          '['.$SETTINGS->webname.'] '.$msg_usercreate24,
                          $MUP_MAIL->template('templates/email/subscription_cancelled_webmaster.txt')
                          );                    
      
      exit;
      break;
      
      case 'subscr_failed':
      $MUP_IPN->error_out($msg_ipn10.': '.$MUP_IPN->get_payment_status(),$msg_ipn2,$msg_ipn3,$msg_ipn4,$MUP_IPN->char_back(cleanData($SETTINGS->webname)),$SETTINGS->paypal_error);
	    break;
	    
	    case 'subscr_signup':
	    break;
      
      default:
      exit;
      break;
    }
  }
  
  if (isset($_POST['payment_status']))
  {
    switch ($MUP_IPN->get_payment_status())
    {
      case 'Completed':
      break;

	    case 'Pending':
	  
	    // Send mail..
      $MUP_MAIL->sendMail($DATA[0],
                          $ACC->email,
                          $SETTINGS->webname,
                          $SETTINGS->email,
                          '['.$SETTINGS->webname.'] '.$msg_usercreate24,
                          $MUP_MAIL->template('templates/email/pending_paypal.txt')
                          );

      exit;

	    break;

	    case 'Failed':
	    $MUP_IPN->error_out($msg_ipn5,$msg_ipn2,$msg_ipn3,$msg_ipn4,$MUP_IPN->char_back(cleanData($SETTINGS->webname)),$SETTINGS->paypal_error);
      break;

	    case 'Denied':
	    $MUP_IPN->error_out($msg_ipn6,$msg_ipn2,$msg_ipn3,$msg_ipn4,$MUP_IPN->char_back(cleanData($SETTINGS->webname)),$SETTINGS->paypal_error);
	    break;
	  
	    case 'Refunded':
	    break;

	    default:
	    $MUP_IPN->error_out($msg_ipn7.': '.$MUP_IPN->get_payment_status(),$msg_ipn2,$msg_ipn3,$msg_ipn4,$MUP_IPN->char_back(cleanData($SETTINGS->webname)),$SETTINGS->paypal_error);
      break;
    }
  }

  // Add paypal Info to database..
  $MUP_IPN->ipn_sql($_POST,$DATA[0],(isset($_POST['payment_status']) ? $MUP_IPN->get_payment_status() : $msg_ipn11));
  
  if (is_dir($SETTINGS->uploaddir.'/'.$ACC->accfolder) && $SETTINGS->setuptype)
  {
    // Update password and activate..
    $MUP_ACC->update_password_sql($DATA[2],$ACC->email);

    // Send mail to member..
    $MUP_MAIL->sendMail($DATA[0],
                        $ACC->email,
                        $SETTINGS->webname,
                        $SETTINGS->email,
                        '['.$SETTINGS->webname.'] '.$msg_ipn9,
                        $MUP_MAIL->template('templates/email/'.($TYPE->subscription ? 'order_paypal_subscription' : 'order_paypal').'.txt')
                        );

    // Send mail to webmaster..
    $MUP_MAIL->sendMail($SETTINGS->webname,
                        $SETTINGS->email,
                        $SETTINGS->webname,
                        $SETTINGS->email,
                        '['.$SETTINGS->webname.'] '.$msg_ipn8,
                        $MUP_MAIL->template('templates/email/account_active_paypal.txt')
                        );

    exit;
  }
  else
  {
    // Send mail..
    $MUP_MAIL->sendMail($DATA[0],
                        $ACC->email,
                        $SETTINGS->webname,
                        $SETTINGS->email,
                        '['.$SETTINGS->webname.'] '.$msg_usercreate24,
                        $MUP_MAIL->template('templates/email/pending.txt')
                        );      
                        
    // Send mail to webmaster..
    $MUP_MAIL->sendMail($SETTINGS->webname,
                        $SETTINGS->email,
                        $SETTINGS->webname,
                        $SETTINGS->email,
                        '['.$SETTINGS->webname.'] '.$msg_ipn9,
                        $MUP_MAIL->template('templates/email/account_active_paypal.txt')
                        );                    
                         
    exit;
  }
  
  break;
      
  //===================
  // CASE: CREATE
  //===================

  case "create":
      
  // Has signup been disabled..
  if (!$SETTINGS->enable) {
    header("Location: ".($SETTINGS->url_signup ? $SETTINGS->url_signup : 'index.php?cmd=no_signup')."");
  }
      
  if (isset($_POST['process_create']))
  {
    if ($MUP_CREATE->does_account_exist((isset($ULI_COOKIE) ? $ULI_COOKIE : '')) 
        && !$SETTINGS->sameip) 
    {
      $IP_ERROR = str_replace("{ip}",$_SERVER['REMOTE_ADDR'],$msg_usercreate13);
      $count++;
    }
    else
    {
      if ($MUP_CREATE->field_check(0,0,$_POST['package'])) {
        $P_ERROR = $msg_usercreate10;
        $count++;
      }
      if ($MUP_CREATE->field_check(5,15,$_POST['user_name']) || $MUP_CREATE->is_alpha($_POST['user_name'],15)) {
        $N_ERROR = $msg_usercreate8;
        $count++;
      }
      if (!isset($N_ERROR) && $MUP_CREATE->is_user_unique($_POST['user_name'])) {
        $N_ERROR = $msg_usercreate14;
        $count++;
      }
      if ($MUP_CREATE->is_email_unique($_POST['user_email'])) {
        $E_ERROR = $msg_usercreate15;
        $count++;
      }
      if (!isset($E_ERROR) && $MUP_CREATE->is_email_valid($_POST['user_email'])) {
        $E_ERROR = $msg_usercreate6;
        $count++;
      }
      if (!isset($_POST['terms'])) {
        $T_ERROR = $msg_usercreate32;
        $count++;
      }
      if (!PhpCaptcha::Validate($_POST['code']) && $SETTINGS->captcha_code) {
        $SUM_ERROR = $msg_usercreate28;
        $count++;
      }
      if (isset($_POST['company'])) {
        if ($MUP_CREATE->isFieldRequired('company_required',$_POST['company'])) {
          $count++;
        }
      }  
      if (isset($_POST['name'])) {  
        if ($MUP_CREATE->isFieldRequired('name_required',$_POST['name'])) {
          $count++;
        }
      }
      if (isset($_POST['address'])) {  
        if ($MUP_CREATE->isFieldRequired('address_required',$_POST['address'])) {
          $count++;
        }
      }  
      if (isset($_POST['tel'])) {
        if ($MUP_CREATE->isFieldRequired('tel_required',$_POST['tel'])) {
          $count++;
        }
      }
      if (isset($_POST['fax'])) {  
        if ($MUP_CREATE->isFieldRequired('fax_required',$_POST['fax'])) {
          $count++;
        }
      }
      if (isset($_POST['mobile'])) {  
        if ($MUP_CREATE->isFieldRequired('mobile_required',$_POST['mobile'])) {
          $count++;
        }
      }
      if (isset($_POST['location'])) {  
        if ($MUP_CREATE->isFieldRequired('location_required',$_POST['location'])) {
          $count++;
        }
      } 
      if ($count==0)
      {
        // Pass a few defaults to class..
        $UNIQUEID          = $MUP_CREATE->random_data(20,'unicode');
        $MUP_CREATE->code  = $UNIQUEID;
        $MUP_CREATE->date  = date($SETTINGS->dateformat, strtotime(($SETTINGS->time_offset=='0' ? "+0 hours" : $SETTINGS->time_offset)));
    
        // Generate random password..
        $password          = $MUP_CREATE->random_data(8,'pass');
        
        // Load account type data into array..
        $TYPE = accountType($_POST['package']);
                           
        // Get Folder Name..
        $folder            = $MUP_CREATE->setup_folder($TYPE,$_POST['user_name']);
        
        // Default mail vars used by processing..
        $MUP_MAIL->addTag('{USERNAME}', $_POST['user_name']);
        $MUP_MAIL->addTag('{TYPE}', $TYPE->accname);
        $MUP_MAIL->addTag('{DATE}', date($SETTINGS->dateformat, strtotime(($SETTINGS->time_offset=='0' ? "+0 hours" : $SETTINGS->time_offset))));
        $MUP_MAIL->addTag('{VERIFICATION_LINK}', 'index.php?cmd=verify&code='.$UNIQUEID);
        
        //--------------------------------------------------------
        // No errors so far, so now decide which mode we are in
        // Mode 1: Automatic Setup/Paypal
        // Mode 2: Manual Setup
        // Mode 3: Automatic Setup/No Paypal
        //--------------------------------------------------------
                          
        switch ($SETTINGS->setuptype)
        {
          //-------------------------------------------------------
          // Mode 1 & Mode 3. 
          // Paypal overwrites automatic mode
          // If directories cannot be created, enforce manual mode
          //--------------------------------------------------------

          case '1':

          if ($SETTINGS->paypal_ipn && $TYPE->cost > 0)
          {
            // Assign User Paypal Field Data..
            // Add different vars if subscription based..
            // Updated in v4.0..
                                    
            $MUP_IPN->add_field('rm', '2');
            $MUP_IPN->add_field('cmd', ($TYPE->subscription ? '_xclick-subscriptions' : '_xclick'));
            $MUP_IPN->add_field('business', $SETTINGS->paypal_email);
            $MUP_IPN->add_field('item_name', cleanData($TYPE->accname));
            $MUP_IPN->add_field('item_number', $TYPE->itemcode);
            $MUP_IPN->add_field('notify_url', 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'].'?cmd=process');
            $MUP_IPN->add_field('cancel_return', ($SETTINGS->url_ppcancel ? $SETTINGS->url_ppcancel : 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'].'?cmd=paypal_cancel'));
            $MUP_IPN->add_field('return', ($SETTINGS->url_ppthanks ? $SETTINGS->url_ppthanks : 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'].'?cmd=paypal_thanks'));
            $MUP_IPN->add_field('no_shipping', 1);
            $MUP_IPN->add_field('currency_code', $TYPE->currency);
            $MUP_IPN->add_field('custom', $_POST['user_name'].'-'.$UNIQUEID.'-'.$password.'-'.$TYPE->subscription.'-mswuploader');
            
            // Pass additional subscription vars if required..
            if ($TYPE->subscription) {
              $MUP_IPN->add_field('a3',$TYPE->cost);
              $MUP_IPN->add_field('p3',$TYPE->billing_no);
              $MUP_IPN->add_field('t3',strtoupper(substr($TYPE->billing_time,0,1)));
              $MUP_IPN->add_field('src',1);
              $MUP_IPN->add_field('sra',1);
            } else {
              $MUP_IPN->add_field('amount', $TYPE->cost);
            }

            // Log data in database..
            $MUP_CREATE->add_account_sql($TYPE,0,$folder,$_POST,$password);
                                    
            // Attempt to create directory..
            // Add index file to directory if enabled..
            if ($MUP_CREATE->create_folder($SETTINGS->uploaddir,$folder))
            {
              $MUP_CREATE->create_index($SETTINGS->autoindex,$SETTINGS->uploaddir,$msg_manage26,$folder);
            }
                                    
            // Show processing screen and redirect to Paypal/Sandbox..
            // At this point we terminate the script until Paypal responds..
            // No e-mails sent so far..
            $page_title_data  = $msg_usercreate23;
            $PROCESS          = true;
      
            include(FOLDER_PATH.'inc/header.php');

            $tpl_paypal =& new Savant2();
            $tpl_paypal->assign('PROCESSING', $msg_usercreate23);
            $tpl_paypal->assign('PLEASE_WAIT', $msg_usercreate30);
            $tpl_paypal->assign('ACTION', $SETTINGS->paypal_test ? 'https://www.sandbox.paypal.com/cgi-bin/webscr?' : 'https://www.paypal.com/cgi-bin/webscr?');
            $tpl_paypal->assign('HIDDEN_VARS',$MUP_IPN->loadHiddenFields());
            $tpl_paypal->display('templates/paypal_process.tpl.php');

            include(FOLDER_PATH.'inc/footer.php');
                                    
            exit;
          }
          else
          {
            // If directory has been created and is writeable activate account..
            // Otherwise log data, but account status is pending..
            if ($MUP_CREATE->create_folder($SETTINGS->uploaddir,$folder))
            {
              // Log data in database..
              $MUP_CREATE->add_account_sql($TYPE,0,$folder,$_POST,$password);
                                         
              // Add index file if enabled..
              $MUP_CREATE->create_index($SETTINGS->autoindex,$SETTINGS->uploaddir,$msg_manage26,$folder);
                                         
              // Send mail..
              $MUP_MAIL->sendMail($_POST['user_name'],
                                  $_POST['user_email'],
                                  $SETTINGS->webname,
                                  $SETTINGS->email,
                                  '['.$SETTINGS->webname.'] '.$msg_usercreate25,
                                  $MUP_MAIL->template('templates/email/verification.txt')
                                  );
                                                             
              // Show page..
              header("Location: ".($SETTINGS->url_accthanks ? $SETTINGS->url_accthanks : 'index.php?cmd=acc_thanks')."");
            }
            else
            {
              // Log data in database..
              $MUP_CREATE->add_account_sql($TYPE,0,$folder,$_POST,$password);
              
              // Send mail..
              $MUP_MAIL->sendMail($_POST['user_name'],
                                  $_POST['user_email'],
                                  $SETTINGS->webname,
                                  $SETTINGS->email,
                                  '['.$SETTINGS->webname.'] '.$msg_usercreate24,
                                  $MUP_MAIL->template('templates/email/pending.txt')
                                  );
                                         
              // Show page..
              header("Location: ".($SETTINGS->url_accpending ? $SETTINGS->url_accpending : 'index.php?cmd=acc_pending')."");
            }
          }
                               
          break;
                               
          case '0':                               
          
          // Log data in database..
          $MUP_CREATE->add_account_sql($TYPE,0,$folder,$_POST,$password);
          
          // Send mail..
          $MUP_MAIL->sendMail($_POST['user_name'],
                              $_POST['user_email'],
                              $SETTINGS->webname,
                              $SETTINGS->email,
                              '['.$SETTINGS->webname.'] '.$msg_usercreate24,
                              $MUP_MAIL->template('templates/email/pending.txt')
                              );
                                         
          // Show page..
          header("Location: ".($SETTINGS->url_accpending ? $SETTINGS->url_accpending : 'index.php?cmd=acc_pending')."");

          break;
        }
      }
    }
  }
      
  // Get Account Types..
  $query_types = mysql_query("SELECT * FROM ".$database['prefix']."acctypes 
                              ORDER BY accname
                              ") or die(mysql_error());
      
  $packages = '';

  while ($TYPES = mysql_fetch_object($query_types)) {
    
    switch($TYPES->billing_time) {
      case 'day':   $var = $msg_acctypes46; break;
      case 'week':  $var = $msg_acctypes53; break;
      case 'month': $var = $msg_acctypes47; break;
      case 'year':  $var = $msg_acctypes48; break;
    }
    
    $packages .= '<option'.(isset($_POST['package']) && $_POST['package']==$TYPES->id ? ' selected ' : ' ').'value="'.$TYPES->id.'">'.cleanData($TYPES->accname).' - '.($TYPES->cost>0 ? curSymbol($TYPES->currency).$TYPES->cost.' - '.($TYPES->subscription ? $TYPES->billing_no.' '.$var.' '.$msg_usercreate33 : $msg_usercreate29) : $msg_usercreate3).'</option>'."\n";
  }

  $page_title_data = $msg_usercreate2;
      
  include(FOLDER_PATH.'inc/header.php');

  $tpl_create =& new Savant2();
  $tpl_create->assign('MESSAGE', $msg_usercreate);
  $tpl_create->assign('IP_MATCH',(isset($IP_ERROR) ? '<span class="error">'.$IP_ERROR.'</span><br /><br />' : ''));
  $tpl_create->assign('TEXT', $msg_usercreate2);
  $tpl_create->assign('PACKAGETEXT', $msg_usercreate12);
  $tpl_create->assign('PLEASESELECT', $msg_header32.'...');
  $tpl_create->assign('PACKAGES', $packages);
  $tpl_create->assign('P_ERROR',(isset($P_ERROR) ? '<br /><span class="error">'.$P_ERROR.'</span>' : ''));
  $tpl_create->assign('N_ERROR',(isset($N_ERROR) ? '<br /><span class="error">'.$N_ERROR.'</span>' : ''));
  $tpl_create->assign('E_ERROR',(isset($E_ERROR) ? '<br /><span class="error">'.$E_ERROR.'</span>' : ''));
  $tpl_create->assign('USERTEXT', $msg_home4);
  $tpl_create->assign('EMAILTEXT', $msg_contact10);
  $tpl_create->assign('OTHERFIELDS', otherFieldDisplay(($count>0 ? $_POST : ''),(isset($IP_ERROR) ? true : false)));
  $tpl_create->assign('NAMEVALUE', (isset($_POST['user_name']) ? cleanData($_POST['user_name']) : ''));
  $tpl_create->assign('EMAILVALUE', (isset($_POST['user_email']) ? $_POST['user_email'] : ''));
  $tpl_create->assign('SIGNUP', $msg_usercreate3);
  $tpl_create->assign('NAMEALPHADATA', $msg_usercreate9);
  $tpl_create->assign('TERMSTEXT',$msg_usercreate31);
  $tpl_create->assign('TERMSVALUE', (isset($_POST['terms']) ? 'checked="checked"' : ''));
  $tpl_create->assign('T_ERROR', (isset($T_ERROR) ? '<br /><span class="error">'.$T_ERROR.'</span>' : ''));
  $tpl_create->assign('CAPTCHA', showCaptcha($msg_contact11,(isset($SUM_ERROR) ? '<br /><span class="error">'.$msg_contact12.'</span>' : '')));
  $tpl_create->display('templates/create_account.tpl.php');

  include(FOLDER_PATH.'inc/footer.php');
  break;
      
  //===================
  // CASE: CONMEMBER
  //===================

  case "conmember":
      
  if (!isset($MEMBER_INFO->id)) {
    header("Location: index.php");
    exit;
  }
  
  // Check for news..
  isNewsLive();
      
  // Firstly, check this function is available to member..
  if (!$MEMBER_INFO->contact) {
    header("Location: index.php");
    exit;
  }

  // Contact Member..
  if (isset($_POST['process']))
  {
    // Apply call back element to trim post vars..
    $_POST = array_map('trim',$_POST);
    
    // If user doesn`t exist or is not alphanumeric, its invalid...redirect to homepage..
    // This check is for anyone who changed the query string..
    if (!isUserLive($_GET['user']) || !ctype_alnum($_GET['user'])) {
      header("Location: index.php");
      exit;
    }
    if ($_POST['subject']=='') {
      $S_ERROR = true;
      $count++;
    }
    if ($_POST['comments']=='') {
      $C_ERROR = true;
      $count++;
    }
    if ($count==0)
    {
      $MEM = $MUP_ACC->acc_data('',$_GET['user']);
      
      $MUP_MAIL->addTag('{NAME}', $_GET['user']);
      $MUP_MAIL->addTag('{COMMENTS}',cleanEvilTags($_POST['comments'],true));
      $MUP_MAIL->addTag('{DATE}',date("j F Y"));
      $MUP_MAIL->addTag('{MEMBER}',$MEMBER_INFO->username);
       
      // Send message..
      $MUP_MAIL->sendMail($_GET['user'],
                          $MEM->email,
                          $MEMBER_INFO->username,
                          $MEMBER_INFO->email,
                          '['.$SETTINGS->webname.'] '.cleanEvilTags($_POST['subject'],true),
                          $MUP_MAIL->template('templates/email/contact_member.txt')
                          );
                           
      $SENT = true;
    }
  }

  $page_title_data = $msg_conmember3.' ('.cleanData($_GET['user']).')';

  include(FOLDER_PATH.'inc/header.php');
            
  $tpl_conmember =& new Savant2();
  $tpl_conmember->assign('CONTACT_MESSAGE', (isset($SENT) ? str_replace("{user}",cleanData($_GET['user']),$msg_conmember2) : $msg_conmember));
  $tpl_conmember->assign('FORM_TEXT', (isset($SENT) ? $msg_conmember4 : $msg_conmember3.' - <span class="admin_files">'.cleanData($_GET['user']).'</span>'));
  $tpl_conmember->assign('FORM_DISPLAY', (isset($SENT) ? ' style="display:none"' : ''));
  $tpl_conmember->assign('USER', cleanData($_GET['user']));
  $tpl_conmember->assign('SUBJECT_TEXT', $msg_contact3);
  $tpl_conmember->assign('COMMENT_TEXT', $msg_contact4);
  $tpl_conmember->assign('SUBJECT_VALUE', (isset($_POST['subject']) ? cleanData($_POST['subject']) : ''));
  $tpl_conmember->assign('COMMENT_VALUE', (isset($_POST['comments']) ? cleanData($_POST['comments']) : ''));
  $tpl_conmember->assign('S_ERROR', (isset($S_ERROR) ? '<br /><span class="error">'.$msg_contact6.'</span>' : ''));
  $tpl_conmember->assign('C_ERROR', (isset($C_ERROR) ? '<br /><span class="error">'.$msg_contact7.'</span>' : ''));
  $tpl_conmember->assign('SEND_TEXT', $msg_contact5);
  $tpl_conmember->assign('CANCEL', $msg_script41);
  $tpl_conmember->display('templates/conmember.tpl.php');

  include(FOLDER_PATH.'inc/footer.php');
  break;

  //===================
  // CASE: LOGOUT
  //===================

  case "logout":
      
  $MUP_ACC->kill_session();
  header("Location: index.php");
  
  break;
      
  //===================
  // CASE: VERIFY
  //===================

  case "verify":
      
  if (isset($_GET['code']) && !ctype_alnum($_GET['code'])) {
    header("Location: index.php");
    exit;
  }
  
  $query = mysql_query("SELECT * FROM ".$database['prefix']."members 
                            WHERE unicode  = '".$_GET['code']."' 
                            AND activate   = '0' 
                            LIMIT 1
                            ") or die(mysql_error());
  $ACC = mysql_fetch_object($query);
      
  if (mysql_num_rows($query)>0)
  {
    $password = $ACC->accpass;
    $MUP_ACC->update_password_sql($ACC->accpass,$ACC->email);

    if (mysql_affected_rows()==0)
    {
      header("Location: ".($SETTINGS->url_error ? $SETTINGS->url_error : 'index.php?cmd=verify_error')."");
      exit;
    }
    else
    {
      // Get account type..
      $TYPE = accountType($ACC->accid);
      
      // Mail vars..
      $MUP_MAIL->addTag('{USERNAME}', $ACC->username);
      $MUP_MAIL->addTag('{TYPE}', $TYPE->accname);
      $MUP_MAIL->addTag('{PASSWORD}', $password);
      $MUP_MAIL->addTag('{EMAIL}', $ACC->email);
      $MUP_MAIL->addTag('{OTHER_INFO}', ($MUP_CREATE->otherData($ACC) ? $MUP_CREATE->otherData($ACC) : 'N/A'));
      $MUP_MAIL->addTag('{DATE}', date($SETTINGS->dateformat, strtotime(($SETTINGS->time_offset=='0' ? "+0 hours" : $SETTINGS->time_offset))));
      $MUP_MAIL->addTag('{DIR_NAME}', $ACC->accfolder);
      $MUP_MAIL->addTag('{ACC_STATUS}', (file_exists($SETTINGS->uploaddir.'/'.$ACC->accfolder) && $SETTINGS->setuptype ? $msg_usercreate7 : $msg_usercreate11));
      $MUP_MAIL->addTag('{DIR_STATUS}', (file_exists($SETTINGS->uploaddir.'/'.$ACC->accfolder) ? $msg_script5 : $msg_script6));
      
      // Send message to member..
      $MUP_MAIL->sendMail($ACC->username,
                          $ACC->email,
                          $SETTINGS->webname,
                          $SETTINGS->email,
                          '['.$SETTINGS->webname.'] '.$msg_ipn9,
                          $MUP_MAIL->template('templates/email/welcome.txt')
                          );
                          
      // Send message to webmaster..
      $MUP_MAIL->sendMail($SETTINGS->webname,
                          $SETTINGS->email,
                          $SETTINGS->webname,
                          $SETTINGS->email,
                          '['.$SETTINGS->webname.'] '.$msg_ipn8,
                          $MUP_MAIL->template('templates/email/account_active.txt')
                          );                    
      
      // Set cookie..
      setcookie("uploader_ip_cookie", $ACC->ip, time()+60*60*24*365);
                
      header("Location: ".($SETTINGS->url_success ? $SETTINGS->url_success : 'index.php?cmd=verify_success')."");
      exit;
    }
  }  
  else
  {
    header("Location: ".($SETTINGS->url_error ? $SETTINGS->url_error : 'index.php?cmd=verify_error')."");
    exit;
  }

  break;
      
  //=====================
  // CASE: NEW PASSWORD
  //=====================
      
  case "newpass":
      
  if (isset($_POST['process']))
  {
    // Apply call back element to trim post vars..
    $_POST = array_map('trim',$_POST);   
        
    if (!eregi("^([a-z]|[0-9]|\.|-|_)+@([a-z]|[0-9]|\.|-|_)+\.([a-z]|[0-9]){2,4}$", $_POST['email'])) {
      $E_ERROR = $msg_usercreate6;
      $count++;
    } else {
      if (!isset($E_ERROR) && !$MUP_ACC->acc_data($_POST['email'])) {
        $E_ERROR = $msg_newpass4;
        $count++;
      }
    }
    if ($SETTINGS->captcha_code && isset($_POST['code']))
    {
      if (!PhpCaptcha::Validate($_POST['code'])) {
       $SUM_ERROR = true;
       $count++;
      }
    }
    if ($count==0)    
    {
      // Generate new password..
      $N_PASS = $MUP_ACC->random_data(8,'unicode');
      
      // Get account info..
      $ACC    = $MUP_ACC->acc_data($_POST['email']);
      
      // Update password..
      $MUP_ACC->update_password_sql($N_PASS,$_POST['email']);
      
      // Send mail..
      $MUP_MAIL->addTag('{USERNAME}',$ACC->username);
      $MUP_MAIL->addTag('{PASSWORD}',$N_PASS);

      $MUP_MAIL->sendMail($ACC->username,
                          $_POST['email'],
                          $SETTINGS->webname,
                          $SETTINGS->email,
                          '['.$SETTINGS->webname.'] '.$msg_newpass5,
                          $MUP_MAIL->template('templates/email/new_password.txt')
                          );
                          
      $SENT = true;                    
    }
  }
      
  $page_title_data = $msg_newpass2;
      
  include(FOLDER_PATH.'inc/header.php');

  $tpl_newpass =& new Savant2();
  $tpl_newpass->assign('PASSWORDMESSAGE', (isset($SENT) ? str_replace("{email}",$_POST['email'],$msg_newpass6) : $msg_newpass));
  $tpl_newpass->assign('PASSTEXT', (isset($SENT) ? $msg_newpass7 : $msg_newpass2));
  $tpl_newpass->assign('EMAILVALUE', (isset($_POST['email']) ? $_POST['email'] : ''));
  $tpl_newpass->assign('EMAIL_ADDRESS', $msg_newpass3);
  $tpl_newpass->assign('FORM_DISPLAY', (isset($SENT) ? ' style="display:none"' : ''));
  $tpl_newpass->assign('E_ERROR',(isset($E_ERROR) ? '<br /><span class="error">'.$E_ERROR.'</span>' : ''));
  $tpl_newpass->assign('SHOW_CAPTCHA', showCaptcha($msg_contact11,(isset($SUM_ERROR) ? '<br /><span class="error">'.$msg_contact12.'</span>' : '')));
  $tpl_newpass->display('templates/new_pass.tpl.php');

  include(FOLDER_PATH.'inc/footer.php');

  break;
  
  //==========================
  // Case : Terms
  // Added in v4.0
  //==========================
  
  case 'terms':
  
  $page_title_data = $msg_header48;
      
  include(FOLDER_PATH.'inc/header.php');

  $tpl_terms =& new Savant2();
  $tpl_terms->assign('TERMS', $msg_header48);
  $tpl_terms->assign('TERMSTEXT', nl2br(cleanData($SETTINGS->terms)));
  $tpl_terms->display('templates/terms.tpl.php');

  include(FOLDER_PATH.'inc/footer.php');
  
  break;
      
  //==================
  // Case : Captcha
  //==================
   
  case 'captcha':
  
  $MWC = new PhpCaptcha();
  $MWC->Create();
  
  break;
   
  //==================
  // Case : Watermark
  //==================
   
  case 'watermark':
   
  if (isset($_GET['file']) && !ctype_alnum($_GET['file'])) { exit; }
   
  $FILE                    = loadFileDataToString($_GET['file'],'',''); 
   
  $MUP_WMK->waterMarkText  = $MUP_WMK->char_back($MUP_WMK->strip_slashes($SETTINGS->watertext));
  $MUP_WMK->imagePath      = $SETTINGS->uploaddir.'/'.$FILE->folder_name.'/'.$FILE->upload_name;
  $MUP_WMK->font           = 'classes/fonts/'.$SETTINGS->waterfont.'.ttf';
  $MUP_WMK->size           = $SETTINGS->watersize;
  $MUP_WMK->red            = $SETTINGS->watertextr;
  $MUP_WMK->green          = $SETTINGS->watertextg;
  $MUP_WMK->blue           = $SETTINGS->watertextb;
  $MUP_WMK->hSpacing       = $SETTINGS->waterhspace;
  $MUP_WMK->vSpacing       = $SETTINGS->watervspace;
  $MUP_WMK->angle          = $SETTINGS->waterangle;

  header("Content-type: ".$FILE->file_type."");
                
  $MUP_WMK->mark();

  echo $MUP_WMK->imageResource;
  break;
  
  //==========================
  // Case: Default Redirects
  // Added in v4.0
  //==========================
  
  case 'ip_banned':
  case 'banned':
  case 'no_entry':
  case 'no_signup';
  case 'acc_thanks';
  case 'acc_pending';
  case 'verify_error';
  case 'verify_success':
  case 'paypal_cancel':
  case 'paypal_thanks':
  case 'subscription_expired':
  
  // Load data based on cmd variable..
  switch ($cmd) {
    case 'ip_banned': 
     $title  = $msg_redirect;
     $text   = $msg_redirect2;
     break;
    case 'banned':
     $title  = $msg_redirect3;
     $text   = $msg_redirect4;
     break;
    case 'no_entry':  
     $title  = $msg_redirect13;
     $text   = $msg_redirect14;
     break;
    case 'no_signup'; 
     $title  = $msg_redirect19;
     $text   = $msg_redirect20;
     break;
    case 'acc_thanks';
     $title  = $msg_redirect7;
     $text   = $msg_redirect8;
     break;
    case 'acc_pending';
     $title  = $msg_redirect5;
     $text   = $msg_redirect6;
     break;
    case 'verify_error';
     $title  = $msg_redirect9;
     $text   = $msg_redirect10;
     break;
    case 'verify_success':
     $title  = $msg_redirect11;
     $text   = $msg_redirect12;
     break;
    case 'paypal_cancel':
     // Clear account data...
     $DATA = explode("-", $_POST['custom']); 
     
     //$MUP_ACC->clear_acc_data($DATA[1],FOLDER_PATH,$SETTINGS->uploaddir);
    
     $title  = $msg_redirect15;
     $text   = $msg_redirect16;
     break;
    case 'paypal_thanks':
     $title  = $msg_redirect17;
     $text   = $msg_redirect18;
     break;  
    case 'subscription_expired':
     $title  = $msg_redirect21;
     $text   = $msg_redirect22;
     break; 
  }
  
  $page_title_data = $title;
      
  include(FOLDER_PATH.'inc/header.php');

  $tpl_redirect =& new Savant2();
  $tpl_redirect->assign('TITLE',$title);
  $tpl_redirect->assign('MESSAGE',$text);
  $tpl_redirect->display('templates/redirect.tpl.php');

  include(FOLDER_PATH.'inc/footer.php');
  
  break;
  
  

 }

?>
